/********************************************************************/
/*                                                                  */
/*    Licensed Materials - Property of IBM                          */
/*    5639-A83, 5639-A24 (C) Copyright IBM Corp. 1992,1996.         */
/*    All Rights Reserved.                                          */
/*    US Government Users Restricted Rights-- Use, duplication or   */
/*    disclosure restricted by GSA ADP Schedule Contract with       */
/*    IBM Corp.                                                     */
/*                                                                  */
/*  DISCLAIMER OF WARRANTIES                                        */
/*    The following enclosed code is sample code created by IBM   */
/*    Corporation. This sample code is not part of any standard     */
/*    IBM product and is provided to you solely for the purpose of  */
/*    assisting you in the development of your applications.  The   */
/*    code is provided "AS IS", without warranty of any kind.       */
/*    IBM shall not be liable for any damages arising out of your   */
/*    use of the sample code, even if IBM has been advised of the   */
/*    possibility of such damages.                                  */
/*                                                                  */
/*                                                                  */
/* Build ILC test of Common Data Types between PL/I and C.          */
/* The PL/I function PLICS2 dynamically loads and calls VisualAge C+*/
/* procedure PLICS2D.C to verify structure data argument passing.   */
/*                                                                  */
/*  PLICS2.PLI is compiled and linked as an EXE.                    */
/*  PLICS2D.C is compiled and linked as a DLL by the same name.     */
/*                                                                  */
/* Syntax:   BLDPLICS [p] | [c] | [b]                               */
/*             where p is for compiling the PL/I procedure          */
/*             where c is for compiling the C procedure             */
/*             where b is for compiling both procedures             */
/*                                                                  */
/********************************************************************/

parse upper arg type

 if ( type = 'C' | type = 'B' ) then     /* Compile C or both C & PL/I */
  do
   /* call cc PLICS2D.C  */
    ' icc /Q /C /Sd /Ss /Sp1 /Ge- /Ls /FlPLICS2D  PLICS2D  '
    if rc \= 0 then
      exit(1)
  end

 if ( type = 'P' | type = 'B' ) then     /* Compile P or both C & PL/I */
  do
    ' pli PLICS2    '
    if rc \= 0 then
      exit(1)
  end

  'ilink PLICS2D /packd /packc /se:200 /co /noe,PLICS2D.DLL,load.map,,PLICS2D.def'
  if rc \= 0 then
    exit(1)

  'ilink PLICS2   /pm:vio /dosseg /noe /co /stack:5000000,,load.map,hepos20i+ibmos20i,nul.def'
  if rc \= 0 then
    exit(1)

  ' set dd:sysprint=1:'
  'PLICS2   >PLICS2.run 2>&1'

  'type PLICS2.RUN '
  ' set dd:sysprint='
