                                                                                
 /********************************************************************/         
 /*                                                                  */         
 /*  PL/I Include file: DSQCOMMC.INC                                 */         
 /*                                                                  */         
 /*    This file is installed in the \IBMPLI\INCLUDE\DB22\ directory.*/         
 /*                                                                  */         
 /*                                                                  */         
 /*  NAME - DSQCOMMC.INC                                             */         
 /*                                                                  */         
 /*  DESCRIPTION                                                     */         
 /*                                                                  */         
 /*    This include file is translated into a PL/I include file,     */         
 /*    from the C header files supplied with the                     */         
 /*    IBM DATABASE 2 OS/2 CLIENT/SERVER product.                    */         
 /*    This include file is intended for use with the                */         
 /*    IBM DATABASE 2 OS/2 CLIENT/SERVER product.                    */         
 /*                                                                  */         
 /*    Defines for Callable Interface 'C'                            */         
 /*                                                                  */         
 /*    (C) Copyright IBM Corp. 1994. All Rights Reserved.            */         
 /*    US Government Users Restricted Rights-- Use, duplication or   */         
 /*    disclosure restricted by GSA ADP Schedule Contract with       */         
 /*    IBM Corp.                                                     */         
 /*                                                                  */         
 /*  Function = Defines for Callable Interface 'C'                   */         
 /*             Operating System:  OS/2 Extended Edition             */         
 /*                                                                  */         
 /*  Operating System = OS/2 Extended Edition                        */         
 /*                                                                  */         
 /*                                                                  */         
 /*  DISCLAIMER OF WARRANTIES                                        */         
 /*    The following enclosed code is sample code created by IBM   */         
 /*    Corporation. This sample code is not part of any standard     */         
 /*    IBM product and is provided to you solely for the purpose of  */         
 /*    assisting you in the development of your applications.  The   */         
 /*    code is provided "AS IS", without warranty of any kind.       */         
 /*    IBM shall not be liable for any damages arising out of your   */         
 /*    use of the sample code, even if IBM has been advised of the   */         
 /*    possibility of such damages.                                  */         
 /*                                                                  */         
 /********************************************************************/         
                                                                                
 %dcl DSQ_H_DSQCOMMC char ext;                                                  
 %if DSQ_H_DSQCOMMC = '' %then %do;                                             
                                                                                
    %DSQ_H_DSQCOMMC = 'Y';                                                      
                                                                                
                                                                                
    %dcl DSQ_API_RC char ext;                                                   
    %if DSQ_API_RC = '' %then %do;                                              
                                                                                
      %DSQ_API_RC = 'fixed bin(15)' ;                                           
                                                                                
      %dcl DSQ_API_FN char;                                                     
      %DSQ_API_FN= 'options(byvalue linkage(cdecl16) nodescriptor)';            
                                                                                
                                                                                
    %end;                                                                       
                                                                                
                                                                                
    /* Callable Interface Constants and Structures                   */         
                                                                                
    /*  return codes  */                                                        
    declare DSQ_SUCCESS fixed bin(31) value(0);                                 
    declare DSQ_WARNING fixed bin(31) value(4);                                 
    declare DSQ_FAILURE fixed bin(31) value(8);                                 
    declare DSQ_SEVERE fixed bin(31) value(16);                                 
                                                                                
                                                                                
    /*  reason codes  */                                                        
                                                                                
    declare DSQ_COMMAND_SUCCESS fixed bin(31) value(0);                         
                                                                                
    declare DSQ_CALL_FORMAT               fixed bin(31) value(15);              
    declare DSQ_CONVERSION_ERROR          fixed bin(31) value(25);              
    declare DSQ_DATA_TRUNCATED            fixed bin(31) value(30);              
    declare DSQ_DSQDSPLY_NOT_SET          fixed bin(31) value(35);              
    declare DSQ_INVALID_PROCESS           fixed bin(31) value(40);              
    declare DSQ_INVALID_TYPE              fixed bin(31) value(45);              
    declare DSQ_INVALID_TYPE_ON_START     fixed bin(31) value(50);              
    declare DSQ_MEMORY                    fixed bin(31) value(55);              
    declare DSQ_NUMBER_OF_VAR_0_OR_NEG    fixed bin(31) value(60);              
    declare DSQ_NO_DATABASE               fixed bin(31) value(65);              
    declare DSQ_NO_SEM_TO_START           fixed bin(31) value(70);              
    declare DSQ_QM_ABEND                  fixed bin(31) value(80);              
    declare DSQ_QM_RETURNED_ERROR         fixed bin(31) value(85);              
    declare DSQ_QM_SESSION_NOT_STARTED    fixed bin(31) value(90);              
    declare DSQ_SCREENS_IN_BATCH          fixed bin(31) value(95);              
    declare DSQ_SECOND_START              fixed bin(31) value(100);             
    declare DSQ_SEVERE_ERROR              fixed bin(31) value(105);             
    declare DSQ_START_ERROR               fixed bin(31) value(110);             
    declare DSQ_TOO_MUCH_DATA             fixed bin(31) value(115);             
    declare DSQ_TWO_BEGIN_WINDOWS         fixed bin(31) value(120);             
    declare DSQ_UNMATCHED_END_WINDOW      fixed bin(31) value(125);             
    declare DSQ_VALUE_LENGTH_SET          fixed bin(31) value(130);             
                                                                                
                                                                                
    /*  host variable types  */                                                 
                                                                                
    declare DSQ_VARIABLE_CHAR char value("CHAR");                               
    declare DSQ_VARIABLE_FINT char value("FINT");                               
                                                                                
                                                                                
    /*  cancel indicator  */                                                    
                                                                                
    declare DSQ_CANCEL_YES char value('1');                                     
    declare DSQ_CANCEL_NO char value('0');                                      
                                                                                
                                                                                
    /*   SYSTEM/GLOBAL Variable Values   */                                     
                                                                                
    declare DSQ_YES char value("1");                                            
    declare DSQ_NO char value("0");                                             
    declare DSQ_INTERACTIVE char value("1");                                    
    declare DSQ_BATCH char value("2");                                          
    declare DSQ_TABLE char value("T");                                          
    declare DSQ_VIEW char value("V");                                           
    declare DSQ_PQ char value("PQ");                                            
    declare DSQ_SQL char value("SQL");                                          
    declare DSQ_PQ_CONVERTED char value("3");                                   
    declare DSQ_SQL_CONVERTED char value("1");                                  
                                                                                
                                                                                
 define structure                                                               
   1 DSQCOMM,                                                                   
                                     /* function return code         */         
       2 dsq_return_code fixed bin(31) unsigned,                                
                                                                                
                                     /* instance id for this session */         
       2 dsq_instance_id fixed bin(31) unsigned,                                
                                                                                
                                     /* reserved space - not for     */         
                                     /* application use              */         
       2 dsq_reserve1 char(32),                                                 
                                                                                
                                     /* function reason code         */         
       2 dsq_reason_code fixed bin(31) unsigned,                                
                                                                                
                                     /* function error id for OS/2   */         
                                     /* and Query Manager errors     */         
       2 dsq_error_id fixed bin(31) unsigned,                                   
                                                                                
                                                                                
                                     /* application switch handle    */         
       2 dsq_window_handle fixed bin(31) unsigned,                              
                                                                                
                                     /* completion message id        */         
       2 dsq_message_id char(8) ,                                               
                                                                                
                                     /* query message id             */         
       2 dsq_q_message_id char(8) ,                                             
                                                                                
                                     /* name of start parm in error  */         
       2 dsq_start_parm_error char(8) ,                                         
                                                                                
                                     /* command canceled by          */         
                                     /* Control-Break (1=yes,0=no)   */         
       2 dsq_cancel_ind char(1) ,                                               
                                                                                
                                                                                
                                     /* reserved space -- not for    */         
                                     /* application use              */         
       2 dsq_reserve2 char(23) ,                                                
                                                                                
                                     /* reserved space -- not for    */         
                                     /* application use              */         
       2 dsq_reserve3 char(156);                                                
                                                                                
                                                                                
                                                                                
    dcl DSQCIC  entry (                                                         
           handle DSQCOMM,           /* dsqcomm- communication area  */         
           signed fixed bin(31),     /* command length               */         
           pointer)                  /* command                      */         
             returns( DSQ_API_RC byvalue)                                       
              DSQ_API_FN EXTERNAL;                                              
                                                                                
    dcl DSQCICE  entry (                                                        
           handle DSQCOMM,           /* dsqcomm- communication area  */         
           signed fixed bin(31),     /* command length               */         
           pointer,                  /* command                      */         
           signed fixed bin(31),     /* number of variables          */         
           signed fixed bin(31),     /* name lengths                 */         
           pointer,                  /* variable names               */         
           signed fixed bin(31),     /* variable value lengths       */         
           pointer,                  /* variable values              */         
           pointer)                  /* type = {FINT || CHAR}        */         
             returns( DSQ_API_RC byvalue)                                       
              DSQ_API_FN EXTERNAL;                                              
                                                                                
                                                                                
 %end;                                                                          
 /* DSQ_H_DSQCOMMC */                                                           
                                                                                
