 /********************************************************************/
 /*                                                                  */
 /*  PL/I Include file: PMMLE.CPY                                    */
 /*                                                                  */
 /*  NAME - PMMLE.CPY                                                */
 /*                                                                  */
 /*  DESCRIPTION                                                     */
 /*    Presentation Manager PL/I include file.                       */
 /*                                                                  */
 /*    (C) Copyright IBM Corp. 1992. All Rights Reserved.            */
 /*    US Government Users Restricted Rights-- Use, duplication or   */
 /*    disclosure restricted by GSA ADP Schedule Contract with       */
 /*    IBM Corp.                                                     */
 /*                                                                  */
 /*  DISCLAIMER OF WARRANTIES                                        */
 /*    The following enclosed code is sample code created by IBM   */
 /*    Corporation. This sample code is not part of any standard     */
 /*    IBM product and is provided to you solely for the purpose of  */
 /*    assisting you in the development of your applications.  The   */
 /*    code is provided "AS IS", without warranty of any kind.       */
 /*    IBM shall not be liable for any damages arising out of your   */
 /*    use of the sample code, even if IBM has been advised of the   */
 /*    possibility of such damages.                                  */
 /*                                                                  */
 /********************************************************************/
 /*==================================================================*/
 /*                                                                  */
 /* The following symbols are used in this file for conditional      */
 /* sections.                                                        */
 /*                                                                  */
 /*   #define:                To include:                            */
 /*                                                                  */
 /*   INCL_WINMLE             Includes this file                     */
 /*                                                                  */
 /*==================================================================*/
 %if IBMC__='Y' %then %do;
   %if CHKHDR__='Y' %then %do;
   %end;
 %end;
 %if MLE_INCLUDED='Y' %then %do;
   %MLE_INCLUDED='Y';
   declare MLS_WORDWRAP fixed bin(31) value('00_00_00_01'xn);
   declare MLS_BORDER fixed bin(31) value('00_00_00_02'xn);
   declare MLS_VSCROLL fixed bin(31) value('00_00_00_04'xn);
   declare MLS_HSCROLL fixed bin(31) value('00_00_00_08'xn);
   declare MLS_READONLY fixed bin(31) value('00_00_00_10'xn);
   declare MLS_IGNORETAB fixed bin(31) value('00_00_00_20'xn);
   declare MLS_DISABLEUNDO fixed bin(31) value('00_00_00_40'xn);
   %declare IPT char;
   %IPT=LONG;
   %declare PIPT char;
   %PIPT=PLONG;
   %declare PIX char;
   %PIX=LONG;
   %declare LINE char;
   %LINE=ULONG;
   %declare FORMATRECT char;
   %FORMATRECT='char(stg(#FORMATRECT))';
   dcl 1 #FORMATRECT based(null()) unaligned,
         2 cxFormat LONG,
         2 cyFormat LONG;
   %declare PFORMATRECT char;
   %PFORMATRECT='pointer';
   %declare MLECTLDATA char;
   %MLECTLDATA='char(stg(#MLECTLDATA))';
   dcl 1 #MLECTLDATA based(null()) unaligned,
         2 cbCtlData USHORT,
         2 afIEFormat USHORT,
         2 cchText ULONG,
         2 iptAnchor IPT,
         2 iptCursor IPT,
         2 cxFormat LONG,
         2 cyFormat LONG,
         2 afFormatFlags ULONG;
   %declare PMLECTLDATA char;
   %PMLECTLDATA='pointer';

   declare MLFFMTRECT_LIMITHORZ fixed bin(31) value('00_00_00_01'xn);
   declare MLFFMTRECT_LIMITVERT fixed bin(31) value('00_00_00_02'xn);
   declare MLFFMTRECT_MATCHWINDOW fixed bin(31) value('00_00_00_04'xn);
   declare MLFFMTRECT_FORMATRECT fixed bin(31) value('00_00_00_07'xn);

   %declare MLFIE_CFTEXT char;
   %MLFIE_CFTEXT=0;
   %declare MLFIE_NOTRANS char;
   %MLFIE_NOTRANS=1;
   %declare MLFIE_WINFMT char;
   %MLFIE_WINFMT=2;
   %declare MLFIE_RTF char;
   %MLFIE_RTF=3;
   %declare MLEOVERFLOW char;
   %MLEOVERFLOW='char(stg(#MLEOVERFLOW))';
   dcl 1 #MLEOVERFLOW based(null()) unaligned,
         2 afErrInd ULONG,
         2 nBytesOver LONG,
         2 pixHorzOver LONG,
         2 pixVertOver LONG;
   %declare POVERFLOW char;
   %POVERFLOW='pointer';
   declare MLFEFR_RESIZE fixed bin(31) value('00_00_00_01'xn);
   declare MLFEFR_TABSTOP fixed bin(31) value('00_00_00_02'xn);
   declare MLFEFR_FONT fixed bin(31) value('00_00_00_04'xn);
   declare MLFEFR_TEXT fixed bin(31) value('00_00_00_08'xn);
   declare MLFEFR_WORDWRAP fixed bin(31) value('00_00_00_10'xn);
   declare MLFETL_TEXTBYTES fixed bin(31) value('00_00_00_20'xn);

   %declare MLEMARGSTRUCT char;
   %MLEMARGSTRUCT='char(stg(#MLEMARGSTRUCT))';
   dcl 1 #MLEMARGSTRUCT based(null()) unaligned,
         2 afMargins USHORT,
         2 usMouMsg USHORT,
         2 iptNear IPT;
   %declare PMARGSTRUCT char;
   %PMARGSTRUCT='pointer';

   declare MLFMARGIN_LEFT fixed bin(16) value('00_01'xn);
   declare MLFMARGIN_BOTTOM fixed bin(16) value('00_02'xn);
   declare MLFMARGIN_RIGHT fixed bin(16) value('00_03'xn);
   declare MLFMARGIN_TOP fixed bin(16) value('00_04'xn);

   %declare MLFQS_MINMAXSEL char;
   %MLFQS_MINMAXSEL=0;
   %declare MLFQS_MINSEL char;
   %MLFQS_MINSEL=1;
   %declare MLFQS_MAXSEL char;
   %MLFQS_MAXSEL=2;
   %declare MLFQS_ANCHORSEL char;
   %MLFQS_ANCHORSEL=3;
   %declare MLFQS_CURSORSEL char;
   %MLFQS_CURSORSEL=4;

   declare MLFCLPBD_TOOMUCHTEXT fixed bin(31) value('00_00_00_01'xn);
   declare MLFCLPBD_ERROR fixed bin(31) value('00_00_00_02'xn);

   %declare PMSEARCH char;
   %PMSEARCH='char(stg(#SEARCH))';
   dcl 1 #SEARCH based(null()) unaligned,
         2 cb USHORT,
         2 pchFind PCHAR,
         2 pchReplace PCHAR,
         2 cchFind SHORT,
         2 cchReplace SHORT,
         2 iptStart IPT,
         2 iptStop IPT,
         2 cchFound USHORT;
   %declare PMLE_SEARCHDATA char;
   %PMLE_SEARCHDATA='pointer';

   declare MLFSEARCH_CASESENSITIVE fixed bin(31) value('00_00_00_01'xn);
   declare MLFSEARCH_SELECTMATCH fixed bin(31) value('00_00_00_02'xn);
   declare MLFSEARCH_CHANGEALL fixed bin(31) value('00_00_00_04'xn);

   declare MLM_SETTEXTLIMIT fixed bin(16) value('01_B0'xn);
   declare MLM_QUERYTEXTLIMIT fixed bin(16) value('01_B1'xn);
   declare MLM_SETFORMATRECT fixed bin(16) value('01_B2'xn);
   declare MLM_QUERYFORMATRECT fixed bin(16) value('01_B3'xn);
   declare MLM_SETWRAP fixed bin(16) value('01_B4'xn);
   declare MLM_QUERYWRAP fixed bin(16) value('01_B5'xn);
   declare MLM_SETTABSTOP fixed bin(16) value('01_B6'xn);
   declare MLM_QUERYTABSTOP fixed bin(16) value('01_B7'xn);
   declare MLM_SETREADONLY fixed bin(16) value('01_B8'xn);
   declare MLM_QUERYREADONLY fixed bin(16) value('01_B9'xn);
   declare MLM_QUERYCHANGED fixed bin(16) value('01_BA'xn);
   declare MLM_SETCHANGED fixed bin(16) value('01_BB'xn);
   declare MLM_QUERYLINECOUNT fixed bin(16) value('01_BC'xn);
   declare MLM_CHARFROMLINE fixed bin(16) value('01_BD'xn);
   declare MLM_LINEFROMCHAR fixed bin(16) value('01_BE'xn);
   declare MLM_QUERYLINELENGTH fixed bin(16) value('01_BF'xn);
   declare MLM_QUERYTEXTLENGTH fixed bin(16) value('01_C0'xn);
   declare MLM_FORMAT fixed bin(16) value('01_C1'xn);
   declare MLM_SETIMPORTEXPORT fixed bin(16) value('01_C2'xn);
   declare MLM_IMPORT fixed bin(16) value('01_C3'xn);
   declare MLM_EXPORT fixed bin(16) value('01_C4'xn);
   declare MLM_DELETE fixed bin(16) value('01_C6'xn);
   declare MLM_QUERYFORMATLINELENGTH fixed bin(16) value('01_C7'xn);
   declare MLM_QUERYFORMATTEXTLENGTH fixed bin(16) value('01_C8'xn);
   declare MLM_INSERT fixed bin(16) value('01_C9'xn);
   declare MLM_SETSEL fixed bin(16) value('01_CA'xn);
   declare MLM_QUERYSEL fixed bin(16) value('01_CB'xn);
   declare MLM_QUERYSELTEXT fixed bin(16) value('01_CC'xn);
   declare MLM_QUERYUNDO fixed bin(16) value('01_CD'xn);
   declare MLM_UNDO fixed bin(16) value('01_CE'xn);
   declare MLM_RESETUNDO fixed bin(16) value('01_CF'xn);
   declare MLM_QUERYFONT fixed bin(16) value('01_D0'xn);
   declare MLM_SETFONT fixed bin(16) value('01_D1'xn);
   declare MLM_SETTEXTCOLOR fixed bin(16) value('01_D2'xn);
   declare MLM_QUERYTEXTCOLOR fixed bin(16) value('01_D3'xn);
   declare MLM_SETBACKCOLOR fixed bin(16) value('01_D4'xn);
   declare MLM_QUERYBACKCOLOR fixed bin(16) value('01_D5'xn);
   declare MLM_QUERYFIRSTCHAR fixed bin(16) value('01_D6'xn);
   declare MLM_SETFIRSTCHAR fixed bin(16) value('01_D7'xn);
   declare MLM_CUT fixed bin(16) value('01_D8'xn);
   declare MLM_COPY fixed bin(16) value('01_D9'xn);
   declare MLM_PASTE fixed bin(16) value('01_DA'xn);
   declare MLM_CLEAR fixed bin(16) value('01_DB'xn);
   declare MLM_ENABLEREFRESH fixed bin(16) value('01_DC'xn);
   declare MLM_DISABLEREFRESH fixed bin(16) value('01_DD'xn);
   declare MLM_SEARCH fixed bin(16) value('01_DE'xn);
   declare MLM_QUERYIMPORTEXPORT fixed bin(16) value('01_DF'xn);
   declare MLN_OVERFLOW fixed bin(16) value('00_01'xn);
   declare MLN_PIXHORZOVERFLOW fixed bin(16) value('00_02'xn);
   declare MLN_PIXVERTOVERFLOW fixed bin(16) value('00_03'xn);
   declare MLN_TEXTOVERFLOW fixed bin(16) value('00_04'xn);
   declare MLN_VSCROLL fixed bin(16) value('00_05'xn);
   declare MLN_HSCROLL fixed bin(16) value('00_06'xn);
   declare MLN_CHANGE fixed bin(16) value('00_07'xn);
   declare MLN_SETFOCUS fixed bin(16) value('00_08'xn);
   declare MLN_KILLFOCUS fixed bin(16) value('00_09'xn);
   declare MLN_MARGIN fixed bin(16) value('00_0A'xn);
   declare MLN_SEARCHPAUSE fixed bin(16) value('00_0B'xn);
   declare MLN_MEMERROR fixed bin(16) value('00_0C'xn);
   declare MLN_UNDOOVERFLOW fixed bin(16) value('00_0D'xn);
   declare MLN_CLPBDFAIL fixed bin(16) value('00_0F'xn);
 %end;
 %if IBMC__='Y' %then %do;
   %if CHKHDR__='Y' %then %do;
   %end;
 %end;
