 /********************************************************************/
 /*                                                                  */
 /*  PL/I Include file: PMWP.CPY                                     */
 /*                                                                  */
 /*  NAME - PMWP.CPY                                                 */
 /*                                                                  */
 /*  DESCRIPTION                                                     */
 /*    Presentation Manager PL/I include file.                       */
 /*                                                                  */
 /*    (C) Copyright IBM Corp. 1992. All Rights Reserved.            */
 /*    US Government Users Restricted Rights-- Use, duplication or   */
 /*    disclosure restricted by GSA ADP Schedule Contract with       */
 /*    IBM Corp.                                                     */
 /*                                                                  */
 /*  DISCLAIMER OF WARRANTIES                                        */
 /*    The following enclosed code is sample code created by IBM   */
 /*    Corporation. This sample code is not part of any standard     */
 /*    IBM product and is provided to you solely for the purpose of  */
 /*    assisting you in the development of your applications.  The   */
 /*    code is provided "AS IS", without warranty of any kind.       */
 /*    IBM shall not be liable for any damages arising out of your   */
 /*    use of the sample code, even if IBM has been advised of the   */
 /*    possibility of such damages.                                  */
 /*                                                                  */
 /********************************************************************/
 /*==================================================================*/
 /*                                                                  */
 /*  The folowing symbols are used in this file                      */
 /*  for conditional sections.                                       */
 /*                                                                  */
 /*  #define:                To include:                             */
 /*                                                                  */
 /*  INCL_WINWORKPLACE       All of Workplace Shell                  */
 /*  INCL_WPCLASS            Workplace object class API's            */
 /*                                                                  */
 /*==================================================================*/
 %if IBMC__='Y' %then %do;
   %if CHKHDR__='Y' %then %do;
   %end;
 %end;
 %if PMWP_INCLUDED='Y' %then %do;
   %PMWP_INCLUDED='Y';
   %if INCL_WINWORKPLACE='Y' %then %do;
     %INCL_WPCLASS='Y';
   %end;
   %declare HOBJECT char;
   %HOBJECT=LHANDLE;
   %if INCL_WPCLASS='Y' | INCL_NOCOMMON='Y' %then %do;
     %declare CCHMAXCLASS char;
     %CCHMAXCLASS=3;
     %declare QC_First char;
     %QC_First=0;
     %declare QC_Next char;
     %QC_Next=1;
     %declare QC_Last char;
     %QC_Last=2;
     %declare QC_FIRST char;
     %QC_FIRST=QC_First;
     %declare QC_NEXT char;
     %QC_NEXT=QC_Next;
     %declare QC_LAST char;
     %QC_LAST=QC_Last;
     %declare OBJECTIMAGE char;
     %OBJECTIMAGE='char(stg(#OBJECTIMAGE))';
     dcl 1 #OBJECTIMAGE based(null()) unaligned,
           2 hptrObject HPOINTER;
     %declare POBJECTIMAGE char;
     %POBJECTIMAGE='pointer';
     %declare OBJCLASS char;
     %OBJCLASS='char(stg(#OBJCLASS))';
     dcl 1 #OBJCLASS based(null()) unaligned,
           2 pNext pointer,
           2 pszClassName PSZ,
           2 pszModName PSZ;
     %declare POBJCLASS char;
     %POBJCLASS='pointer';
     dcl WinRegisterObjectClass entry (
            PSZ,
            PSZ)
            returns(optional byvalue BOOL)
            APIENTRY;
     dcl WinDeregisterObjectClass entry (
            PSZ)
            returns(optional byvalue BOOL)
            APIENTRY;
     dcl WinReplaceObjectClass entry (
            PSZ,
            PSZ,
            BOOL)
            returns(optional byvalue BOOL)
            APIENTRY;
     dcl WinEnumObjectClasses entry (
            POBJCLASS,
            PULONG)
            returns(optional byvalue BOOL)
            APIENTRY;
     dcl WinCreateObject entry (
            PSZ,
            PSZ,
            PSZ,
            PSZ,
            ULONG)
            returns(optional byvalue HOBJECT)
            APIENTRY;
     %declare CO_FAILIFEXISTS char;
     %CO_FAILIFEXISTS=0;
     %declare CO_REPLACEIFEXISTS char;
     %CO_REPLACEIFEXISTS=1;
     %declare CO_UPDATEIFEXISTS char;
     %CO_UPDATEIFEXISTS=2;
     dcl WinSetObjectData entry (
            HOBJECT,
            PSZ)
            returns(optional byvalue BOOL)
            APIENTRY;
     dcl WinDestroyObject entry (
            HOBJECT)
            returns(optional byvalue BOOL)
            APIENTRY;
     dcl WinQueryObject entry (
            PSZ)
            returns(optional byvalue HOBJECT)
            APIENTRY;
   %end;
   %INCL_WPERRORS='Y';
   %include pmerr;
   %declare PAGEINFO char;
   %PAGEINFO='char(stg(#PAGEINFO))';
   dcl 1 #PAGEINFO based(null()) unaligned,
         2 cb ULONG,
         2 hwndPage HWND,
         2 PAGEINFO_pfnwp PFNWP,
         2 resid ULONG,
         2 pCreateParams PVOID,
         2 dlgid USHORT,
         2 usPageStyleFlags USHORT,
         2 usPageInsertFlags USHORT,
         2 usSettingsFlags USHORT,
         2 pszName PSZ,
         2 idDefaultHelpPanel USHORT,
         2 usReserved2 USHORT,
         2 pszHelpLibraryName PSZ,
         2 pHelpSubtable PUSHORT,
         2 hmodHelpSubtable HMODULE,
         2 ulPageInsertId ULONG;
   %declare PPAGEINFO char;
   %PPAGEINFO='pointer';

   declare SETTINGS_PAGE_NUMBERS bit(8) value('00_00_00_01'b);

   %if INCL_NOCOMMON='Y' %then %do;
     %declare ICONPOS char;
     %ICONPOS='char(stg(#ICONPOS))';
     dcl 1 #ICONPOS based(null()) unaligned,
           2 ptlIcon POINTL,
           2 szIdentity(1) CHAR;
     %declare PICONPOS char;
     %PICONPOS='pointer';
     %if INCL_WINPOINTERS='Y' %then %do;
       dcl WinSetFileIcon entry (
              PSZ,
              PICONINFO)
              returns(optional byvalue BOOL)
              APIENTRY;
     %end;
     dcl WinFreeFileIcon entry (
            HPOINTER)
            returns(optional byvalue BOOL)
            APIENTRY;
     dcl WinLoadFileIcon entry (
            PSZ,
            BOOL)
            returns(optional byvalue HPOINTER)
            APIENTRY;
     dcl WinStoreWindowPos entry (
            PSZ,
            PSZ,
            HWND)
            returns(optional byvalue BOOL)
            APIENTRY;
     dcl WinRestoreWindowPos entry (
            PSZ,
            PSZ,
            HWND)
            returns(optional byvalue BOOL)
            APIENTRY;
     dcl WinShutdownSystem entry (
            HAB,
            HMQ)
            returns(optional byvalue BOOL)
            APIENTRY;
   %end;
 %end;
 %if IBMC__='Y' %then %do;
   %if CHKHDR__='Y' %then %do;
   %end;
 %end;
