 /*********************************************************/
 /*  CREATED BY C2PLI CONVERSION UTILITY                  */
 /*********************************************************/
 /********************************************************************/
 /*                                                                  */
 /*  PL/I Include file: SQL.CPY                                      */
 /*                                                                  */
 /*    This file is installed in the \IBMPLI\INCLUDE\ directory.     */
 /*                                                                  */
 /*                                                                  */
 /*  NAME - SQL.CPY                                                  */
 /*                                                                  */
 /*  DESCRIPTION                                                     */
 /*                                                                  */
 /*    This include file is translated into a PL/I include file,     */
 /*    from the C header files supplied with the                     */
 /*    IBM DATABASE 2 SOFTWARE DEVELOPERS KIT/2  product.            */
 /*    This include file is intended for use with the                */
 /*    IBM DATABASE 2 SOFTWARE DEVELOPERS KIT/2 product.             */
 /*                                                                  */
 /*                                                                  */
 /*    (C) Copyright IBM Corp. 1994, 1996. All Rights Reserved.      */
 /*    US Government Users Restricted Rights-- Use, duplication or   */
 /*    disclosure restricted by GSA ADP Schedule Contract with       */
 /*    IBM Corp.                                                     */
 /*  Licensed Materials - Property of IBM                            */
 /*                                                                  */
 /*  Function = Include File defining:                               */
 /*               System Constants                                   */
 /*               National Language Support Information              */
 /*               SQLCA / SQLDA Constants                            */
 /*               Interface to BINDER and PRECOMPILER                */
 /*               Error Message Retrieval Interface                  */
 /*               Authorization Constants                            */
 /*                                                                  */
 /*  Operating System = OS/2                                         */
 /*                                                                  */
 /*                                                                  */
 /*  DISCLAIMER OF WARRANTIES                                        */
 /*    The following enclosed code is sample code created by IBM   */
 /*    Corporation. This sample code is not part of any standard     */
 /*    IBM product and is provided to you solely for the purpose of  */
 /*    assisting you in the development of your applications.  The   */
 /*    code is provided "AS IS", without warranty of any kind.       */
 /*    IBM shall not be liable for any damages arising out of your   */
 /*    use of the sample code, even if IBM has been advised of the   */
 /*    possibility of such damages.                                  */
 /*                                                                  */
 /********************************************************************/
 %dcl SQL_H_SQL char ext;
 %if SQL_H_SQL = '' %then
  %do;
    %dcl SQL_H_SQL char ext;
    %SQL_H_SQL = 'Y';



 /* System dependent defines  */
    %include sqlsystm;

    %dcl SQL_CODE char ext;
    %if SQL_CODE = '' %then
     %do;
 /* Required include file    */
 /*    %include sqlca;       */
     %end;

 /* System Constants           */

    %dcl SQL_RC_OK char ext;
    %if SQL_RC_OK = '' %then
     %do;
 /* successful execution                */
       %SQL_RC_OK = '0';

     %end;

                              /* Maximum nbr of key parts in Index   */
    dcl SQL_KEYPMAX fixed bin(31) value(16);
                              /* Maximum key length                  */
    dcl SQL_KEYLMAX fixed bin(31) value(255);
                              /* Maximum size of field for sort      */
    dcl SQL_SORTFLDLMT fixed bin(31) value(254);
                              /* Maximum record length               */
    dcl SQL_MAXRECL fixed bin(31) value(4005);
                              /* Maximum nbr of tables in a SELECT   */
    dcl SQL_MAXTABLES fixed bin(31) value(15);
                              /* Maximum nbr of items in a SELECT    */
    dcl SQL_MAXSEL_ITEMS fixed bin(31) value(255);
                              /* Maximum nbr of Host Vars per stmt   */
    dcl SQL_MAXVARS_STMT fixed bin(31) value(32767);
                              /* Maximum nbr of columns in a table   */
    dcl SQL_MAXCOLS fixed bin(31) value(255);
                              /* Maximum nbr of parms in a function  */
    dcl SQL_MAXPARMS fixed bin(31) value(90);
                              /* Maximum statement size              */
    dcl SQL_MAX_STMT_SIZ fixed bin(31) value(32765);

                              /* Size of a SMALLINT                  */
    dcl SQL_SMALL_LENGTH fixed bin(31) value(2);
                              /* Maximum value of a SMALLINT         */
    dcl SQL_MAXSMALLVAL fixed bin(31) value(32767);
                                      /* Minimum value of a SMALLINT */
 %dcl SQL_MINSMALLVAL char ext;
 %SQL_MINSMALLVAL = '(-(SQL_MAXSMALLVAL)-1)';
                              /* Size of an INTEGER                  */
    dcl SQL_INT_LENGTH fixed bin(31) value(4);
                                 /* Maximum value of an INTEGER      */
    dcl SQL_MAXINTVAL fixed bin(31) value(2147483647);
                                     /* Minimum value of an INTEGER  */
 %dcl SQL_MININTVAL char ext;
 %SQL_MININTVAL = '(-(SQL_MAXINTVAL)-1)';
                              /* Size of a FLOAT                     */
    dcl SQL_FLOAT_LENGTH fixed bin(31) value(8);
                              /* Default precision for DECIMAL       */
    dcl SQL_DEFDEC_PRECISION fixed bin(31) value(5);
                              /* Default scale for DECIMAL           */
    dcl SQL_DEFDEC_SCALE fixed bin(31) value(0);
                              /* Maximum scale/prec. for DECIMAL     */
    dcl SQL_MAXDECIMAL fixed bin(31) value(31);
                              /* Default length for a CHAR           */
    dcl SQL_DEFCHAR fixed bin(31) value(1);
                              /* Default length for a wchar_t        */
    dcl SQL_DEFWCHAR fixed bin(31) value(1);
                              /* Maximum length of a CHAR            */
    dcl SQL_MAXCHAR fixed bin(31) value(254);
                              /* Maximum length of an LSTRING        */
    dcl SQL_MAXLSTR fixed bin(31) value(255);
                                      /* Maximum length of a         */
                              /* VARCHAR                             */
 %dcl SQL_MAXVCHAR char ext;
 %SQL_MAXVCHAR = 'SQL_MAXRECL-5';
                              /* Maximum length of a VARGRAPHIC      */
    dcl SQL_MAXVGRAPH fixed bin(31) value(2000);
                                 /* Max. length of a BLOB host var   */
    dcl SQL_MAXBLOB fixed bin(31) value(2147483647);
                                 /* Max. length of a CLOB host var   */
    dcl SQL_MAXCLOB fixed bin(31) value(2147483647);
                                 /* Max. length of an DBCLOB host    */
                              /* var                                 */
    dcl SQL_MAXDBCLOB fixed bin(31) value(1073741823);
                              /* Length of a LOB locator host var    */
    dcl SQL_LOBLOCATOR_LEN fixed bin(31) value(4);
                              /* Length of a LOB file host var       */
    dcl SQL_LOBFILE_LEN fixed bin(31) value(267);
                              /* Overhead for VARCHAR in record      */
    dcl SQL_VCHAROH fixed bin(31) value(4);
                              /* Maximum length of a LONG VARCHAR    */
    dcl SQL_LONGMAX fixed bin(31) value(32700);
                              /* Max. length of a LONG VARGRAPHIC    */
    dcl SQL_LONGGRMAX fixed bin(31) value(16350);
                              /* Overhead for LONG VARCHAR in        */
                              /* record                              */
    dcl SQL_LVCHAROH fixed bin(31) value(24);
                              /* Overhead for LOB in record          */
    dcl SQL_LOBCHAROH fixed bin(31) value(312);
                                 /* BLOB maximum length, in bytes    */
    dcl SQL_BLOB_MAXLEN fixed bin(31) value(2147483647);
                                 /* CLOB maximum length, in chars    */
    dcl SQL_CLOB_MAXLEN fixed bin(31) value(2147483647);
                                 /* maxlen for dbcs lobs             */
    dcl SQL_DBCLOB_MAXLEN fixed bin(31) value(1073741823);
                              /* Size of a TIME field                */
    dcl SQL_TIME_LENGTH fixed bin(31) value(3);
                              /* Size of a TIME field output         */
    dcl SQL_TIME_STRLEN fixed bin(31) value(8);
                              /* Size of a non-USA TIME field        */
                              /* output without seconds              */
    dcl SQL_TIME_MINSTRLEN fixed bin(31) value(5);
                              /* Size of a DATE field                */
    dcl SQL_DATE_LENGTH fixed bin(31) value(4);
                              /* Size of a DATE field output         */
    dcl SQL_DATE_STRLEN fixed bin(31) value(10);
                              /* Size of a TIMESTAMP field           */
    dcl SQL_STAMP_LENGTH fixed bin(31) value(10);
                              /* Size of a TIMESTAMP field output    */
    dcl SQL_STAMP_STRLEN fixed bin(31) value(26);
                              /* Size of a TIMESTAMP field output    */
                              /* without microseconds                */
    dcl SQL_STAMP_MINSTRLEN fixed bin(31) value(19);
                              /* Size of a BOOLEAN field             */
    dcl SQL_BOOLEAN_LENGTH fixed bin(31) value(1);
                              /* Size of an indicator value          */
    dcl SQL_IND_LENGTH fixed bin(31) value(2);

                              /* Max size of Stored Proc Name        */
    dcl SQL_MAX_PNAME_LENGTH fixed bin(31) value(254);
                              /* Maximum length of Long Identifer    */
    dcl SQL_LG_IDENT fixed bin(31) value(18);
                              /* Maximum length of Short Identifer   */
    dcl SQL_SH_IDENT fixed bin(31) value(8);
                              /* Minimum length of Identifiers       */
    dcl SQL_MN_IDENT fixed bin(31) value(1);
                              /* Max size of Host Variable Name      */
    dcl SQL_MAX_VAR_NAME fixed bin(31) value(30);
                              /* # of bytes in a kilobyte            */
    dcl SQL_KILO_VALUE fixed bin(31) value(1024);
                              /* # of bytes in a megabyte            */
    dcl SQL_MEGA_VALUE fixed bin(31) value(1048576);
                                 /* # of bytes in a gigabyte         */
    dcl SQL_GIGA_VALUE fixed bin(31) value(1073741824);

                              /* size of container name for api's    */
    dcl SQLB_MAX_CONTAIN_NAME_SZ fixed bin(31) value(256);

 /* Codepages*/
                              /* Codepage 367 - EUC single byte      */
    dcl SQL_CP_367 fixed bin(31) value(367);
                              /* Codepage 437 - US, Europe           */
    dcl SQL_CP_437 fixed bin(31) value(437);
                              /* Codepage 813 - AIX Greece           */
    dcl SQL_CP_813 fixed bin(31) value(813);
                              /* Codepage 819 - ISO 8859-1           */
    dcl SQL_CP_819 fixed bin(31) value(819);
                              /* Codepage 850 - International PC     */
    dcl SQL_CP_850 fixed bin(31) value(850);
                              /* Codepage 855 - OS2 Cyrillic         */
    dcl SQL_CP_855 fixed bin(31) value(855);
                              /* Codepage 852 - OS2 Latin2           */
    dcl SQL_CP_852 fixed bin(31) value(852);
                              /* Codepage 857 - OS2 Turkey           */
    dcl SQL_CP_857 fixed bin(31) value(857);
                              /* Codepage 860 - Portuguese           */
    dcl SQL_CP_860 fixed bin(31) value(860);
                              /* Codepage 862 - OS2 Hebrew           */
    dcl SQL_CP_862 fixed bin(31) value(862);
                              /* Codepage 863 - Canadian-French      */
    dcl SQL_CP_863 fixed bin(31) value(863);
                              /* Codepage 863 - OS2 Arabic           */
    dcl SQL_CP_864 fixed bin(31) value(864);
                              /* Codepage 865 - Norway, Denmark      */
    dcl SQL_CP_865 fixed bin(31) value(865);
                              /* Codepage 866 - Russia               */
    dcl SQL_CP_866 fixed bin(31) value(866);
                              /* Codepage 869 - OS2 Greece           */
    dcl SQL_CP_869 fixed bin(31) value(869);
                              /* Codepage 874 - OS2/AIX Thailand     */
    dcl SQL_CP_874 fixed bin(31) value(874);
                              /* Codepage 891 - Korean               */
    dcl SQL_CP_891 fixed bin(31) value(891);
                              /* Codepage 897 - Japanese             */
    dcl SQL_CP_897 fixed bin(31) value(897);
                              /* Codepage 903 - Chinese              */
    dcl SQL_CP_903 fixed bin(31) value(903);
                              /* Codepage 904 - Taiwan               */
    dcl SQL_CP_904 fixed bin(31) value(904);
                              /* Codepage 912 - AIX Latin2           */
    dcl SQL_CP_912 fixed bin(31) value(912);
                              /* Codepage 915 - AIX Cyrillic         */
    dcl SQL_CP_915 fixed bin(31) value(915);
                              /* Codepage 916 - AIX Hebrew           */
    dcl SQL_CP_916 fixed bin(31) value(916);
                              /* Codepage 920 - AIX Turkey           */
    dcl SQL_CP_920 fixed bin(31) value(920);
                              /* Codepage 1004 - MS-WINDOWS          */
    dcl SQL_CP_1004 fixed bin(31) value(1004);
                              /* Codepage 1040 - Extended Korean     */
    dcl SQL_CP_1040 fixed bin(31) value(1040);
                              /* Codepage 1041 - Extended Japanese   */
    dcl SQL_CP_1041 fixed bin(31) value(1041);
                              /* Codepage 1042 - Extended Chinese    */
    dcl SQL_CP_1042 fixed bin(31) value(1042);
                              /* Codepage 1043 - Extended Taiwan     */
    dcl SQL_CP_1043 fixed bin(31) value(1043);
                              /* Codepage 1046 - AIX Arabic          */
    dcl SQL_CP_1046 fixed bin(31) value(1046);
                              /* Codepage 1051 - HP Roman8           */
    dcl SQL_CP_1051 fixed bin(31) value(1051);
                              /* Codepage 1088 - Korea Std           */
    dcl SQL_CP_1088 fixed bin(31) value(1088);
                              /* Codepage 1089 - AIX Arabic          */
    dcl SQL_CP_1089 fixed bin(31) value(1089);
                              /* Codepage 1114 - Taiwan Big-5        */
    dcl SQL_CP_1114 fixed bin(31) value(1114);
                              /* Codepage 1115 - China GB            */
    dcl SQL_CP_1115 fixed bin(31) value(1115);
                              /* Codepage 1250 - Windows Latin-2     */
    dcl SQL_CP_1250 fixed bin(31) value(1250);
                              /* Codepage 1251 - Windows Cyrillic    */
    dcl SQL_CP_1251 fixed bin(31) value(1251);
                              /* Codepage 1252 - Windows Latin-1     */
    dcl SQL_CP_1252 fixed bin(31) value(1252);
                              /* Codepage 1253 - Windows Greek       */
    dcl SQL_CP_1253 fixed bin(31) value(1253);
                              /* Codepage 1254 - Windows Turkish     */
    dcl SQL_CP_1254 fixed bin(31) value(1254);
                              /* Codepage 1255 - Windows Hebrew      */
    dcl SQL_CP_1255 fixed bin(31) value(1255);
                              /* Codepage 1256 - Windows Arabic      */
    dcl SQL_CP_1256 fixed bin(31) value(1256);
                              /* Codepage 1275 - Mac Latin-1         */
    dcl SQL_CP_1275 fixed bin(31) value(1275);

 /* DBCS Codepages*/
                              /* Codepage 926 - Korean               */
    dcl SQL_CP_926 fixed bin(31) value(926);
                              /* Codepage 951 - New Korean           */
    dcl SQL_CP_951 fixed bin(31) value(951);
                              /* Codepage 301 - Japanese             */
    dcl SQL_CP_301 fixed bin(31) value(301);
                              /* Codepage 928 - Chinese              */
    dcl SQL_CP_928 fixed bin(31) value(928);
                              /* Codepage 927 - Taiwan               */
    dcl SQL_CP_927 fixed bin(31) value(927);
                              /* Codepage 947 - Taiwan Big-5         */
    dcl SQL_CP_947 fixed bin(31) value(947);
                              /* Codepage 971 - Korean 5601          */
    dcl SQL_CP_971 fixed bin(31) value(971);
                              /* Codepage1380 - China GB             */
    dcl SQL_CP_1380 fixed bin(31) value(1380);
                              /* Codepage1382 - Simp Chinese GB      */
    dcl SQL_CP_1382 fixed bin(31) value(1382);

 /* Combined Codepages */
                              /* Codepage 891 + 926 - Korean         */
    dcl SQL_CP_934 fixed bin(31) value(934);
                              /* CP 1088 + 951 - Korean Std          */
    dcl SQL_CP_949 fixed bin(31) value(949);
                              /* Codepage 897 + 301 - Japanese       */
    dcl SQL_CP_932 fixed bin(31) value(932);
                              /* Codepage 903 + 928 - Chinese        */
    dcl SQL_CP_936 fixed bin(31) value(936);
                              /* Codepage 904 + 927 - Taiwan         */
    dcl SQL_CP_938 fixed bin(31) value(938);
                              /* Codepage 1040 + 926 - Ext.Korean    */
    dcl SQL_CP_944 fixed bin(31) value(944);
                              /* Codepage 1041 + 301 - Ext.Japanese  */
    dcl SQL_CP_942 fixed bin(31) value(942);
                              /* Codepage 1042 + 928 - Ext.Chinese   */
    dcl SQL_CP_946 fixed bin(31) value(946);
                              /* Codepage 1043 + 927 - Ext.Taiwan    */
    dcl SQL_CP_948 fixed bin(31) value(948);
                              /* Codepage 1114 + 947 - Taiwan Big5   */
    dcl SQL_CP_950 fixed bin(31) value(950);
                              /* Codepage  367 + 971 - Korean 5601   */
    dcl SQL_CP_970 fixed bin(31) value(970);
                              /* Codepage 1115 +1380 - China GB      */
    dcl SQL_CP_1381 fixed bin(31) value(1381);
                              /* Codepage  367 +1382 - Chinese GB    */
    dcl SQL_CP_1383 fixed bin(31) value(1383);

 /* Datastream Types*/
                              /* Single byte PC                      */
    dcl SQL_SBC_PC fixed bin(31) value(0);
                              /* Japanese-PC                         */
    dcl SQL_JPN_PC fixed bin(31) value(1);
                              /* Chinese-PC                          */
    dcl SQL_CHN_PC fixed bin(31) value(2);
                              /* Korean-PC                           */
    dcl SQL_KOR_PC fixed bin(31) value(3);
                              /* New Korean-PC                       */
    dcl SQL_KSC_PC fixed bin(31) value(4);
                              /* Korean 5601                         */
    dcl SQL_KR5_PC fixed bin(31) value(5);
                              /* Taiwan Big-5                        */
    dcl SQL_TWN_PC fixed bin(31) value(6);
                              /* China GB                            */
    dcl SQL_CGB_PC fixed bin(31) value(7);
                              /* China GB on AIX                     */
    dcl SQL_CGBA_PC fixed bin(31) value(8);
                              /* Unknown                             */
    dcl SQL_UNKN_PC fixed bin(31) value(255);

 /* AIX codeset & locale lengths*/
    dcl SQL_CODESET_LEN fixed bin(31) value(9);
    dcl SQL_LOCALE_LEN fixed bin(31) value(5);

 /* SQLCA Constants             */
    %dcl SQL_RC_INVALID_SQLCA char ext;
    %if SQL_RC_INVALID_SQLCA = '' %then
     %do;
     %end;

 /* Size of SQLCA               */
 %dcl SQLCA_SIZE char ext;
 %SQLCA_SIZE='struct sqlca';
    %dcl @SQLCA_SIZE char ext;
    %@SQLCA_SIZE='@struct sqlca';

 /* SQL Error message token delimiter*/
 dcl SQL_ERRMC_PRES char value('FF'xn);
 /* delimiter for string entry */

 /* Offset in SQLERRD - Diagnostic information*/
                              /* return code                         */
    dcl SQL_ERRD_RC fixed bin(31) value(0);
                              /* reason code                         */
    dcl SQL_ERRD_REAS fixed bin(31) value(1);
                              /* nbr rows inserted/updated/deleted   */
    dcl SQL_ERRD_CNT fixed bin(31) value(2);
                              /* optimizer estimate of # rows        */
    dcl SQL_ERRD_OPT_CARD fixed bin(31) value(2);
                              /* obsolete -- do not use --           */
    dcl SQL_ERRD_OPTM fixed bin(31) value(3);
                              /* optimzer estimate of total cost     */
    dcl SQL_ERRD_OPT_TOTCOST fixed bin(31) value(3);
                              /* nbr of cascaded deletes/updates     */
    dcl SQL_ERRD_DCNT fixed bin(31) value(4);
                              /* line number for recompile error     */
    dcl SQL_ERRD_LINE fixed bin(31) value(4);
                              /* diagnostics                         */
    dcl SQL_ERRD_DIAG fixed bin(31) value(5);

 /* Indexes in SQLWARN - Warning flags*/
                              /* composite - set if any warnings     */
    dcl SQL_WARN_ANY fixed bin(31) value(0);
                              /* string column truncated             */
    dcl SQL_WARN_TRUNC fixed bin(31) value(1);
                              /* null values eliminated              */
    dcl SQL_WARN_NUL fixed bin(31) value(2);
                              /* nbr of columns/host vars mismatch   */
    dcl SQL_WARN_MISM fixed bin(31) value(3);
                              /* no WHERE clause in update/delete    */
    dcl SQL_WARN_ALLR fixed bin(31) value(4);
                              /* date has been truncated             */
    dcl SQL_WARN_DATE fixed bin(31) value(6);

 /* Values for Warning flags in SQLWARN*/
                              /* warning indicator                   */
    dcl SQL_WARNING char value('W');
                              /* null terminator truncated warning   */
    dcl SQL_NULL_TRN char value('N');
                              /* no warning indicator                */
    dcl SQL_NO_WARN char value(' ');

 /* SQLDA Constants*/

 /* Increment for type with null indicator */
    dcl SQL_TYP_NULINC fixed bin(31) value(1);

 /* Variable Types                         */
                              /* DATE                                */
    dcl SQL_TYP_DATE fixed bin(31) value(384);
 %dcl SQL_TYP_NDATE char ext;
 %SQL_TYP_NDATE = 'SQL_TYP_DATE+SQL_TYP_NULINC';

                              /* TIME                                */
    dcl SQL_TYP_TIME fixed bin(31) value(388);
 %dcl SQL_TYP_NTIME char ext;
 %SQL_TYP_NTIME = 'SQL_TYP_TIME+SQL_TYP_NULINC';

                              /* TIMESTAMP                           */
    dcl SQL_TYP_STAMP fixed bin(31) value(392);
 %dcl SQL_TYP_NSTAMP char ext;
 %SQL_TYP_NSTAMP = 'SQL_TYP_STAMP+SQL_TYP_NULINC';

                              /* C NUL-terminated graphic str        */
    dcl SQL_TYP_CGSTR fixed bin(31) value(400);
 %dcl SQL_TYP_NCGSTR char ext;
 %SQL_TYP_NCGSTR = 'SQL_TYP_CGSTR+SQL_TYP_NULINC';

                              /* BLOB - varying length string        */
    dcl SQL_TYP_BLOB fixed bin(31) value(404);
 %dcl SQL_TYP_NBLOB char ext;
 %SQL_TYP_NBLOB = 'SQL_TYP_BLOB+SQL_TYP_NULINC';

                              /* CLOB - varying length string        */
    dcl SQL_TYP_CLOB fixed bin(31) value(408);
 %dcl SQL_TYP_NCLOB char ext;
 %SQL_TYP_NCLOB = 'SQL_TYP_CLOB+SQL_TYP_NULINC';

                              /* DBCLOB - varying length string      */
    dcl SQL_TYP_DBCLOB fixed bin(31) value(412);
 %dcl SQL_TYP_NDBCLOB char ext;
 %SQL_TYP_NDBCLOB = 'SQL_TYP_DBCLOB+SQL_TYP_NULINC';

                              /* VARCHAR(i) - varying length string  */
                              /* (2 byte length)                     */
    dcl SQL_TYP_VARCHAR fixed bin(31) value(448);
 %dcl SQL_TYP_NVARCHAR char ext;
 %SQL_TYP_NVARCHAR = 'SQL_TYP_VARCHAR+SQL_TYP_NULINC';

                              /* CHAR(i) - fixed length string       */
    dcl SQL_TYP_CHAR fixed bin(31) value(452);
 %dcl SQL_TYP_NCHAR char ext;
 %SQL_TYP_NCHAR = 'SQL_TYP_CHAR+SQL_TYP_NULINC';

                              /* LONG VARCHAR - varying length       */
                              /* string                              */
    dcl SQL_TYP_LONG fixed bin(31) value(456);
 %dcl SQL_TYP_NLONG char ext;
 %SQL_TYP_NLONG = 'SQL_TYP_LONG+SQL_TYP_NULINC';

                              /* varying length string for C (null   */
                              /* terminated)                         */
    dcl SQL_TYP_CSTR fixed bin(31) value(460);
 %dcl SQL_TYP_NCSTR char ext;
 %SQL_TYP_NCSTR = 'SQL_TYP_CSTR+SQL_TYP_NULINC';

                              /* VARGRAPHIC(i) - varying length      */
                              /* graphic string (2 byte length)      */
    dcl SQL_TYP_VARGRAPH fixed bin(31) value(464);
 %dcl SQL_TYP_NVARGRAPH char ext;
 %SQL_TYP_NVARGRAPH = 'SQL_TYP_VARGRAPH+SQL_TYP_NULINC';

                              /* GRAPHIC(i) - fixed length graphic   */
                              /* string                              */
    dcl SQL_TYP_GRAPHIC fixed bin(31) value(468);
 %dcl SQL_TYP_NGRAPHIC char ext;
 %SQL_TYP_NGRAPHIC = 'SQL_TYP_GRAPHIC+SQL_TYP_NULINC';

                              /* LONG VARGRAPHIC(i) - varying        */
                              /* length graphic string               */
    dcl SQL_TYP_LONGRAPH fixed bin(31) value(472);
 %dcl SQL_TYP_NLONGRAPH char ext;
 %SQL_TYP_NLONGRAPH = 'SQL_TYP_LONGRAPH+SQL_TYP_NULINC';

                              /* varying length string for Pascal    */
                              /* (1-byte length)                     */
    dcl SQL_TYP_LSTR fixed bin(31) value(476);
 %dcl SQL_TYP_NLSTR char ext;
 %SQL_TYP_NLSTR = 'SQL_TYP_LSTR+SQL_TYP_NULINC';

                              /* FLOAT - 8-byte floating point       */
    dcl SQL_TYP_FLOAT fixed bin(31) value(480);
 %dcl SQL_TYP_NFLOAT char ext;
 %SQL_TYP_NFLOAT = 'SQL_TYP_FLOAT+SQL_TYP_NULINC';

                              /* DECIMAL (m,n)                       */
    dcl SQL_TYP_DECIMAL fixed bin(31) value(484);
 %dcl SQL_TYP_NDECIMAL char ext;
 %SQL_TYP_NDECIMAL = 'SQL_TYP_DECIMAL+SQL_TYP_NULINC';

                              /* Zoned Decimal -> DECIMAL (m,n)      */
    dcl SQL_TYP_ZONED fixed bin(31) value(488);
 %dcl SQL_TYP_NZONED char ext;
 %SQL_TYP_NZONED = 'SQL_TYP_ZONED+SQL_TYP_NULINC';

                              /* INTEGER - 4-byte signed integer     */
    dcl SQL_TYP_INTEGER fixed bin(31) value(496);
 %dcl SQL_TYP_NINTEGER char ext;
 %SQL_TYP_NINTEGER = 'SQL_TYP_INTEGER+SQL_TYP_NULINC';

                              /* SMALLINT - 2-byte signed integer    */
    dcl SQL_TYP_SMALL fixed bin(31) value(500);
 %dcl SQL_TYP_NSMALL char ext;
 %SQL_TYP_NSMALL = 'SQL_TYP_SMALL+SQL_TYP_NULINC';

                              /* NUMERIC -> DECIMAL (m,n)            */
    dcl SQL_TYP_NUMERIC fixed bin(31) value(504);
 %dcl SQL_TYP_NNUMERIC char ext;
 %SQL_TYP_NNUMERIC = 'SQL_TYP_NUMERIC+SQL_TYP_NULINC';

                              /* BLOB File - Binary Large Object     */
                              /* File                                */
    dcl SQL_TYP_BLOB_FILE fixed bin(31) value(804);
 %dcl SQL_TYP_NBLOB_FILE char ext;
 %SQL_TYP_NBLOB_FILE = 'SQL_TYP_BLOB_FILE+SQL_TYP_NULINC';

                              /* CLOB File - Char Large Object File  */
    dcl SQL_TYP_CLOB_FILE fixed bin(31) value(808);
 %dcl SQL_TYP_NCLOB_FILE char ext;
 %SQL_TYP_NCLOB_FILE = 'SQL_TYP_CLOB_FILE+SQL_TYP_NULINC';

                              /* DBCLOB File - Double Byte Char      */
                              /* Large Object File                   */
    dcl SQL_TYP_DBCLOB_FILE fixed bin(31) value(812);
 %dcl SQL_TYP_NDBCLOB_FILE char ext;
 %SQL_TYP_NDBCLOB_FILE = 'SQL_TYP_DBCLOB_FILE+SQL_TYP_NULINC';

                              /* BLOB locator                        */
    dcl SQL_TYP_BLOB_LOCATOR fixed bin(31) value(960);
 %dcl SQL_TYP_NBLOB_LOCATOR char ext;
 %SQL_TYP_NBLOB_LOCATOR = 'SQL_TYP_BLOB_LOCATOR+SQL_TYP_NULINC';

                              /* CLOB locator                        */
    dcl SQL_TYP_CLOB_LOCATOR fixed bin(31) value(964);
 %dcl SQL_TYP_NCLOB_LOCATOR char ext;
 %SQL_TYP_NCLOB_LOCATOR = 'SQL_TYP_CLOB_LOCATOR+SQL_TYP_NULINC';

                              /* DBCLOB locator                      */
    dcl SQL_TYP_DBCLOB_LOCATOR fixed bin(31) value(968);
 %dcl SQL_TYP_NDBCLOB_LOCATOR char ext;
 %SQL_TYP_NDBCLOB_LOCATOR = 'SQL_TYP_DBCLOB_LOCATOR+SQL_TYP_NULINC';

 %dcl SQL_LOBTOKEN_LEN char ext;
 %SQL_LOBTOKEN_LEN='SQL_LOBLOCATOR_LEN';
    %dcl @SQL_LOBTOKEN_LEN char ext;
    %@SQL_LOBTOKEN_LEN='@SQL_LOBLOCATOR_LEN';
 %dcl SQL_TYP_BLOB_TOKEN char ext;
 %SQL_TYP_BLOB_TOKEN='SQL_TYP_BLOB_LOCATOR';
    %dcl @SQL_TYP_BLOB_TOKEN char ext;
    %@SQL_TYP_BLOB_TOKEN='@SQL_TYP_BLOB_LOCATOR';
 %dcl SQL_TYP_NBLOB_TOKEN char ext;
 %SQL_TYP_NBLOB_TOKEN='SQL_TYP_NBLOB_LOCATOR';
    %dcl @SQL_TYP_NBLOB_TOKEN char ext;
    %@SQL_TYP_NBLOB_TOKEN='@SQL_TYP_NBLOB_LOCATOR';
 %dcl SQL_TYP_CLOB_TOKEN char ext;
 %SQL_TYP_CLOB_TOKEN='SQL_TYP_CLOB_LOCATOR';
    %dcl @SQL_TYP_CLOB_TOKEN char ext;
    %@SQL_TYP_CLOB_TOKEN='@SQL_TYP_CLOB_LOCATOR';
 %dcl SQL_TYP_NCLOB_TOKEN char ext;
 %SQL_TYP_NCLOB_TOKEN='SQL_TYP_NCLOB_LOCATOR';
    %dcl @SQL_TYP_NCLOB_TOKEN char ext;
    %@SQL_TYP_NCLOB_TOKEN='@SQL_TYP_NCLOB_LOCATOR';
 %dcl SQL_TYP_DBCLOB_TOKEN char ext;
 %SQL_TYP_DBCLOB_TOKEN='SQL_TYP_DBCLOB_LOCATOR';
    %dcl @SQL_TYP_DBCLOB_TOKEN char ext;
    %@SQL_TYP_DBCLOB_TOKEN='@SQL_TYP_DBCLOB_LOCATOR';
 %dcl SQL_TYP_NDBCLOB_TOKEN char ext;
 %SQL_TYP_NDBCLOB_TOKEN='SQL_TYP_NDBCLOB_LOCATOR';
    %dcl @SQL_TYP_NDBCLOB_TOKEN char ext;
    %@SQL_TYP_NDBCLOB_TOKEN='@SQL_TYP_NDBCLOB_LOCATOR';
 %dcl SQL_NCLOB_MAXLEN char ext;
 %SQL_NCLOB_MAXLEN='SQL_DBCLOB_MAXLEN';
    %dcl @SQL_NCLOB_MAXLEN char ext;
    %@SQL_NCLOB_MAXLEN='@SQL_DBCLOB_MAXLEN';
 %dcl SQL_LOBHANDLE_LEN char ext;
 %SQL_LOBHANDLE_LEN='SQL_LOBTOKEN_LEN';
    %dcl @SQL_LOBHANDLE_LEN char ext;
    %@SQL_LOBHANDLE_LEN='@SQL_LOBTOKEN_LEN';
 %dcl SQL_TYP_BLOB_HANDLE char ext;
 %SQL_TYP_BLOB_HANDLE='SQL_TYP_BLOB_TOKEN';
    %dcl @SQL_TYP_BLOB_HANDLE char ext;
    %@SQL_TYP_BLOB_HANDLE='@SQL_TYP_BLOB_TOKEN';
 %dcl SQL_TYP_NBLOB_HANDLE char ext;
 %SQL_TYP_NBLOB_HANDLE='SQL_TYP_NBLOB_TOKEN';
    %dcl @SQL_TYP_NBLOB_HANDLE char ext;
    %@SQL_TYP_NBLOB_HANDLE='@SQL_TYP_NBLOB_TOKEN';
 %dcl SQL_TYP_CLOB_HANDLE char ext;
 %SQL_TYP_CLOB_HANDLE='SQL_TYP_CLOB_TOKEN';
    %dcl @SQL_TYP_CLOB_HANDLE char ext;
    %@SQL_TYP_CLOB_HANDLE='@SQL_TYP_CLOB_TOKEN';
 %dcl SQL_TYP_NCLOB_HANDLE char ext;
 %SQL_TYP_NCLOB_HANDLE='SQL_TYP_NCLOB_TOKEN';
    %dcl @SQL_TYP_NCLOB_HANDLE char ext;
    %@SQL_TYP_NCLOB_HANDLE='@SQL_TYP_NCLOB_TOKEN';
 %dcl SQL_TYP_DBCLOB_HANDLE char ext;
 %SQL_TYP_DBCLOB_HANDLE='SQL_TYP_DBCLOB_TOKEN';
    %dcl @SQL_TYP_DBCLOB_HANDLE char ext;
    %@SQL_TYP_DBCLOB_HANDLE='@SQL_TYP_DBCLOB_TOKEN';
 %dcl SQL_TYP_NDBCLOB_HANDLE char ext;
 %SQL_TYP_NDBCLOB_HANDLE='SQL_TYP_NDBCLOB_TOKEN';
    %dcl @SQL_TYP_NDBCLOB_HANDLE char ext;
    %@SQL_TYP_NDBCLOB_HANDLE='@SQL_TYP_NDBCLOB_TOKEN';

 /* Return Codes for sqlabndx and sqlaprep*/
                              /* The option(s) specified are not     */
                              /* supported by the target  database   */
                              /* and will be ignored                 */
    dcl SQLA_RC_OPT_IGNORED fixed bin(31) value(20);
                              /* Bind execution succeeded with       */
                              /* warnings.                           */
    dcl SQLA_RC_BINDWARN fixed bin(31) value(25);
                              /* Precompilation succeeded with       */
                              /* warnings.                           */
    dcl SQLA_RC_PREPWARN fixed bin(31) value(25);
                              /* Bind execution failed               */
    %dcl SQLA_RC_BINDERROR char ext;
    %SQLA_RC_BINDERROR = '-1';
                              /* Precompilation failed               */
    %dcl SQLA_RC_PREPERROR char ext;
    %SQLA_RC_PREPERROR = '-1';
                              /* Invalid bind file                   */
    %dcl SQLA_RC_BAD_BINDNAME char ext;
    %SQLA_RC_BAD_BINDNAME = '-2';
                              /* Invalid database                    */
    %dcl SQLA_RC_BAD_DBNAME char ext;
    %SQLA_RC_BAD_DBNAME = '-3';
                              /* Invalid message file                */
    %dcl SQLA_RC_BAD_MSGNAME char ext;
    %SQLA_RC_BAD_MSGNAME = '-5';
                              /* Invalid format                      */
    %dcl SQLA_RC_BAD_FORMAT char ext;
    %SQLA_RC_BAD_FORMAT = '-6';
                              /* Error opening list file             */
    %dcl SQLA_RC_OPEN_ERROR char ext;
    %SQLA_RC_OPEN_ERROR = '-31';
                              /* Error opening message file          */
    %dcl SQLA_RC_MFILE_OPEN_ERR char ext;
    %SQLA_RC_MFILE_OPEN_ERR = '-35';
                              /* Source file name is invalid         */
    %dcl SQLA_RC_FILE_NAME_BAD char ext;
    %SQLA_RC_FILE_NAME_BAD = '-36';
                              /* Bind file corrupted                 */
    %dcl SQLA_RC_BAD_BNDFILE char ext;
    %SQLA_RC_BAD_BNDFILE = '-39';
                              /* Bind list errors                    */
    %dcl SQLA_RC_LIST_ERROR char ext;
    %SQLA_RC_LIST_ERROR = '-40';
                              /* Interrupt                           */
    %dcl SQLA_RC_INTERRUPT char ext;
    %SQLA_RC_INTERRUPT = '-94';
                              /* System error                        */
    %dcl SQLA_RC_OSERROR char ext;
    %SQLA_RC_OSERROR = '-1086';
                              /* Prep/Bind already in use            */
    %dcl SQLA_RC_PREP_BIND_BUSY char ext;
    %SQLA_RC_PREP_BIND_BUSY = '-1392';
                              /* Invalid parm. length                */
    %dcl SQLA_RC_OPTION_LEN_BAD char ext;
    %SQLA_RC_OPTION_LEN_BAD = '-4903';
                              /* Invalid parm. ptr                   */
    %dcl SQLA_RC_OPTION_PTR_BAD char ext;
    %SQLA_RC_OPTION_PTR_BAD = '-4904';
                              /* Invalid parm. size                  */
    %dcl SQLA_RC_OPTION_SIZE_BAD char ext;
    %SQLA_RC_OPTION_SIZE_BAD = '-4905';
                              /* Invalid parm. data                  */
    %dcl SQLA_RC_OPTION_DATA_BAD char ext;
    %SQLA_RC_OPTION_DATA_BAD = '-4917';
                              /* Invalid option or option value      */
    %dcl SQLA_RC_OPTION_INVALID char ext;
    %SQLA_RC_OPTION_INVALID = '-4930';
                              /* No SDK/6000 license                 */
    %dcl SQLA_RC_SDK_LICENSE char ext;
    %SQLA_RC_SDK_LICENSE = '-8005';

 /* Values used for the date/time format parameter of sqlabind()     */
 /* ** OBSOLETE   */
 /* **            */
                              /* FORMAT = Default for Country Code   */
    dcl SQL_FMT_DEF char value("DEF");
                              /* FORMAT = USA                        */
    dcl SQL_FMT_USA char value("USA");
                              /* FORMAT = EUR                        */
    dcl SQL_FMT_EUR char value("EUR");
                              /* FORMAT = ISO                        */
    dcl SQL_FMT_ISO char value("ISO");
                              /* FORMAT = JIS                        */
    dcl SQL_FMT_JIS char value("JIS");
                              /* FORMAT = LOCAL                      */
    dcl SQL_FMT_LOC char value("LOC");
                             /* The size of a date/time format buffer*/
    dcl SQL_FMT_LENGTH fixed bin(31) value(3);

 /* Structures used system wide          */

 define structure
    1 sqlchar,                /* General-purpose VARCHAR for         */
                              /* casting */
       2 length fixed bin(15),
       2 data char(1);


 define structure
    1 sqlgraphic,             /* General-purpose VARGRAPHIC for      */
                              /* casting */
       2 length fixed bin(15),
       2 data (1) type wchar_t;


 define structure
    1 sqllob,                 /* General-purpose LOB for casting     */
       2 length unsigned fixed bin(31) ,
       2 data(1) char(1);


 define structure
   1 sqldbclob,   /* General-purpose DBCLOB for casting  */
       2 length unsigned fixed bin(31) ,
       2 data dim(0:1-1) type wchar_t;


 define structure
   1 sqlfile,   /* File reference structure for LOBs   */
       2 name_length unsigned fixed bin(31) ,
       2 data_length unsigned fixed bin(31) ,
       2 file_options unsigned fixed bin(31) ,
       2 name char(255);


 /* Values used for file_options in the sqlfile structure*/
                              /* Input file to read from             */
    dcl SQL_FILE_READ fixed bin(31) value(2);
                              /* Output file - new file to be        */
                              /* created                             */
    dcl SQL_FILE_CREATE fixed bin(31) value(8);
                              /* Output file - overwrite existing    */
                              /* file or create a new file if it     */
                              /* doesn't exist                       */
    dcl SQL_FILE_OVERWRITE fixed bin(31) value(16);
                              /* Output file - append to an          */
                              /* existing file or create a new file  */
                              /* if it doesn't exist                 */
    dcl SQL_FILE_APPEND fixed bin(31) value(32);

 /* Structure used to store binder options when calling sqlabndr() */
 /* or sqlabndx() or to store precompile options when calling      */
 /* sqlaprep().                                                    */

 %dcl sqlbindopt char ext;
 %sqlbindopt='sqloptionS';
    %dcl @sqlbindopt char ext;
    %@sqlbindopt='@sqloptionS';

    %dcl SQL_BIND_OPTS char ext;
    %if SQL_BIND_OPTS = '' %then
     %do;

  define structure                    /* Header for sqlopt structure */
    1 sqloptheader,
                                      /* Number of options allocated */
          2 allocated unsigned fixed bin(31) ,
           2 used unsigned fixed bin(31) ; /* Number of options used */


 define structure
    1 sqloptions,                       /* bind/prep option          */
          2 type unsigned fixed bin(31) ,/* Type of bind/prep option */
          2 val unsigned fixed bin(31) ;/* Value of bind/prep option */


 define structure
   1 sqlopt,
           2 header type sqloptheader,/* Header for sqlopt structure */
                                       /* Array of bind/prep options */
          2 option dim(0:1-1) type sqloptions;


       %dcl SQL_BIND_OPTS char ext;
       %SQL_BIND_OPTS = 'Y';
     %end;

 /* Values used for option[n].type in the sqloptions structure*/
 /* of sqlabndx() and sqlaprep().                             */
                              /* Option for date/time format - bind  */
                              /* and precompile option               */
    dcl SQL_DATETIME_OPT fixed bin(31) value(1);
                              /* Option for standards level          */
                              /* compliance - precompile option      */
                              /* only                                */
    dcl SQL_STANDARDS_OPT fixed bin(31) value(2);
                              /* Option for isolation level - bind   */
                              /* and precompile option               */
    dcl SQL_ISO_OPT fixed bin(31) value(4);
                              /* Option for record blocking - bind   */
                              /* and precompile option               */
    dcl SQL_BLOCK_OPT fixed bin(31) value(5);
                              /* Option for granting privileges -    */
                              /* bind option only                    */
    dcl SQL_GRANT_OPT fixed bin(31) value(6);
                              /* Option for the Flagger -            */
                              /* precompile option only              */
    dcl SQL_FLAG_OPT fixed bin(31) value(8);
                              /* Specifies whether one or multiple   */
                              /* connections are allowed             */
                              /* similtaneously within a unit of     */
                              /* work.                               */
    dcl SQL_CONNECT_OPT fixed bin(31) value(16);
                              /* Specifies the set of rules used     */
                              /* for connection to multiple          */
                              /* databases within a single unit of   */
                              /* work                                */
    dcl SQL_RULES_OPT fixed bin(31) value(17);
                              /* Specifies which of multiple         */
                              /* databases connected to will be      */
                              /* disconnected when a COMMIT or       */
                              /* ROLLBACK is issued.                 */
    dcl SQL_DISCONNECT_OPT fixed bin(31) value(18);
                              /* Specifies what syncpoint option     */
                              /* (for example one phase or two       */
                              /* phase) will be used                 */
    dcl SQL_SYNCPOINT_OPT fixed bin(31) value(19);
                              /* Option to create a bind file -      */
                              /* precompile option only              */
    dcl SQL_BIND_OPT fixed bin(31) value(20);
                              /* Option specifies SAA/non-SAA        */
                              /* compatibility - FORTRAN precompile  */
                              /* option only                         */
    dcl SQL_SAA_OPT fixed bin(31) value(21);
                              /* Option to create a package with a   */
                              /* specific name - precompile option   */
                              /* only                                */
    dcl SQL_PKG_OPT fixed bin(31) value(23);
                              /* Option to specify SQLDA             */
                              /* optimization - precompile option    */
                              /* only                                */
    dcl SQL_OPTIM_OPT fixed bin(31) value(24);
                              /* Option to not create a package or   */
                              /* bind file - precompile option only  */
    dcl SQL_SYNTAX_OPT fixed bin(31) value(25);
                                     /* Indicates under what         */
                              /* conditions a package will be be     */
                              /* created - bind and precompile       */
                              /* option                              */
 %dcl SQL_SQLERROR_OPT char ext;
 %SQL_SQLERROR_OPT='SQL_SYNTAX_OPT';
    %dcl @SQL_SQLERROR_OPT char ext;
    %@SQL_SQLERROR_OPT='@SQL_SYNTAX_OPT';
                              /* Option to suppress #line macro      */
                              /* generation in modified source file  */
                              /* - C precompile option only          */
    dcl SQL_LINEMACRO_OPT fixed bin(31) value(26);
                              /* 'No-op' option - ignore this entry  */
                              /* in the option array - bind and      */
                              /* precompile option                   */
    dcl SQL_NO_OPT fixed bin(31) value(27);
                              /* Level of a module - precompile      */
                              /* option only                         */
    dcl SQL_LEVEL_OPT fixed bin(31) value(30);
                              /* Package collection identifier -     */
                              /* precompile option only              */
    dcl SQL_COLLECTION_OPT fixed bin(31) value(31);
                              /* Package version identifier -        */
                              /* precompile option only              */
    dcl SQL_VERSION_OPT fixed bin(31) value(32);
                              /* Package owner authorization         */
                              /* identifier - bind and precompile    */
                              /* option                              */
    dcl SQL_OWNER_OPT fixed bin(31) value(33);
                                    /* Synonym for owner - bind and  */
                              /* precompile option                   */
 %dcl SQL_SCHEMA_OPT char ext;
 %SQL_SCHEMA_OPT='SQL_OWNER_OPT';
    %dcl @SQL_SCHEMA_OPT char ext;
    %@SQL_SCHEMA_OPT='@SQL_OWNER_OPT';
                              /* Authorization identifier that is    */
                              /* to be used as a qualifier for       */
                              /* unqualified objects - bind and      */
                              /* precompile option                   */
    dcl SQL_QUALIFIER_OPT fixed bin(31) value(34);
                                        /* Synonym for qualifier -   */
                              /* bind and precompile option          */
 %dcl SQL_CATALOG_OPT char ext;
 %SQL_CATALOG_OPT='SQL_QUALIFIER_OPT';
    %dcl @SQL_CATALOG_OPT char ext;
    %@SQL_CATALOG_OPT='@SQL_QUALIFIER_OPT';
                              /* Package description - bind and      */
                              /* precompile option                   */
    dcl SQL_TEXT_OPT fixed bin(31) value(35);
                              /* Indicates when object validation    */
                              /* occurs - bind and precompile        */
                              /* option                              */
    dcl SQL_VALIDATE_OPT fixed bin(31) value(40);
                              /* Determines whether information      */
                              /* will be produced about how the SQL  */
                              /* statements in a package will be     */
                              /* executed - bind and precompile      */
                              /* option                              */
    dcl SQL_EXPLAIN_OPT fixed bin(31) value(41);
                              /* Indicates whether a package is to   */
                              /* be added or replaced - bind and     */
                              /* precompile option                   */
    dcl SQL_ACTION_OPT fixed bin(31) value(42);
                              /* Replaces a specific version of a    */
                              /* package - bind and precompile       */
                              /* option                              */
    dcl SQL_REPLVER_OPT fixed bin(31) value(44);
                              /* Indicates whether EXECUTE           */
                              /* authorities are to be preserved     */
                              /* when a package is replaced - bind   */
                              /* and precompile option               */
    dcl SQL_RETAIN_OPT fixed bin(31) value(45);
                              /* Indicates whether resources are     */
                              /* released at each COMMIT or when     */
                              /* the application  terminates - bind  */
                              /* and precompile option               */
    dcl SQL_RELEASE_OPT fixed bin(31) value(46);
                              /* Specifies whether or not the query  */
                              /* is executed using I/O parallelism   */
                              /*  bind and precompile option         */
    dcl SQL_DEGREE_OPT fixed bin(31) value(47);
                              /* Designates whether an apostrophe    */
                              /* or quote will be used as a string   */
                              /* delimiter - bind and precompile     */
                              /* option                              */
    dcl SQL_STRDEL_OPT fixed bin(31) value(50);
                              /* Designates whether a period or      */
                              /* comma will be used as a decimal     */
                              /* point indicator - bind and          */
                              /* precompile option                   */
    dcl SQL_DECDEL_OPT fixed bin(31) value(51);
                              /* Designates default character        */
                              /* subtype that is to be used for      */
                              /* column definitions in the CREATE    */
                              /* and ALTER TABLE SQL statements -    */
                              /* bind and precompile option          */
    dcl SQL_CHARSUB_OPT fixed bin(31) value(55);
                              /* Designates what CCSID will be used  */
                              /* for single byte characters for      */
                              /* character column definitions        */
                              /* without a specific CCSID clause in  */
                              /* the CREATE and ALTER TABLE SQL      */
                              /* statements - bind and precompile    */
                              /* option                              */
    dcl SQL_CCSIDS_OPT fixed bin(31) value(56);
                              /* Designates what CCSID will be used  */
                              /* for mixed byte characters for       */
                              /* character column definitions        */
                              /* without a specific CCSID clause in  */
                              /* the CREATE and ALTER TABLE SQL      */
                              /* statements - bind and precompile    */
                              /* option                              */
    dcl SQL_CCSIDM_OPT fixed bin(31) value(57);
                              /* Designates what CCSID will be used  */
                              /* for double byte characters for      */
                              /* character column definitions        */
                              /* without a specific CCSID clause in  */
                              /* the CREATE and ALTER TABLE SQL      */
                              /* statements - bind and precompile    */
                              /* option                              */
    dcl SQL_CCSIDG_OPT fixed bin(31) value(58);
                              /* Specifies maximum precision to be   */
                              /* used in decimal arithmetic          */
                              /* operations - bind and precompile    */
                              /* option                              */
    dcl SQL_DEC_OPT fixed bin(31) value(59);
                              /* Specifies wchar_t type to be used   */
                              /*  precompile only                    */
    dcl SQL_WCHAR_OPT fixed bin(31) value(60);
                              /* Specifies which authorization       */
                              /* identifier to use when dynamic SQL  */
                              /* in a package is executed. Owner of  */
                              /* package or authid executing         */
                              /* package - bind and precompile       */
                              /* option                              */
    dcl SQL_DYNAMICRULES_OPT fixed bin(31) value(61);
                              /* Buffers VALUE inserts - bind and    */
                              /* precompile option for DB2/PE        */
                              /* servers only                        */
    dcl SQL_INSERT_OPT fixed bin(31) value(62);
                              /* Capture explain snapshot - bind     */
                              /* and precompile option               */
    dcl SQL_EXPLSNAP_OPT fixed bin(31) value(63);
                              /* Path for user-defined function      */
                              /* resolution - bind and precompile    */
                              /* option                              */
    dcl SQL_FUNCTION_PATH fixed bin(31) value(64);
                              /* Disable prepare-time SQL warnings   */
                              /*  bind and precompile option         */
    dcl SQL_SQLWARN_OPT fixed bin(31) value(65);
                              /* Set query optimization class -      */
                              /* bind and precompile option          */
    dcl SQL_QUERYOPT_OPT fixed bin(31) value(66);
                              /* Target compiler - precompile        */
                              /* option                              */
    dcl SQL_TARGET_OPT fixed bin(31) value(67);

 /* Values used for option[n].val when option[n].type is*/
 /* SQL_DATETIME_OPT. These can also be used for the date/time*/
 /* format parameter of sqlabind().                           */

                              /* FORMAT = Default for Country Code   */
    dcl SQL_DATETIME_DEF fixed bin(31) value(48);
                              /* FORMAT = USA                        */
    dcl SQL_DATETIME_USA fixed bin(31) value(49);
                              /* FORMAT = EUR                        */
    dcl SQL_DATETIME_EUR fixed bin(31) value(50);
                              /* FORMAT = ISO                        */
    dcl SQL_DATETIME_ISO fixed bin(31) value(51);
                              /* FORMAT = JIS                        */
    dcl SQL_DATETIME_JIS fixed bin(31) value(52);
                              /* FORMAT = LOCAL                      */
    dcl SQL_DATETIME_LOC fixed bin(31) value(53);

 /* The following constants are here for backwards compatbility with */
 /* earlier  releases.*/

 %dcl SQL_FRMT_OPT char ext;
 %SQL_FRMT_OPT='SQL_DATETIME_OPT';
    %dcl @SQL_FRMT_OPT char ext;
    %@SQL_FRMT_OPT='@SQL_DATETIME_OPT';
 %dcl SQL_FMT_0 char ext;
 %SQL_FMT_0='SQL_DATETIME_DEF';
    %dcl @SQL_FMT_0 char ext;
    %@SQL_FMT_0='@SQL_DATETIME_DEF';
 %dcl SQL_FMT_1 char ext;
 %SQL_FMT_1='SQL_DATETIME_USA';
    %dcl @SQL_FMT_1 char ext;
    %@SQL_FMT_1='@SQL_DATETIME_USA';
 %dcl SQL_FMT_2 char ext;
 %SQL_FMT_2='SQL_DATETIME_EUR';
    %dcl @SQL_FMT_2 char ext;
    %@SQL_FMT_2='@SQL_DATETIME_EUR';
 %dcl SQL_FMT_3 char ext;
 %SQL_FMT_3='SQL_DATETIME_ISO';
    %dcl @SQL_FMT_3 char ext;
    %@SQL_FMT_3='@SQL_DATETIME_ISO';
 %dcl SQL_FMT_4 char ext;
 %SQL_FMT_4='SQL_DATETIME_JIS';
    %dcl @SQL_FMT_4 char ext;
    %@SQL_FMT_4='@SQL_DATETIME_JIS';
 %dcl SQL_FMT_5 char ext;
 %SQL_FMT_5='SQL_DATETIME_LOC';
    %dcl @SQL_FMT_5 char ext;
    %@SQL_FMT_5='@SQL_DATETIME_LOC';

 /* Values used for option[n].val when option[n].type is */
 /* SQL_STANDARDS_OPT.    */
                              /* SAA Level 1 Database CPI            */
    dcl SQL_SAA_COMP fixed bin(31) value(0);
                              /* MIA                                 */
    dcl SQL_MIA_COMP fixed bin(31) value(1);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_ISO_OPT*/
                              /* Repeatable read level               */
    dcl SQL_REP_READ fixed bin(31) value(0);
                              /* Cursor stability level              */
    dcl SQL_CURSOR_STAB fixed bin(31) value(1);
                              /* Uncommitted read level              */
    dcl SQL_UNCOM_READ fixed bin(31) value(2);
                              /* Read stability level                */
    dcl SQL_READ_STAB fixed bin(31) value(3);
                              /* No Commit level      l              */
    dcl SQL_NO_COMMIT fixed bin(31) value(4);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_BLOCK_OPT */
                              /* Block Unambiguous cursors           */
    dcl SQL_BL_UNAMBIG fixed bin(31) value(0);
                              /* Block All cursors                   */
    dcl SQL_BL_ALL fixed bin(31) value(1);
                              /* Block No cursors                    */
    dcl SQL_NO_BL fixed bin(31) value(2);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_FLAG_OPT */
                              /* Flagger check against MVS           */
                              /* DB2 V2.3, V3.1 or V4.1 SQL          */
                              /* syntax                              */
    dcl SQL_MVSDB2V23_SYNTAX fixed bin(31) value(4);
    dcl SQL_MVSDB2V31_SYNTAX fixed bin(31) value(5);
    dcl SQL_MVSDB2V41_SYNTAX fixed bin(31) value(6);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_SAA_OPT. */
                              /* SQLCA definition not SAA            */
                              /* compatible                          */
    dcl SQL_SAA_NO fixed bin(31) value(0);
                              /* SQLCA definition is SAA compatible  */
    dcl SQL_SAA_YES fixed bin(31) value(1);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_OPTIM_OPT.         */
                              /* Do not optimize SQLDA               */
                              /* initialization                      */
    dcl SQL_DONT_OPTIMIZE fixed bin(31) value(0);
                              /* Optimize SQLDA initialization       */
    dcl SQL_OPTIMIZE fixed bin(31) value(1);

 /* Values used for option[n].val when option[n].type is  */
 /* SQL_SYNTAX_OPT.       */
                              /* Create a package and/or a bind      */
                              /* file                                */
    dcl SQL_NO_SYNTAX_CHECK fixed bin(31) value(0);
                              /* Do not create a package or bind     */
                              /* file                                */
    dcl SQL_SYNTAX_CHECK fixed bin(31) value(1);

 /* Values used for option[n].val when option[n].type is  */
 /* SQL_LINEMACRO_OPT.    */
                              /* Do not generate #line macros in     */
                              /* modified source file                */
    dcl SQL_NO_LINE_MACROS fixed bin(31) value(0);
                              /* Generate #line macros in modified   */
                              /* source file                         */
    dcl SQL_LINE_MACROS fixed bin(31) value(1);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_WCHAR_OPT.         */
                              /* wchar_t not converted               */
    dcl SQL_WCHAR_NOCONVERT fixed bin(31) value(0);
                              /* wchar_t converted                   */
    dcl SQL_WCHAR_CONVERT fixed bin(31) value(1);

 /* Maximum sqlchar length for option[n].val when option[n].type is  */
 /* SQL_LEVEL_OPT */
    dcl SQL_MAX_LEVEL fixed bin(31) value(8);

 /* Maximum sqlchar length for option[n].val when option[n].type is  */
 /* SQL_COLLECTION_OPT */
    dcl SQL_MAX_COLLECTION fixed bin(31) value(8);

 /* Maximum sqlchar length for option[n].val when option[n].type is  */
 /* SQL_VERSION_OPT */
    dcl SQL_MAX_VERSION fixed bin(31) value(254);

 /* Maximum sqlchar length for option[n].val when option[n].type is  */
 /* SQL_OWNER_OPT */
    dcl SQL_MAX_OWNER fixed bin(31) value(8);

 /* Maximum sqlchar length for option[n].val when option[n].type is  */
 /* SQL_SCHEMA_OPT */
 %dcl SQL_MAX_SCHEMA char ext;
 %SQL_MAX_SCHEMA='SQL_MAX_OWNER';
    %dcl @SQL_MAX_SCHEMA char ext;
    %@SQL_MAX_SCHEMA='@SQL_MAX_OWNER';

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQL_QUALIFIER_OPT */
    dcl SQL_MAX_QUALIFIER fixed bin(31) value(18);

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQL_CATALOG_OPT */
 %dcl SQL_MAX_CATALOG char ext;
 %SQL_MAX_CATALOG='SQL_MAX_QUALIFIER';
    %dcl @SQL_MAX_CATALOG char ext;
    %@SQL_MAX_CATALOG='@SQL_MAX_QUALIFIER';

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQL_TEXT_OPT */
    dcl SQL_MAX_TEXT fixed bin(31) value(255);

 /* Values used for option[n].val when option[n].type is            */
 /* SQL_VALIDATE_OPT      */
                              /* Validate objects during BIND        */
    dcl SQL_VALIDATE_BIND fixed bin(31) value(0);
                              /* Validate objects during execution   */
    dcl SQL_VALIDATE_RUN fixed bin(31) value(1);

 /* Values used for option[n].val when option[n].type is  */
 /* SQL_EXPLAIN_OPT       */
                              /* No EXPLAIN output produced          */
    dcl SQL_EXPLAIN_NO fixed bin(31) value(0);
                              /* EXPLAIN output produced execution   */
    dcl SQL_EXPLAIN_YES fixed bin(31) value(1);

 /* Values used for option[n].val when option[n].type is  */
 /* SQL_ACTION_OPT         */
                              /* Package is to be added              */
    dcl SQL_ACTION_ADD fixed bin(31) value(0);
                              /* Package is to be replaced           */
    dcl SQL_ACTION_REPLACE fixed bin(31) value(1);

 /* Maximum sqlchar length for option[n].val when option[n].type is  */
 /* SQL_REPLVER_OPT */
    dcl SQL_MAX_REPLVER fixed bin(31) value(254);

 /* Values used for option[n].val when option[n].type is  */
 /* SQL_SQLERROR_OPT      */
                                          /* Do not create a         */
                              /* package if errors are encountered   */
 %dcl SQL_SQLERROR_NOPACKAGE char ext;
 %SQL_SQLERROR_NOPACKAGE='SQL_NO_SYNTAX_CHECK';
    %dcl @SQL_SQLERROR_NOPACKAGE char ext;
    %@SQL_SQLERROR_NOPACKAGE='@SQL_NO_SYNTAX_CHECK';
                                       /* Do not create a package    */
 %dcl SQL_SQLERROR_CHECK char ext;
 %SQL_SQLERROR_CHECK='SQL_SYNTAX_CHECK';
    %dcl @SQL_SQLERROR_CHECK char ext;
    %@SQL_SQLERROR_CHECK='@SQL_SYNTAX_CHECK';
                              /* Create a package even if errors     */
                              /* are encountered                     */
    dcl SQL_SQLERROR_CONTINUE fixed bin(31) value(2);

 /* Values used for option[n].val when option[n].type is  */
 /* SQL_RETAIN_OPT         */
                              /* Do not preserve EXECUTE             */
                              /* authorities when a package is       */
                              /* replaced                            */
    dcl SQL_RETAIN_NO fixed bin(31) value(0);
                              /* Preserve EXECUTE authorities when   */
                              /* a package is replaced               */
    dcl SQL_RETAIN_YES fixed bin(31) value(1);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_RELEASE_OPT       */
                              /* Release resources at COMMIT         */
    dcl SQL_RELEASE_COMMIT fixed bin(31) value(0);
                              /* Release resources when the program  */
                              /* terminates                          */
    dcl SQL_RELEASE_DEALLOCATE fixed bin(31) value(1);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_STRDEL_OPT         */
                              /* Apostrophe string delimiter         */
    dcl SQL_STRDEL_APOSTROPHE fixed bin(31) value(0);
                              /* Quote string delimiter              */
    dcl SQL_STRDEL_QUOTE fixed bin(31) value(1);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_DECDEL_OPT         */
                              /* Period is used as a decimal point   */
                              /* indicator in decimal and floating   */
                              /* point literals                      */
    dcl SQL_DECDEL_PERIOD fixed bin(31) value(0);
                              /* Comma is used as a decimal point    */
                              /* indicator in decimal and floating   */
                              /* point literals                      */
    dcl SQL_DECDEL_COMMA fixed bin(31) value(1);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_CHARSUB_OPT       */
                              /* Use the target system defined       */
                              /* default for all new character       */
                              /* columns for which an explicit       */
                              /* subtype is not specified            */
    dcl SQL_CHARSUB_DEFAULT fixed bin(31) value(0);
                              /* Use the BIT character subtype for   */
                              /* all new character columns for       */
                              /* which an explicit subtype is not    */
                              /* specified                           */
    dcl SQL_CHARSUB_BIT fixed bin(31) value(1);
                              /* Use the SBCS character subtype for  */
                              /* all new character columns for       */
                              /* which an explicit subtype is not    */
                              /* specified                           */
    dcl SQL_CHARSUB_SBCS fixed bin(31) value(2);
                              /* Use the mixed character subtype     */
                              /* for all new character columns for   */
                              /* which an explicit subtype is not    */
                              /* specified                           */
    dcl SQL_CHARSUB_MIXED fixed bin(31) value(3);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_DEC_OPT */
                              /* 15 bit precision is used in         */
                              /* decimal arithmetic operations       */
    dcl SQL_DEC_15 fixed bin(31) value(15);
                              /* 31 bit precision is used in         */
                              /* decimal arithmetic operations       */
    dcl SQL_DEC_31 fixed bin(31) value(31);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_DEGREE_OPT         */
                              /* Prohibits parallel I/O operations   */
    dcl SQL_DEGREE_1 fixed bin(31) value(1);
                              /* Allows the target database system   */
                              /* to determine the degree of          */
                              /* parallel I/O operations             */
    dcl SQL_DEGREE_ANY fixed bin(31) value(0);
                              /* Maximum value                       */
    dcl SQL_MAX_DEGREE_VAL fixed bin(31) value(32767);

 /* The next four option values (for CONNECT type, SQLRULES, */
 /* DISCONNECT and SYNCPOINT) are used not only by the precompiler */
 /* but also by the sqlesetc and sqleqryc APIs. */

 /* Values used for option[n].val when option[n].type is  */
 /* SQL_CONNECT_OPT       */
                              /* Indicates that only one connection  */
                              /* to a database can exist at any      */
                              /* given time.                         */
    dcl SQL_CONNECT_1 fixed bin(31) value(1);
                              /* Indicates that multiple             */
                              /* connections can exist               */
                              /* simultaneously, with one being      */
                              /* active and the others dormant.      */
    dcl SQL_CONNECT_2 fixed bin(31) value(2);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_RULES_OPT */
                              /* Indicates that CONNECT TO can be    */
                              /* used to make a dormant connection   */
                              /* the current connection.             */
    dcl SQL_RULES_DB2 fixed bin(31) value(1);
                              /* Indicates that CONNECT TO is not    */
                              /* valid for making a dormant          */
                              /* connection current, and SET         */
                              /* CONNECTION must be used instead.    */
    dcl SQL_RULES_STD fixed bin(31) value(2);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_DISCONNECT_OPT    */
                              /* Indicates that all connections      */
                              /* marked by the RELEASE statement     */
                              /* will be the only connections        */
                              /* released when a COMMIT is issued.   */
    dcl SQL_DISCONNECT_EXPL fixed bin(31) value(1);
                              /* Indicates that all connections      */
                              /* that do not have open WITH HOLD     */
                              /* cursors will be the only            */
                              /* connections released when a COMMIT  */
                              /* is issued.                          */
    dcl SQL_DISCONNECT_COND fixed bin(31) value(2);
                              /* Indicates that all connections      */
                              /* will be released when a COMMIT is   */
                              /* issued.                             */
    dcl SQL_DISCONNECT_AUTO fixed bin(31) value(3);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_SYNCPOINT_OPT     */
                              /* Do not use a transaction manager    */
                              /* to perform two phase commit, but    */
                              /* enforce that there is only one      */
                              /* database is updated when multiple   */
                              /* databases are accessed within a     */
                              /* single transaction.                 */
    dcl SQL_SYNC_ONEPHASE fixed bin(31) value(1);
                              /* Use a transaction manager to        */
                              /* coordinate two phase commit.        */
    dcl SQL_SYNC_TWOPHASE fixed bin(31) value(2);
                              /* No update enforcement or two phase  */
                              /* commit protocol will be used.       */
    dcl SQL_SYNC_NONE fixed bin(31) value(0);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_DYNAMICRULES_OPT  */
                              /* Dynamic SQL in package will use     */
                              /* authid of person running the        */
                              /* package                             */
    dcl SQL_DYNAMICRULES_RUN fixed bin(31) value(0);
                              /* Dynamic SQL in package will use     */
                              /* authid of person who owns the       */
                              /* package                             */
    dcl SQL_DYNAMICRULES_BIND fixed bin(31) value(1);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_INSERT_OPT         */
                              /* Do not buffer VALUE inserts         */
    dcl SQL_INSERT_DEF fixed bin(31) value(0);
                              /* Buffer VALUE inserts                */
    dcl SQL_INSERT_BUF fixed bin(31) value(1);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_EXPLSNAP_OPT      */
                              /* Do not save explain snapshot        */
    dcl SQL_EXPLSNAP_NO fixed bin(31) value(0);
                              /* Save explain snapshot               */
    dcl SQL_EXPLSNAP_YES fixed bin(31) value(1);
                              /* Save explain snapshot for all       */
                              /* static and dynamic statements       */
    dcl SQL_EXPLSNAP_ALL fixed bin(31) value(2);

 /* Maximum sqlchar length for option[n].val when option[n].type is  */
 /* SQL_FUNCTION_PATH */
    dcl SQL_MAX_FUNCPATH fixed bin(31) value(254);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_SQLWARN_OPT       */
                              /* Suppress prepare-time warning       */
                              /* SQLCODEs                            */
    dcl SQL_SQLWARN_NO fixed bin(31) value(0);
                              /* Permit prepare-time warning         */
                              /* SQLCODEs                            */
    dcl SQL_SQLWARN_YES fixed bin(31) value(1);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_QUERYOPT_OPT      */
                              /* Class 0 query optimization          */
    dcl SQL_QUERYOPT_0 fixed bin(31) value(0);
                              /* Class 1 query optimization          */
    dcl SQL_QUERYOPT_1 fixed bin(31) value(1);
                              /* Class 3 query optimization          */
    dcl SQL_QUERYOPT_3 fixed bin(31) value(3);
                              /* Class 5 query optimization          */
    dcl SQL_QUERYOPT_5 fixed bin(31) value(5);
                              /* Class 9 query optimization          */
    dcl SQL_QUERYOPT_9 fixed bin(31) value(9);

 /* Maximum sqlchar length for option[n].val when option[n].type is  */
 /* SQL_TARGET_OPT */
    dcl SQL_MAX_TARGET_LEN fixed bin(31) value(32);

 /* Binder Interface Parameters/Return Codes */

                                  /* BINDER (obsolete interface)     */
    dcl   sqlabind  entry (
           pointer,               /* bind file name                  */
           pointer,               /* database                        */
           pointer,               /* spare                           */
           pointer,               /* message file                    */
           pointer,               /* date/time format                */
           pointer)               /* SQLCA                           */
             returns( byvalue optional SQL_API_RC )
              SQL_API_FN external;

                                  /* BINDER (obsolete interface)     */
    dcl   sqlabndr  entry (
           pointer,               /* bind file name                  */
           pointer,               /* database                        */
           pointer,               /* message file                    */
            handle sqlopt,        /* binder options                  */
            pointer)              /* SQLCA                           */
             returns( byvalue optional SQL_API_RC )
              SQL_API_FN external;

                                  /* Bind                            */
    dcl   sqlabndx  entry (
           pointer,               /* bind file name                  */
           pointer,               /* message file                    */
           handle sqlopt,         /* bind options                    */
            pointer)              /* SQLCA                           */
             returns( byvalue optional SQL_API_RC )
              SQL_API_FN external;

                                  /* Rebind                          */
    dcl   sqlarbnd  entry (
           pointer,               /* package name                    */
           pointer,               /* SQLCA                           */
            pointer)              /* reserved                        */
             returns( byvalue optional SQL_API_RC )
              SQL_API_FN external;

                                  /* Precompile Program              */
    dcl   sqlaprep  entry (
           pointer,               /* source file name                */
           pointer,               /* message file name               */
           handle sqlopt,         /* precompile options              */
            pointer)              /* SQLCA                           */
             returns( byvalue optional SQL_API_RC )
              SQL_API_FN external;

 /* Generic Interfaces to the Binder and Precompiler */

                                  /* BINDER (obsolete interface)     */
    dcl   SQLGBIND  entry (
           unsigned fixed bin(16),/* spare1                          */
           unsigned fixed bin(16),/* message file length             */
           unsigned fixed bin(16),/* format option length            */
           unsigned fixed bin(16),/* bind file name length           */
           unsigned fixed bin(16),/* database name length            */
           pointer,               /* SQLCA                           */
           pointer,               /* spare2                          */
           pointer,               /* message file                    */
           pointer,               /* date/time format                */
           pointer,               /* bind file name                  */
           pointer)               /* database                        */
             returns( byvalue optional SQL_API_RC )
              SQL_API_FN external;

                                  /* BINDER (obsolete interface)     */
    dcl   SQLGBNDR  entry (
           unsigned fixed bin(16),/* bind file name length           */
           unsigned fixed bin(16),/* database name length            */
           unsigned fixed bin(16),/* message file name length        */
           pointer,               /* bind file name                  */
           pointer,               /* database                        */
           pointer,               /* message file                    */
           handle sqlopt,         /* binder options                  */
           pointer)               /* SQLCA                           */
             returns( byvalue optional SQL_API_RC )
              SQL_API_FN external;


                                  /* Bind                            */
    dcl   sqlgbndx  entry (
           unsigned fixed bin(16),/* message file name length        */
           unsigned fixed bin(16),/* bind file name length           */
           pointer,               /* SQLCA                           */
           handle sqlopt,         /* binder options                  */
           pointer,               /* message file                    */
            pointer)              /* bind file name                  */
             returns( byvalue optional SQL_API_RC )
              SQL_API_FN external;

                                  /* Rebind                          */
    dcl   sqlgrbnd  entry (
           unsigned fixed bin(16),/* package name length             */
           pointer,               /* package name                    */
           pointer,               /* SQLCA                           */
           pointer)               /* reserved                        */
             returns( byvalue optional SQL_API_RC )
              SQL_API_FN external;

                                  /* Precompile Program              */
    dcl   sqlgprep  entry (
           unsigned fixed bin(16),/* message file name length        */
           unsigned fixed bin(16),/* source file name length         */
           pointer,               /* SQLCA                           */
           handle sqlopt,         /* precompile options              */
           pointer,               /* message file name               */
            pointer)              /* source file name                */
             returns( byvalue optional SQL_API_RC )
              SQL_API_FN external;

 /* Error/SQLSTATE Message Retrieval Interface Parameters/Return */
 /* Codes */

                                  /* Get Error Message               */
    dcl   sqlaintp_api  entry (
           pointer,               /* buffer for message text         */
           fixed bin(15),         /* buffer size                     */
           fixed bin(15),         /* line width                      */
           pointer,               /* message file                    */
            pointer)              /* SQLCA                           */
             returns( byvalue optional SQL_API_RC )
              SQL_API_FN external;

 /* Generic Interface to Error Message Retrieval */
                                  /* Get Error Message               */
    dcl   sqlgintp  entry (
           fixed bin(15),         /* buffer size                     */
           fixed bin(15),         /* line width                      */
           pointer,               /* SQLCA                           */
            pointer)              /* buffer                          */
             returns( byvalue optional SQL_API_RC )
              SQL_API_FN external;

                                  /* Sqlstate Message Retrieval      */
    dcl   sqlogstt  entry (
           pointer,               /* buffer for message text         */
           fixed bin(15),         /* buffer size                     */
           fixed bin(15),         /* line width                      */
            pointer)              /* sqlstate                        */
             returns( byvalue optional SQL_API_RC )
              SQL_API_FN external;

 /* Generic Interface to SQLSTATE Message Retrieval */
                                  /* Sqlstate Message Retrieval      */
    dcl   sqlggstt  entry (
           fixed bin(15),         /* buffer size                     */
           fixed bin(15),         /* line width                      */
           pointer,               /* sqlstate                        */
            pointer)              /* buffer                          */
             returns( byvalue optional SQL_API_RC )
              SQL_API_FN external;

 /* Return Codes for sqlaintp/sqlogstt */
                              /* insufficient memory for msg file    */
    %dcl SQLA_ERR_BADCC char ext;
    %SQLA_ERR_BADCC = '-1';
                              /* no error code in SQLCA              */
    %dcl SQLA_ERR_NOCOD char ext;
    %SQLA_ERR_NOCOD = '-2';
                              /* message file inaccessible or        */
                              /* incorrect                           */
    %dcl SQLA_ERR_NOMSG char ext;
    %SQLA_ERR_NOMSG = '-3';
                              /* specified line length negative      */
    %dcl SQLA_ERR_BADLL char ext;
    %SQLA_ERR_BADLL = '-4';
                              /* invalid sqlca/buffer addr/length    */
    %dcl SQLA_ERR_BADCA char ext;
    %SQLA_ERR_BADCA = '-5';

 /* Administrative/Database Authorizations returned from Get  */
 /* Administrative Authorizations function */
 /* Authorizations granted explicitly to user */
                              /* SYSADM Authority                    */
    dcl SQL_SYSADM fixed bin(15) value('1'xn);
                              /* DBADM Authority                     */
    dcl SQL_DBADM fixed bin(15) value('2'xn);
                              /* CREATETAB Privilege                 */
    dcl SQL_CREATETAB fixed bin(15) value('4'xn);
                              /* BINDADD Privilege                   */
    dcl SQL_BINDADD fixed bin(15) value('8'xn);
                              /* CONNECT Privilege                   */
    dcl SQL_CONNECT fixed bin(15) value('10'xn);
                              /* CREATE_NOT_FENCED Privilege         */
    dcl SQL_CREATE_NOT_FENC fixed bin(15) value('20'xn);
                              /* SYSCTRL Authority                   */
    dcl SQL_SYSCTRL fixed bin(15) value('40'xn);
                              /* SYSMAINT Authority                  */
    dcl SQL_SYSMAINT fixed bin(15) value('80'xn);

 /* Composite of authorizations granted explicitly to user, to groups*/
 /* of which user is a member, and to PUBLIC */
    %dcl SQL_SYSADM_GRP char ext;
    %SQL_SYSADM_GRP='raise2(SQL_SYSADM,8)';
    %dcl SQL_DBADM_GRP char ext;
    %SQL_DBADM_GRP='raise2(SQL_DBADM,8)';
    %dcl SQL_CREATETAB_GRP char ext;
    %SQL_CREATETAB_GRP='raise2(SQL_CREATETAB,8)';
    %dcl SQL_BINDADD_GRP char ext;
    %SQL_BINDADD_GRP='raise2(SQL_BINDADD,8)';
    %dcl SQL_CONNECT_GRP char ext;
    %SQL_CONNECT_GRP='raise2(SQL_CONNECT,8)';
    %dcl SQL_CREATE_NOT_FENC_GRP char ext;
    %SQL_CREATE_NOT_FENC_GRP='raise2(SQL_CREATE_NOT_FENC,8)';
    %dcl SQL_SYSCTRL_GRP char ext;
    %SQL_SYSCTRL_GRP='raise2(SQL_SYSCTRL,8)';
    %dcl SQL_SYSMAINT_GRP char ext;
    %SQL_SYSMAINT_GRP='raise2(SQL_SYSMAINT,8)';

 /* Table/View Authorizations/Dependencies Bit definitions in*/
 /* SYSTABAUTH.TABAUTH and SYSPLANDEP.TABAUTH                */
                              /* Control Authority                   */
    dcl SQL_TAB_CTL fixed bin(15) value('1'xn);
                              /* Alter Privilege                     */
    dcl SQL_TAB_ALT fixed bin(15) value('2'xn);
                              /* Delete Privilege/Dependency         */
    dcl SQL_TAB_DEL fixed bin(15) value('4'xn);
                              /* Index Privilege                     */
    dcl SQL_TAB_IDX fixed bin(15) value('8'xn);
                              /* Insert Privilege/Dependency         */
    dcl SQL_TAB_INS fixed bin(15) value('10'xn);
                              /* Select Privilege/Dependency         */
    dcl SQL_TAB_SEL fixed bin(15) value('20'xn);
                              /* Update Privilege/Dependency         */
    dcl SQL_TAB_UPD fixed bin(15) value('40'xn);
                              /* Reference Privilege                 */
    dcl SQL_TAB_REF fixed bin(15) value('80'xn);
                              /* Key Dependency                      */
    dcl SQL_TAB_KEY fixed bin(15) value('2000'xn);
                              /* Cascade Dependency                  */
    dcl SQL_TAB_CAS fixed bin(15) value('4000'xn);

 /* Definitions for application remote interface */
                              /* Unload Progam                       */
    dcl SQLZ_DISCONNECT_PROC fixed bin(31) value(1);
                              /* Keep program loaded                 */
    dcl SQLZ_HOLD_PROC fixed bin(31) value(2);
 /********************************************************************/
 /**                                                                 */
 /** The following functions and symbols are obsolete and may not be */
 /** supported in future releases. The obsolete functions are provide*/
 /** for backward compatibility and exported from DB2API.LIB. All    */
 /** applications should be migrated to use new APIs.                */
 /********************************************************************/
                              /* Invalid password                    */
    %dcl SQLA_RC_BAD_PASSWD char ext;
    %SQLA_RC_BAD_PASSWD = '-4';
                              /* Maximum statements (see SQL         */
                              /* reference)                          */
    dcl SQL_MAXSTMTS fixed bin(31) value(32767);
                              /* Maximum host variables per          */
                              /* precompile unit (see SQL            */
                              /* reference)                          */
    dcl SQL_MAXVARS fixed bin(31) value(32767);

  %end;
 /* SQL_H_SQL */
