 /*********************************************************/
 /*  CREATED BY C2PLI CONVERSION UTILITY                  */
 /*********************************************************/
 /********************************************************************/
 /*                                                                  */
 /*  PL/I Include file: SQLCODES.CPY                                 */
 /*                                                                  */
 /*    This file is installed in the \IBMPLI\INCLUDE\ directory.     */
 /*                                                                  */
 /*                                                                  */
 /*  NAME - SQLCODES.CPY                                             */
 /*                                                                  */
 /*  DESCRIPTION                                                     */
 /*                                                                  */
 /*    This include file is translated into a PL/I include file,     */
 /*    from the C header files supplied with the                     */
 /*    IBM DATABASE 2 SOFTWARE DEVELOPERS KIT/2  product.            */
 /*    This include file is intended for use with the                */
 /*    IBM DATABASE 2 SOFTWARE DEVELOPERS KIT/2 product.             */
 /*                                                                  */
 /*                                                                  */
 /*    (C) Copyright IBM Corp. 1994, 1996. All Rights Reserved.      */
 /*    US Government Users Restricted Rights-- Use, duplication or   */
 /*    disclosure restricted by GSA ADP Schedule Contract with       */
 /*    IBM Corp.                                                     */
 /*  Licensed Materials - Property of IBM                            */
 /*                                                                  */
 /*  Function = Include File defining:                               */
 /*               Labels for SQLCODES                                */
 /*                                                                  */
 /*  Operating System = OS/2                                         */
 /*                                                                  */
 /*                                                                  */
 /*  DISCLAIMER OF WARRANTIES                                        */
 /*    The following enclosed code is sample code created by IBM   */
 /*    Corporation. This sample code is not part of any standard     */
 /*    IBM product and is provided to you solely for the purpose of  */
 /*    assisting you in the development of your applications.  The   */
 /*    code is provided "AS IS", without warranty of any kind.       */
 /*    IBM shall not be liable for any damages arising out of your   */
 /*    use of the sample code, even if IBM has been advised of the   */
 /*    possibility of such damages.                                  */
 /*                                                                  */
 /********************************************************************/
 %dcl SQL_H_SQLCODES char ext;
 %if SQL_H_SQLCODES = '' %then
  %do;
    %dcl SQL_H_SQLCODES char ext;
    %SQL_H_SQLCODES = 'Y';



 /* System dependent defines  */
    %include sqlsystm;

 /* SQL Return Codes in SQLCODE */

    %dcl SQL_RC_OK char ext;
    %if SQL_RC_OK = '' %then
     %do;
 /* successful execution                */
       %SQL_RC_OK = '0';
     %end;

 /* ------------ warnings ------------ */
                              /* correlation without qualification   */
    dcl SQL_RC_W012 fixed bin(31) value(12);
                              /* unsupported bind/prep options       */
    dcl SQL_RC_W020 fixed bin(31) value(20);
                              /* eof                                 */
    dcl SQL_RC_W100 fixed bin(31) value(100);
                              /* duplicate column conistraint        */
    dcl SQL_RC_W139 fixed bin(31) value(139);
                              /* invalid syntax ignored              */
    dcl SQL_RC_W143 fixed bin(31) value(143);
                              /* explain mode incompatible           */
    dcl SQL_RC_W217 fixed bin(31) value(217);
                              /* not enough sqlvars, none filled in  */
    dcl SQL_RC_W236 fixed bin(31) value(236);
                              /* distinct type: not enough sqlvars,  */
                              /* some filled in                      */
    dcl SQL_RC_W237 fixed bin(31) value(237);
                              /* LOB type: not enough sqlvars, none  */
                              /* filled in                           */
    dcl SQL_RC_W238 fixed bin(31) value(238);
                              /* distinct type: not enough sqlvars,  */
                              /* none filled in                      */
    dcl SQL_RC_W239 fixed bin(31) value(239);
                              /* new view replaced old               */
    dcl SQL_RC_W280 fixed bin(31) value(280);
                              /* possible infinite loop              */
    dcl SQL_RC_W347 fixed bin(31) value(347);
                              /* alias target is not defined         */
    dcl SQL_RC_W403 fixed bin(31) value(403);
                              /* clause value has been replaced      */
    dcl SQL_RC_W434 fixed bin(31) value(434);
                              /* Sub-optimal query                   */
    dcl SQL_RC_W437 fixed bin(31) value(437);
                              /* Function has truncated value        */
    dcl SQL_RC_W445 fixed bin(31) value(445);
                              /* Create UDF contains redundant keyw  */
    dcl SQL_RC_W447 fixed bin(31) value(447);
                              /* UDF returns a warning sqlstate      */
    dcl SQL_RC_W462 fixed bin(31) value(462);
                              /* DDL:could truncate value at         */
                              /* runtime                             */
    dcl SQL_RC_W474 fixed bin(31) value(474);
                              /* DDL:could truncate value at         */
                              /* runtime                             */
    dcl SQL_RC_W477 fixed bin(31) value(477);
                              /* duplicate referential constraint    */
    dcl SQL_RC_W541 fixed bin(31) value(541);
                              /* Isolation level escalated           */
    dcl SQL_RC_W595 fixed bin(31) value(595);
                              /* existing index used                 */
    dcl SQL_RC_W598 fixed bin(31) value(598);
                              /* compare func not created for lstr   */
    dcl SQL_RC_W599 fixed bin(31) value(599);
                              /* index already exists                */
    dcl SQL_RC_W605 fixed bin(31) value(605);
                              /* unknown SQL warning another         */
                              /* product                             */
    dcl SQL_RC_W965 fixed bin(31) value(965);
                              /* XA informational message            */
    dcl SQL_RC_W997 fixed bin(31) value(997);
                              /* XA no data to return from recover   */
    dcl SQL_RC_W1251 fixed bin(31) value(1251);
                              /* Event monitor state not changed     */
    dcl SQLM_RC_NOT_SET fixed bin(31) value(1615);

 /* ------------ errors ------------ */
                              /* illegal character                   */
    %dcl SQL_RC_E007 char ext;
    %SQL_RC_E007 = '-7';
                              /* string constant not terminated      */
    %dcl SQL_RC_E010 char ext;
    %SQL_RC_E010 = '-10';
                              /* cursor or statement name = ""       */
    %dcl SQL_RC_E013 char ext;
    %SQL_RC_E013 = '-13';
                              /* INTO clause required                */
    %dcl SQL_RC_E029 char ext;
    %SQL_RC_E029 = '-29';
                              /* reserved                            */
    %dcl SQL_RC_E051 char ext;
    %SQL_RC_E051 = '-51';
                              /* bad SQL statement                   */
    %dcl SQL_RC_E084 char ext;
    %SQL_RC_E084 = '-84';

                              /* statement too long                  */
    %dcl SQL_RC_E101 char ext;
    %SQL_RC_E101 = '-101';
                              /* string constant too long            */
    %dcl SQL_RC_E102 char ext;
    %SQL_RC_E102 = '-102';
                              /* invalid numeric literal             */
    %dcl SQL_RC_E103 char ext;
    %SQL_RC_E103 = '-103';
                              /* invalid character/token             */
    %dcl SQL_RC_E104 char ext;
    %SQL_RC_E104 = '-104';
                              /* invalid string constant             */
    %dcl SQL_RC_E105 char ext;
    %SQL_RC_E105 = '-105';
                              /* name too long                       */
    %dcl SQL_RC_E107 char ext;
    %SQL_RC_E107 = '-107';
                              /* name has too many qualifiers        */
    %dcl SQL_RC_E108 char ext;
    %SQL_RC_E108 = '-108';
                              /* clause not permitted                */
    %dcl SQL_RC_E109 char ext;
    %SQL_RC_E109 = '-109';
                              /* invalid hex constant                */
    %dcl SQL_RC_E110 char ext;
    %SQL_RC_E110 = '-110';
                              /* no column name                      */
    %dcl SQL_RC_E111 char ext;
    %SQL_RC_E111 = '-111';
                              /* operand is SQL function             */
    %dcl SQL_RC_E112 char ext;
    %SQL_RC_E112 = '-112';
                              /* wrong nbr of insert values          */
    %dcl SQL_RC_E117 char ext;
    %SQL_RC_E117 = '-117';
                              /* object table in from clause         */
    %dcl SQL_RC_E118 char ext;
    %SQL_RC_E118 = '-118';
                              /* column not in group by              */
    %dcl SQL_RC_E119 char ext;
    %SQL_RC_E119 = '-119';
                              /* clause includes SQL fn              */
    %dcl SQL_RC_E120 char ext;
    %SQL_RC_E120 = '-120';
                              /* dup column name                     */
    %dcl SQL_RC_E121 char ext;
    %SQL_RC_E121 = '-121';
                              /* no group by                         */
    %dcl SQL_RC_E122 char ext;
    %SQL_RC_E122 = '-122';
                              /* parameter must be constant          */
    %dcl SQL_RC_NOTCONST char ext;
    %SQL_RC_NOTCONST = '-123';
                              /* no result column                    */
    %dcl SQL_RC_E125 char ext;
    %SQL_RC_E125 = '-125';
                              /* dup distinct                        */
    %dcl SQL_RC_E127 char ext;
    %SQL_RC_E127 = '-127';
                              /* too many table names                */
    %dcl SQL_RC_E129 char ext;
    %SQL_RC_E129 = '-129';
                              /* invalid escape character            */
    %dcl SQL_RC_INVESC char ext;
    %SQL_RC_INVESC = '-130';
                              /* incompatible data for like          */
    %dcl SQL_RC_E131 char ext;
    %SQL_RC_E131 = '-131';
                              /* like predicate invalid              */
    %dcl SQL_RC_E132 char ext;
    %SQL_RC_E132 = '-132';
                              /* improper use of long string         */
    %dcl SQL_RC_E134 char ext;
    %SQL_RC_E134 = '-134';
                              /* length of concat too long           */
    %dcl SQL_RC_E137 char ext;
    %SQL_RC_E137 = '-137';
                              /* substr arg out of range             */
    %dcl SQL_RC_E138 char ext;
    %SQL_RC_E138 = '-138';
                              /* syntax not supported                */
    %dcl SQL_RC_E142 char ext;
    %SQL_RC_E142 = '-142';
                              /* unsupported ANSI syntax             */
    %dcl SQL_RC_E146 char ext;
    %SQL_RC_E146 = '-146';
                              /* view not updatable                  */
    %dcl SQL_RC_E150 char ext;
    %SQL_RC_E150 = '-150';
                              /* column not updatable                */
    %dcl SQL_RC_E151 char ext;
    %SQL_RC_E151 = '-151';
                              /* no column list                      */
    %dcl SQL_RC_E153 char ext;
    %SQL_RC_E153 = '-153';
                              /* trigger trans tbl not modifiable    */
    %dcl SQL_RC_E155 char ext;
    %SQL_RC_E155 = '-155';
                              /* command not allowed on view         */
    %dcl SQL_RC_E156 char ext;
    %SQL_RC_E156 = '-156';
                              /* view name in foreign key            */
    %dcl SQL_RC_E157 char ext;
    %SQL_RC_E157 = '-157';
                              /* nbr of columns does not match       */
    %dcl SQL_RC_E158 char ext;
    %SQL_RC_E158 = '-158';
                              /* drop view on table                  */
    %dcl SQL_RC_E159 char ext;
    %SQL_RC_E159 = '-159';
                              /* with check not allowed on view      */
    %dcl SQL_RC_E160 char ext;
    %SQL_RC_E160 = '-160';
                              /* with check violation                */
    %dcl SQL_RC_E161 char ext;
    %SQL_RC_E161 = '-161';
                              /* nbr of arguments invalid            */
    %dcl SQL_RC_E170 char ext;
    %SQL_RC_E170 = '-170';
                              /* argument invalid                    */
    %dcl SQL_RC_E171 char ext;
    %SQL_RC_E171 = '-171';
                              /* function name invalid               */
    %dcl SQL_RC_E172 char ext;
    %SQL_RC_E172 = '-172';
                              /* translate scalar argument invalid   */
    %dcl SQL_RC_E176 char ext;
    %SQL_RC_E176 = '-176';
                              /* datetime syntax invalid             */
    %dcl SQL_RC_E180 char ext;
    %SQL_RC_E180 = '-180';
                              /* datetime value invalid              */
    %dcl SQL_RC_E181 char ext;
    %SQL_RC_E181 = '-181';
                              /* datetime arithmetic invalid         */
    %dcl SQL_RC_E182 char ext;
    %SQL_RC_E182 = '-182';
                              /* datetime arithmetic out of range    */
    %dcl SQL_RC_E183 char ext;
    %SQL_RC_E183 = '-183';
                              /* datetime register is invalid        */
    %dcl SQL_RC_DTMEREG char ext;
    %SQL_RC_DTMEREG = '-187';
                              /* truncated DBCS character found      */
    %dcl SQL_RC_DBCSTRUNC char ext;
    %SQL_RC_DBCSTRUNC = '-191';
                              /* NOT NULL needs DEFAULT              */
    %dcl SQL_RC_E193 char ext;
    %SQL_RC_E193 = '-193';
                              /* no qualified columns in ORDER BY    */
    %dcl SQL_RC_E197 char ext;
    %SQL_RC_E197 = '-197';
                              /* no statement text                   */
    %dcl SQL_RC_E198 char ext;
    %SQL_RC_E198 = '-198';
                              /* illegal use of reserved word        */
    %dcl SQL_RC_E199 char ext;
    %SQL_RC_E199 = '-199';

                              /* ambiguous column reference          */
    %dcl SQL_RC_E203 char ext;
    %SQL_RC_E203 = '-203';
                              /* undefined name                      */
    %dcl SQL_RC_E204 char ext;
    %SQL_RC_E204 = '-204';
                              /* not a column                        */
    %dcl SQL_RC_E205 char ext;
    %SQL_RC_E205 = '-205';
                              /* not a column of referenced tables   */
    %dcl SQL_RC_E206 char ext;
    %SQL_RC_E206 = '-206';
                              /* cannot orderby column name w/union  */
    %dcl SQL_RC_E207 char ext;
    %SQL_RC_E207 = '-207';
                              /* column not part of result table     */
    %dcl SQL_RC_E208 char ext;
    %SQL_RC_E208 = '-208';
                              /* duplicate table designator          */
    %dcl SQL_RC_E212 char ext;
    %SQL_RC_E212 = '-212';
                              /* required explain table not exist    */
    %dcl SQL_RC_E219 char ext;
    %SQL_RC_E219 = '-219';
                              /* explain table has improper def      */
    %dcl SQL_RC_E220 char ext;
    %SQL_RC_E220 = '-220';
                              /* raw device containers not allowed   */
    %dcl SQL_RC_E257 char ext;
    %SQL_RC_E257 = '-257';
                              /* cannot add container to pool        */
    %dcl SQL_RC_E258 char ext;
    %SQL_RC_E258 = '-258';
                              /* container map too big               */
    %dcl SQL_RC_E259 char ext;
    %SQL_RC_E259 = '-259';
                              /* cannot add containers to            */
                              /* tablespace                          */
    %dcl SQL_RC_E281 char ext;
    %SQL_RC_E281 = '-281';
                              /* cannot drop tblspace, tbl conflict  */
    %dcl SQL_RC_E282 char ext;
    %SQL_RC_E282 = '-282';
                              /* cannot drop only temp tablespace    */
    %dcl SQL_RC_E283 char ext;
    %SQL_RC_E283 = '-283';
                              /* invalid tablespace type for clause  */
    %dcl SQL_RC_E284 char ext;
    %SQL_RC_E284 = '-284';
                              /* all table parts must be in tblspce  */
    %dcl SQL_RC_E285 char ext;
    %SQL_RC_E285 = '-285';
                              /* need default tblspce for new        */
                              /* tables                              */
    %dcl SQL_RC_E286 char ext;
    %SQL_RC_E286 = '-286';
                              /* SYSCATSPACE not for user objects    */
    %dcl SQL_RC_E287 char ext;
    %SQL_RC_E287 = '-287';
                              /* long tablespace cannot use system   */
    %dcl SQL_RC_E288 char ext;
    %SQL_RC_E288 = '-288';
                              /* cannot allocate new pages in        */
                              /* tablespace                          */
    %dcl SQL_RC_E289 char ext;
    %SQL_RC_E289 = '-289';
                              /* access to tablespace not allowed    */
    %dcl SQL_RC_E290 char ext;
    %SQL_RC_E290 = '-290';
                              /* invalid state transition            */
    %dcl SQL_RC_E291 char ext;
    %SQL_RC_E291 = '-291';
                              /* cannot create internal db file      */
    %dcl SQL_RC_E292 char ext;
    %SQL_RC_E292 = '-292';
                              /* error accessing container           */
    %dcl SQL_RC_E293 char ext;
    %SQL_RC_E293 = '-293';
                              /* container already in use            */
    %dcl SQL_RC_E294 char ext;
    %SQL_RC_E294 = '-294';
                              /* container names too long            */
    %dcl SQL_RC_E295 char ext;
    %SQL_RC_E295 = '-295';
                              /* tablespace limit exceeded           */
    %dcl SQL_RC_E296 char ext;
    %SQL_RC_E296 = '-296';
                              /* container pathname too long         */
    %dcl SQL_RC_E297 char ext;
    %SQL_RC_E297 = '-297';
                              /* bad container pathname              */
    %dcl SQL_RC_E298 char ext;
    %SQL_RC_E298 = '-298';
                              /* container already added             */
    %dcl SQL_RC_E299 char ext;
    %SQL_RC_E299 = '-299';

                              /* host variable has invalid type      */
    %dcl SQL_RC_E301 char ext;
    %SQL_RC_E301 = '-301';
                              /* host variable value too large       */
    %dcl SQL_RC_E302 char ext;
    %SQL_RC_E302 = '-302';
                              /* data types not comparable           */
    %dcl SQL_RC_E303 char ext;
    %SQL_RC_E303 = '-303';
                              /* value not in range of host var      */
    %dcl SQL_RC_E304 char ext;
    %SQL_RC_E304 = '-304';
                              /* host var cannot be null             */
    %dcl SQL_RC_E305 char ext;
    %SQL_RC_E305 = '-305';
                              /* host var limit reached              */
    %dcl SQL_RC_E308 char ext;
    %SQL_RC_E308 = '-308';
                              /* host var should not be null         */
    %dcl SQL_RC_E309 char ext;
    %SQL_RC_E309 = '-309';
                              /* length of host var is negative      */
    %dcl SQL_RC_E311 char ext;
    %SQL_RC_E311 = '-311';
                              /* unusable host variable              */
    %dcl SQL_RC_E312 char ext;
    %SQL_RC_E312 = '-312';
                              /* wrong nbr of host variables         */
    %dcl SQL_RC_E313 char ext;
    %SQL_RC_E313 = '-313';
                              /* no conversn source-cp to target-cp  */
    %dcl SQL_RC_E332 char ext;
    %SQL_RC_E332 = '-332';
                              /* converion overflow                  */
    %dcl SQL_RC_E334 char ext;
    %SQL_RC_E334 = '-334';
                              /* duplicate common table expression   */
    %dcl SQL_RC_E340 char ext;
    %SQL_RC_E340 = '-340';
                              /* cyclic ref between comm tbl exp     */
    %dcl SQL_RC_E341 char ext;
    %SQL_RC_E341 = '-341';
                              /* comm tbl exp use UNION ALL          */
    %dcl SQL_RC_E342 char ext;
    %SQL_RC_E342 = '-342';
                              /* col names required                  */
    %dcl SQL_RC_E343 char ext;
    %SQL_RC_E343 = '-343';
                              /* columns must match exactly          */
    %dcl SQL_RC_E344 char ext;
    %SQL_RC_E344 = '-344';
                              /* cannot use GROUP BY or HAVING here  */
    %dcl SQL_RC_E345 char ext;
    %SQL_RC_E345 = '-345';
                              /* invalid reference to comm tbl exp   */
    %dcl SQL_RC_E346 char ext;
    %SQL_RC_E346 = '-346';
                              /* LOB col cannot be idx, key, constr  */
    %dcl SQL_RC_E350 char ext;
    %SQL_RC_E350 = '-350';
                              /* LOB col cannot be selected by DRDA  */
    %dcl SQL_RC_E351 char ext;
    %SQL_RC_E351 = '-351';
                              /* LOB col cannot be inserted by DRDA  */
    %dcl SQL_RC_E352 char ext;
    %SQL_RC_E352 = '-352';
                              /* LOB col cannot be logged            */
    %dcl SQL_RC_E355 char ext;
    %SQL_RC_E355 = '-355';

                              /* operands not comparable             */
    %dcl SQL_RC_E401 char ext;
    %SQL_RC_E401 = '-401';
                              /* invalid type for arithmetic op      */
    %dcl SQL_RC_E402 char ext;
    %SQL_RC_E402 = '-402';
                              /* alias object undefined              */
    %dcl SQL_RC_E403 char ext;
    %SQL_RC_E403 = '-403';
                              /* update/insert string too long       */
    %dcl SQL_RC_E404 char ext;
    %SQL_RC_E404 = '-404';
                              /* numeric literal out of range        */
    %dcl SQL_RC_E405 char ext;
    %SQL_RC_E405 = '-405';
                              /* derived value out of range          */
    %dcl SQL_RC_E406 char ext;
    %SQL_RC_E406 = '-406';
                              /* column cannot be null               */
    %dcl SQL_RC_E407 char ext;
    %SQL_RC_E407 = '-407';
                              /* invalid data type for column        */
    %dcl SQL_RC_E408 char ext;
    %SQL_RC_E408 = '-408';
                              /* invalid operand for count           */
    %dcl SQL_RC_E409 char ext;
    %SQL_RC_E409 = '-409';
                              /* float literal too long              */
    %dcl SQL_RC_E410 char ext;
    %SQL_RC_E410 = '-410';
                              /* multiple columns in subquery        */
    %dcl SQL_RC_E412 char ext;
    %SQL_RC_E412 = '-412';
                              /* overflow during data conversion     */
    %dcl SQL_RC_E413 char ext;
    %SQL_RC_E413 = '-413';
                              /* incompatible data types for union   */
    %dcl SQL_RC_E415 char ext;
    %SQL_RC_E415 = '-415';
                              /* long string in union                */
    %dcl SQL_RC_E416 char ext;
    %SQL_RC_E416 = '-416';
                              /* invalid use of parameter markers    */
    %dcl SQL_RC_E417 char ext;
    %SQL_RC_E417 = '-417';
                              /* parameter marker in select clause   */
    %dcl SQL_RC_E418 char ext;
    %SQL_RC_E418 = '-418';
                              /* division produced negative scale    */
    %dcl SQL_RC_E419 char ext;
    %SQL_RC_E419 = '-419';
                              /* invalid character in input string   */
    %dcl SQL_RC_E420 char ext;
    %SQL_RC_E420 = '-420';
                              /* diff number of columns for union    */
    %dcl SQL_RC_E421 char ext;
    %SQL_RC_E421 = '-421';
                              /* Invalid handle                      */
    %dcl SQL_RC_E423 char ext;
    %SQL_RC_E423 = '-423';
                              /* dynamic COMMIT not valid            */
    %dcl SQL_RC_E426 char ext;
    %SQL_RC_E426 = '-426';
                              /* dynamic ROLLBACK not valid          */
    %dcl SQL_RC_E427 char ext;
    %SQL_RC_E427 = '-427';
                              /* DISCONNECT in unit of work          */
                              /* notallow                            */
    %dcl SQL_RC_E428 char ext;
    %SQL_RC_E428 = '-428';
                              /* Handle table full                   */
    %dcl SQL_RC_E429 char ext;
    %SQL_RC_E429 = '-429';
                              /* UDF abnormal end                    */
    %dcl SQL_RC_E430 char ext;
    %SQL_RC_E430 = '-430';
                              /* UDF interrupted                     */
    %dcl SQL_RC_E431 char ext;
    %SQL_RC_E431 = '-431';
                              /* Parameter marker cannot have udf    */
                              /* nm                                  */
    %dcl SQL_RC_E432 char ext;
    %SQL_RC_E432 = '-432';
                              /* Value is too long                   */
    %dcl SQL_RC_E433 char ext;
    %SQL_RC_E433 = '-433';
                              /* Inv SQLSTATE in RAISE_ERROR         */
    %dcl SQL_RC_E435 char ext;
    %SQL_RC_E435 = '-435';
                              /* C language char string missing NUL  */
    %dcl SQL_RC_E436 char ext;
    %SQL_RC_E436 = '-436';
                              /* App raised error                    */
    %dcl SQL_RC_E438 char ext;
    %SQL_RC_E438 = '-438';
                              /* Error in UDF                        */
    %dcl SQL_RC_E439 char ext;
    %SQL_RC_E439 = '-439';
                              /* No function with compatible arg     */
    %dcl SQL_RC_E440 char ext;
    %SQL_RC_E440 = '-440';
                              /* Invalid use of DISTINCT with        */
                              /* scalar                              */
    %dcl SQL_RC_E441 char ext;
    %SQL_RC_E441 = '-441';
                              /* Error refering function in DML      */
    %dcl SQL_RC_E442 char ext;
    %SQL_RC_E442 = '-442';
                              /* UDF returns error sqlstate          */
    %dcl SQL_RC_E443 char ext;
    %SQL_RC_E443 = '-443';
                              /* Unable to access UDF function       */
    %dcl SQL_RC_E444 char ext;
    %SQL_RC_E444 = '-444';
                              /* Exceed max number of parameters     */
    %dcl SQL_RC_E448 char ext;
    %SQL_RC_E448 = '-448';
                              /* Invalid EXTERNAL NAME format        */
    %dcl SQL_RC_E449 char ext;
    %SQL_RC_E449 = '-449';
                              /* UDF generates too long result       */
                              /* value                               */
    %dcl SQL_RC_E450 char ext;
    %SQL_RC_E450 = '-450';
                              /* DDL: invalid type for external UDF  */
    %dcl SQL_RC_E451 char ext;
    %SQL_RC_E451 = '-451';
                              /* Hostvar file inaccessible           */
    %dcl SQL_RC_E452 char ext;
    %SQL_RC_E452 = '-452';
                              /* Error in RETURNS and CAST FROM      */
    %dcl SQL_RC_E453 char ext;
    %SQL_RC_E453 = '-453';
                              /* Duplicate UDF name and signature    */
    %dcl SQL_RC_E454 char ext;
    %SQL_RC_E454 = '-454';
                              /* Diff schema for UDF name &          */
                              /* specific                            */
    %dcl SQL_RC_E455 char ext;
    %SQL_RC_E455 = '-455';
                              /* Duplicate specific name             */
    %dcl SQL_RC_E456 char ext;
    %SQL_RC_E456 = '-456';
                              /* Name reserved for system use        */
    %dcl SQL_RC_E457 char ext;
    %SQL_RC_E457 = '-457';
                              /* DDL refers UDF signature not found  */
    %dcl SQL_RC_E458 char ext;
    %SQL_RC_E458 = '-458';
                              /* AS CAST use error                   */
    %dcl SQL_RC_E459 char ext;
    %SQL_RC_E459 = '-459';
                              /* invalid CAST                        */
    %dcl SQL_RC_E461 char ext;
    %SQL_RC_E461 = '-461';
                              /* UDF returns an invalid sqlstate     */
    %dcl SQL_RC_E463 char ext;
    %SQL_RC_E463 = '-463';
                              /* Unable to start fenced UDF          */
    %dcl SQL_RC_E465 char ext;
    %SQL_RC_E465 = '-465';
                              /* reserved object name                */
    %dcl SQL_RC_E473 char ext;
    %SQL_RC_E473 = '-473';
                              /* Result type of source is different  */
    %dcl SQL_RC_E475 char ext;
    %SQL_RC_E475 = '-475';
                              /* Reference to function is not        */
                              /* unique                              */
    %dcl SQL_RC_E476 char ext;
    %SQL_RC_E476 = '-476';
                              /* other obj depends on this obj       */
    %dcl SQL_RC_E478 char ext;
    %SQL_RC_E478 = '-478';
                              /* Parm num not match with source      */
    %dcl SQL_RC_E483 char ext;
    %SQL_RC_E483 = '-483';
                              /* Boolean type is system used only    */
    %dcl SQL_RC_E486 char ext;
    %SQL_RC_E486 = '-486';
                              /* Attempt to excute an SQL statement  */
    %dcl SQL_RC_E487 char ext;
    %SQL_RC_E487 = '-487';
                              /* Inv BOOLEAN in select list result   */
    %dcl SQL_RC_E489 char ext;
    %SQL_RC_E489 = '-489';
                              /* DDL: missing reqired clause         */
    %dcl SQL_RC_E491 char ext;
    %SQL_RC_E491 = '-491';
                              /* DDL: miss match with source type    */
    %dcl SQL_RC_E492 char ext;
    %SQL_RC_E492 = '-492';
                              /* UDF returned bad date/time value    */
    %dcl SQL_RC_E493 char ext;
    %SQL_RC_E493 = '-493';

                              /* cursor not open (fetch/close)       */
    %dcl SQL_RC_E501 char ext;
    %SQL_RC_E501 = '-501';
                              /* cursor already open                 */
    %dcl SQL_RC_E502 char ext;
    %SQL_RC_E502 = '-502';
                              /* column not in update clause         */
    %dcl SQL_RC_E503 char ext;
    %SQL_RC_E503 = '-503';
                              /* cursor name not defined             */
    %dcl SQL_RC_E504 char ext;
    %SQL_RC_E504 = '-504';
                              /* cursor not open (update/delete)     */
    %dcl SQL_RC_E507 char ext;
    %SQL_RC_E507 = '-507';
                              /* cursor not on a row                 */
    %dcl SQL_RC_E508 char ext;
    %SQL_RC_E508 = '-508';
                              /* table not same as for cursor        */
    %dcl SQL_RC_E509 char ext;
    %SQL_RC_E509 = '-509';
                              /* table cannot be modified            */
    %dcl SQL_RC_E510 char ext;
    %SQL_RC_E510 = '-510';
                              /* for update not allowed              */
    %dcl SQL_RC_E511 char ext;
    %SQL_RC_E511 = '-511';
                              /* cursor not prepared                 */
    %dcl SQL_RC_E514 char ext;
    %SQL_RC_E514 = '-514';
                              /* describe not a prepared statement   */
    %dcl SQL_RC_E516 char ext;
    %SQL_RC_E516 = '-516';
                              /* prepared statment not a select      */
    %dcl SQL_RC_E517 char ext;
    %SQL_RC_E517 = '-517';
                              /* execute not a prepared statement    */
    %dcl SQL_RC_E518 char ext;
    %SQL_RC_E518 = '-518';
                              /* statement has an open cursor        */
    %dcl SQL_RC_E519 char ext;
    %SQL_RC_E519 = '-519';
                              /* invalid foreign key value           */
    %dcl SQL_RC_E530 char ext;
    %SQL_RC_E530 = '-530';
                              /* cannot update primary key           */
    %dcl SQL_RC_E531 char ext;
    %SQL_RC_E531 = '-531';
                              /* delete is restricted                */
    %dcl SQL_RC_E532 char ext;
    %SQL_RC_E532 = '-532';
                              /* multi-row insert not allowed        */
    %dcl SQL_RC_E533 char ext;
    %SQL_RC_E533 = '-533';
                              /* multi-row update of pk              */
    %dcl SQL_RC_E534 char ext;
    %SQL_RC_E534 = '-534';
                              /* multi-row delete not allowed        */
    %dcl SQL_RC_E535 char ext;
    %SQL_RC_E535 = '-535';
                              /* descendent in subquery              */
    %dcl SQL_RC_E536 char ext;
    %SQL_RC_E536 = '-536';
                              /* dup column in key def               */
    %dcl SQL_RC_E537 char ext;
    %SQL_RC_E537 = '-537';
                              /* foreign key does not match pk       */
    %dcl SQL_RC_E538 char ext;
    %SQL_RC_E538 = '-538';
                              /* table does not have primary key     */
    %dcl SQL_RC_E539 char ext;
    %SQL_RC_E539 = '-539';
                              /* duplicate referential constraint    */
    %dcl SQL_RC_E541 char ext;
    %SQL_RC_E541 = '-541';
                              /* pk column cannot allow nulls        */
    %dcl SQL_RC_E542 char ext;
    %SQL_RC_E542 = '-542';
                              /* restricted row delete               */
    %dcl SQL_RC_E543 char ext;
    %SQL_RC_E543 = '-543';
                              /* check contraint violated            */
    %dcl SQL_RC_E544 char ext;
    %SQL_RC_E544 = '-544';
                              /* check contraint not satisfied       */
    %dcl SQL_RC_E545 char ext;
    %SQL_RC_E545 = '-545';
                              /* check contraint invalid             */
    %dcl SQL_RC_E546 char ext;
    %SQL_RC_E546 = '-546';
                              /* check contraint invalid             */
    %dcl SQL_RC_E548 char ext;
    %SQL_RC_E548 = '-548';
                              /* authorization error w/obj insert    */
    %dcl SQL_RC_E551 char ext;
    %SQL_RC_E551 = '-551';
                              /* auth error w/o obj ins              */
    %dcl SQL_RC_E552 char ext;
    %SQL_RC_E552 = '-552';
                              /* SYSIBM qualifier                    */
    %dcl SQL_RC_E553 char ext;
    %SQL_RC_E553 = '-553';
                              /* cannot grant privilege to self      */
    %dcl SQL_RC_E554 char ext;
    %SQL_RC_E554 = '-554';
                              /* cannot revoke privilege from self   */
    %dcl SQL_RC_E555 char ext;
    %SQL_RC_E555 = '-555';
                              /* revoke stmt denied--priv not held   */
    %dcl SQL_RC_E556 char ext;
    %SQL_RC_E556 = '-556';
                              /* invalid combination of privileges   */
    %dcl SQL_RC_E557 char ext;
    %SQL_RC_E557 = '-557';
                              /* revoke stmt denied--has CONTROL     */
    %dcl SQL_RC_E558 char ext;
    %SQL_RC_E558 = '-558';
                              /* privilege not allowed for public    */
    %dcl SQL_RC_E562 char ext;
    %SQL_RC_E562 = '-562';
                              /* invalid authorization id            */
    %dcl SQL_RC_E567 char ext;
    %SQL_RC_E567 = '-567';
                              /* user/group ambiguity                */
    %dcl SQL_RC_E569 char ext;
    %SQL_RC_E569 = '-569';
                              /* Inoperative package                 */
    %dcl SQL_RC_E572 char ext;
    %SQL_RC_E572 = '-572';
                              /* contraint col not primary key       */
    %dcl SQL_RC_E573 char ext;
    %SQL_RC_E573 = '-573';
                              /* view is inoperative                 */
    %dcl SQL_RC_E575 char ext;
    %SQL_RC_E575 = '-575';
                              /* Repetitive alias chain              */
    %dcl SQL_RC_E576 char ext;
    %SQL_RC_E576 = '-576';
                              /* Result of CASE expr cannot be NULL  */
    %dcl SQL_RC_E580 char ext;
    %SQL_RC_E580 = '-580';
                              /* Data types of CASE expr incompat    */
    %dcl SQL_RC_E581 char ext;
    %SQL_RC_E581 = '-581';
                              /* Inv predicate in CASE expr          */
    %dcl SQL_RC_E582 char ext;
    %SQL_RC_E582 = '-582';
                              /* Variant or ext action function      */
    %dcl SQL_RC_E583 char ext;
    %SQL_RC_E583 = '-583';
                              /* Inv use of NULL or DEFAULT          */
    %dcl SQL_RC_E584 char ext;
    %SQL_RC_E584 = '-584';
                              /* Duplicate schema name               */
    %dcl SQL_RC_E585 char ext;
    %SQL_RC_E585 = '-585';
                              /* Too many schema names               */
    %dcl SQL_RC_E586 char ext;
    %SQL_RC_E586 = '-586';
                              /* udf - dup func signature            */
    %dcl SQL_RC_E600 char ext;
    %SQL_RC_E600 = '-600';
                              /* duplicate table/view name           */
    %dcl SQL_RC_E601 char ext;
    %SQL_RC_E601 = '-601';
                              /* too many columns in index           */
    %dcl SQL_RC_E602 char ext;
    %SQL_RC_E602 = '-602';
                              /* cannot create unique index          */
    %dcl SQL_RC_E603 char ext;
    %SQL_RC_E603 = '-603';
                              /* invalid length, precision, scale    */
    %dcl SQL_RC_E604 char ext;
    %SQL_RC_E604 = '-604';
                              /* op not allowed on system tables     */
    %dcl SQL_RC_E607 char ext;
    %SQL_RC_E607 = '-607';
                              /* duplicate column name               */
    %dcl SQL_RC_E612 char ext;
    %SQL_RC_E612 = '-612';
                              /* primary key too long                */
    %dcl SQL_RC_E613 char ext;
    %SQL_RC_E613 = '-613';
                              /* index key too long                  */
    %dcl SQL_RC_E614 char ext;
    %SQL_RC_E614 = '-614';
                              /* table already has primary key       */
    %dcl SQL_RC_E624 char ext;
    %SQL_RC_E624 = '-624';
                              /* DDL: multiple/conflict keywords     */
    %dcl SQL_RC_E628 char ext;
    %SQL_RC_E628 = '-628';
                              /* foreign key is not nullable         */
    %dcl SQL_RC_E629 char ext;
    %SQL_RC_E629 = '-629';
                              /* foreign key is too long             */
    %dcl SQL_RC_E631 char ext;
    %SQL_RC_E631 = '-631';
                              /* delete rule restriction             */
    %dcl SQL_RC_E632 char ext;
    %SQL_RC_E632 = '-632';
                              /* delete rule is restricted           */
    %dcl SQL_RC_E633 char ext;
    %SQL_RC_E633 = '-633';
                              /* delete rule cannot be CASCADE       */
    %dcl SQL_RC_E634 char ext;
    %SQL_RC_E634 = '-634';
                              /* dup pk or drop pk clause            */
    %dcl SQL_RC_E637 char ext;
    %SQL_RC_E637 = '-637';
                              /* no column definitions               */
    %dcl SQL_RC_E638 char ext;
    %SQL_RC_E638 = '-638';
                              /* invalid keyword value               */
    %dcl SQL_RC_E644 char ext;
    %SQL_RC_E644 = '-644';
                              /* architectural size limit of object  */
    %dcl SQL_RC_E659 char ext;
    %SQL_RC_E659 = '-659';
                              /* ref constraint does not hold        */
    %dcl SQL_RC_E667 char ext;
    %SQL_RC_E667 = '-667';
                              /* table in CHECK PENDING state        */
    %dcl SQL_RC_E668 char ext;
    %SQL_RC_E668 = '-668';
                              /* cannot drop primary key             */
    %dcl SQL_RC_E669 char ext;
    %SQL_RC_E669 = '-669';
                              /* row length too large                */
    %dcl SQL_RC_E670 char ext;
    %SQL_RC_E670 = '-670';
                              /* primary key not unique              */
    %dcl SQL_RC_E673 char ext;
    %SQL_RC_E673 = '-673';
                              /* too many columns for table          */
    %dcl SQL_RC_E680 char ext;
    %SQL_RC_E680 = '-680';
                              /* incompatible column constraint      */
    %dcl SQL_RC_E683 char ext;
    %SQL_RC_E683 = '-683';
                              /* invalid trigger definition          */
    %dcl SQL_RC_E696 char ext;
    %SQL_RC_E696 = '-696';
                              /* invalid correlation name use        */
    %dcl SQL_RC_E697 char ext;
    %SQL_RC_E697 = '-697';

                              /* object uses reserved name           */
    %dcl SQL_RC_E707 char ext;
    %SQL_RC_E707 = '-707';
                              /* invalid replace value for sp reg    */
    %dcl SQL_RC_INV_REPL char ext;
    %SQL_RC_INV_REPL = '-713';
                              /* trigger error                       */
    %dcl SQL_RC_E723 char ext;
    %SQL_RC_E723 = '-723';
                              /* max level of cascading              */
    %dcl SQL_RC_E724 char ext;
    %SQL_RC_E724 = '-724';
                              /* Invalid triggered statement         */
    %dcl SQL_RC_E751 char ext;
    %SQL_RC_E751 = '-751';
                              /* Inoperative package                 */
    %dcl SQL_RC_E752 char ext;
    %SQL_RC_E752 = '-752';

                              /* divide by zero                      */
    %dcl SQL_RC_E801 char ext;
    %SQL_RC_E801 = '-801';
                              /* arith overflow or divide by zero    */
    %dcl SQL_RC_E802 char ext;
    %SQL_RC_E802 = '-802';
                              /* distinct violation                  */
    %dcl SQL_RC_E803 char ext;
    %SQL_RC_E803 = '-803';
                              /* bad input parameters                */
    %dcl SQL_RC_E804 char ext;
    %SQL_RC_E804 = '-804';
                              /* program not bound                   */
    %dcl SQL_RC_E805 char ext;
    %SQL_RC_E805 = '-805';
                              /* inconsistent connect semantics      */
    %dcl SQL_RC_E808 char ext;
    %SQL_RC_E808 = '-808';
                              /* more than one row/value             */
    %dcl SQL_RC_E811 char ext;
    %SQL_RC_E811 = '-811';
                              /* time stamp conflict                 */
    %dcl SQL_RC_E818 char ext;
    %SQL_RC_E818 = '-818';
                              /* invalid address in sqlda            */
    %dcl SQL_RC_E822 char ext;
    %SQL_RC_E822 = '-822';
                              /* too many items in list              */
    %dcl SQL_RC_E840 char ext;
    %SQL_RC_E840 = '-840';
                              /* connection already exists           */
    %dcl SQL_RC_E842 char ext;
    %SQL_RC_E842 = '-842';
                              /* connection does not exist           */
    %dcl SQL_RC_E843 char ext;
    %SQL_RC_E843 = '-843';
                              /* can't change connection settings    */
    %dcl SQL_RC_E847 char ext;
    %SQL_RC_E847 = '-847';
                              /* TM not for 2 phase commit apps      */
    %dcl SQL_RC_E859 char ext;
    %SQL_RC_E859 = '-859';
                              /* inv TM_DATABASE value               */
    %dcl SQL_RC_E865 char ext;
    %SQL_RC_E865 = '-865';
                              /* connect redirect failed             */
    %dcl SQL_RC_E866 char ext;
    %SQL_RC_E866 = '-866';
                              /* connection already exists           */
    %dcl SQL_RC_E868 char ext;
    %SQL_RC_E868 = '-868';

                              /* non-fatal system error              */
    %dcl SQL_RC_E901 char ext;
    %SQL_RC_E901 = '-901';
                              /* fatal error                         */
    %dcl SQL_RC_E902 char ext;
    %SQL_RC_E902 = '-902';
                              /* commit failed, rollback             */
    %dcl SQL_RC_E903 char ext;
    %SQL_RC_E903 = '-903';
                              /* lock timeout                        */
    %dcl SQL_RC_E904 char ext;
    %SQL_RC_E904 = '-904';
                              /* drop pending                        */
    %dcl SQL_RC_E910 char ext;
    %SQL_RC_E910 = '-910';
                              /* deadlock                            */
    %dcl SQL_RC_E911 char ext;
    %SQL_RC_E911 = '-911';
                              /* too many lock requests              */
    %dcl SQL_RC_E912 char ext;
    %SQL_RC_E912 = '-912';
                              /* dist env rollback                   */
    %dcl SQL_RC_E913 char ext;
    %SQL_RC_E913 = '-913';
                              /* ROLLBACK required                   */
    %dcl SQL_RC_E918 char ext;
    %SQL_RC_E918 = '-918';
                              /* reject DB connection to SA REQ      */
    %dcl SQL_RC_E920 char ext;
    %SQL_RC_E920 = '-920';
                              /* COMMIT not allowed                  */
    %dcl SQL_RC_E925 char ext;
    %SQL_RC_E925 = '-925';
                              /* ROLLBACK not allowed                */
    %dcl SQL_RC_E926 char ext;
    %SQL_RC_E926 = '-926';
                              /* insufficient storage                */
    %dcl SQL_RC_E930 char ext;
    %SQL_RC_E930 = '-930';
                              /* all inodes used, system limit       */
    %dcl SQL_RC_INODE char ext;
    %SQL_RC_INODE = '-931';
                              /* cursors active on dropped object    */
    %dcl SQL_RC_E950 char ext;
    %SQL_RC_E950 = '-950';
                              /* table in use - alter disallowed     */
    %dcl SQL_RC_E951 char ext;
    %SQL_RC_E951 = '-951';
                              /* user cancel                         */
    %dcl SQL_RC_E952 char ext;
    %SQL_RC_E952 = '-952';
                              /* agent heap too small                */
    %dcl SQL_RC_E953 char ext;
    %SQL_RC_E953 = '-953';
                              /* application heap too small          */
    %dcl SQL_RC_E954 char ext;
    %SQL_RC_E954 = '-954';
                              /* sort heap error                     */
    %dcl SQL_RC_E955 char ext;
    %SQL_RC_E955 = '-955';
                              /* database heap too small             */
    %dcl SQL_RC_E956 char ext;
    %SQL_RC_E956 = '-956';
                              /* requestor comm heap too small       */
    %dcl SQL_RC_E957 char ext;
    %SQL_RC_E957 = '-957';
                              /* max number of files open            */
    %dcl SQL_RC_E958 char ext;
    %SQL_RC_E958 = '-958';
                              /* server comm heap too small          */
    %dcl SQL_RC_E959 char ext;
    %SQL_RC_E959 = '-959';
                              /* max nbr of files in database        */
    %dcl SQL_RC_E960 char ext;
    %SQL_RC_E960 = '-960';
                              /* rqstr remote svcs heap too small    */
    %dcl SQL_RC_E961 char ext;
    %SQL_RC_E961 = '-961';
                              /* svr remote svcs heap too small      */
    %dcl SQL_RC_E962 char ext;
    %SQL_RC_E962 = '-962';
                              /* log file full                       */
    %dcl SQL_RC_E964 char ext;
    %SQL_RC_E964 = '-964';
                              /* error opening sqlcode mapping file  */
    %dcl SQL_RC_E966 char ext;
    %SQL_RC_E966 = '-966';
                              /* format error in sqlcode map file    */
    %dcl SQL_RC_E967 char ext;
    %SQL_RC_E967 = '-967';
                              /* disk full                           */
    %dcl SQL_RC_E968 char ext;
    %SQL_RC_E968 = '-968';
                              /* unknown sql error another product   */
    %dcl SQL_RC_E969 char ext;
    %SQL_RC_E969 = '-969';
                              /* read-only file                      */
    %dcl SQL_RC_E970 char ext;
    %SQL_RC_E970 = '-970';

                              /* incorrect diskette                  */
    %dcl SQL_RC_E972_DB2AIX char ext;
    %SQL_RC_E972_DB2AIX = '-10019';
                              /* incorrect diskette                  */
    %dcl SQL_RC_E972_DB2OS2 char ext;
    %SQL_RC_E972_DB2OS2 = '-972';
                                         /* incorrect diskette       */
 %dcl SQL_RC_E972 char ext;
 %SQL_RC_E972='SQL_RC_E972_DB2OS2';
    %dcl @SQL_RC_E972 char ext;
    %@SQL_RC_E972='@SQL_RC_E972_DB2OS2';

                              /* out of memory error                 */
    %dcl SQL_RC_E973 char ext;
    %SQL_RC_E973 = '-973';

                              /* drive locked                        */
    %dcl SQL_RC_E974_DB2AIX char ext;
    %SQL_RC_E974_DB2AIX = '-10019';
                              /* drive locked                        */
    %dcl SQL_RC_E974_DB2OS2 char ext;
    %SQL_RC_E974_DB2OS2 = '-974';
                                         /* drive locked             */
 %dcl SQL_RC_E974 char ext;
 %SQL_RC_E974='SQL_RC_E974_DB2OS2';
    %dcl @SQL_RC_E974 char ext;
    %@SQL_RC_E974='@SQL_RC_E974_DB2OS2';

                              /* quiesce backup                      */
    %dcl SQL_RC_QBACK char ext;
    %SQL_RC_QBACK = '-975';

                              /* diskette door open                  */
    %dcl SQL_RC_E976_DB2AIX char ext;
    %SQL_RC_E976_DB2AIX = '-10019';
                              /* diskette door open                  */
    %dcl SQL_RC_E976_DB2OS2 char ext;
    %SQL_RC_E976_DB2OS2 = '-976';
                                         /* diskette door open       */
 %dcl SQL_RC_E976 char ext;
 %SQL_RC_E976='SQL_RC_E976_DB2OS2';
    %dcl @SQL_RC_E976 char ext;
    %@SQL_RC_E976='@SQL_RC_E976_DB2OS2';

                              /* unknown commit state                */
    %dcl SQL_RC_E977 char ext;
    %SQL_RC_E977 = '-977';
                              /* diskette write-protected            */
    %dcl SQL_RC_E978_DB2AIX char ext;
    %SQL_RC_E978_DB2AIX = '-10019';
                              /* diskette write-protected            */
    %dcl SQL_RC_E978_DB2OS2 char ext;
    %SQL_RC_E978_DB2OS2 = '-978';
                                         /* diskette write           */
                              /* protected                           */
 %dcl SQL_RC_E978 char ext;
 %SQL_RC_E978='SQL_RC_E978_DB2OS2';
    %dcl @SQL_RC_E978 char ext;
    %@SQL_RC_E978='@SQL_RC_E978_DB2OS2';

                              /* commit failed with SYNCPOINT NONE   */
    %dcl SQL_RC_E979 char ext;
    %SQL_RC_E979 = '-979';
                              /* disk error                          */
    %dcl SQL_RC_E980 char ext;
    %SQL_RC_E980 = '-980';
                              /* disk error on temp file             */
    %dcl SQL_RC_E982 char ext;
    %SQL_RC_E982 = '-982';
                              /* unsuccessful commit or rollback     */
    %dcl SQL_RC_E984 char ext;
    %SQL_RC_E984 = '-984';
                              /* file error - catalog file bad       */
    %dcl SQL_RC_E985 char ext;
    %SQL_RC_E985 = '-985';
                              /* file error - file renamed           */
    %dcl SQL_RC_E986 char ext;
    %SQL_RC_E986 = '-986';
                              /* app ctl heap out of memory          */
    %dcl SQL_RC_E988 char ext;
    %SQL_RC_E988 = '-988';
                              /* index structure limit error         */
    %dcl SQL_RC_E990 char ext;
    %SQL_RC_E990 = '-990';
                              /* release number incompatible         */
    %dcl SQL_RC_E992 char ext;
    %SQL_RC_E992 = '-992';
                              /* reserved                            */
    %dcl SQL_RC_E994 char ext;
    %SQL_RC_E994 = '-994';
                              /* error freeing pages in DMS          */
                              /* tablespace                          */
    %dcl SQL_RC_E996 char ext;
    %SQL_RC_E996 = '-996';
                              /* General XA error                    */
    %dcl SQL_RC_E998 char ext;
    %SQL_RC_E998 = '-998';

                              /* error finding pages in DMS          */
                              /* tablespace                          */
    %dcl SQL_RC_E1007 char ext;
    %SQL_RC_E1007 = '-1007';
                              /* invalid tablespace id               */
    %dcl SQL_RC_E1008 char ext;
    %SQL_RC_E1008 = '-1008';

                              /* invalid use of graphic data         */
    %dcl SQL_RC_E1216 char ext;
    %SQL_RC_E1216 = '-1216';
                              /* out of private memory               */
    %dcl SQL_RC_E1219 char ext;
    %SQL_RC_E1219 = '-1219';
                              /* Updatale cat values inv             */
    %dcl SQL_RC_E1227 char ext;
    %SQL_RC_E1227 = '-1227';
                              /* System error rollback               */
    %dcl SQL_RC_E1229 char ext;
                              /* Disconn at next commit              */
    %SQL_RC_E1229 = '-1229';
    dcl SQL_RC_W1244 fixed bin(31) value(1244);
                              /* Max client connects                 */
    %dcl SQL_RC_E1245 char ext;
    %SQL_RC_E1245 = '-1245';
                              /* XA TM uses syncpoint 2              */
    %dcl SQL_RC_E1247 char ext;
    %SQL_RC_E1247 = '-1247';
                              /* db not defined with TM              */
    %dcl SQL_RC_E1248 char ext;
    %SQL_RC_E1248 = '-1248';
                              /* DB2CLIENTCOMM env var inv           */
    %dcl SQL_RC_E1290 char ext;
    %SQL_RC_E1290 = '-1290';
                              /* direcory services error             */
    %dcl SQL_RC_E1291 char ext;
    %SQL_RC_E1291 = '-1291';
                              /* global dir error                    */
    %dcl SQL_RC_E1293 char ext;
    %SQL_RC_E1293 = '-1293';
                              /* global dir path invalid             */
    %dcl SQL_RC_E1294 char ext;
    %SQL_RC_E1294 = '-1294';
                              /* global dir router invalid           */
    %dcl SQL_RC_E1295 char ext;
    %SQL_RC_E1295 = '-1295';

                              /* Not Atomic Compound SQL error(s)    */
    %dcl SQL_RC_E1339 char ext;
    %SQL_RC_E1339 = '-1339';

                              /* too many concat operators           */
    %dcl SQL_RC_E1420 char ext;
    %SQL_RC_E1420 = '-1420';
                              /* MBCS conversion error               */
    %dcl SQL_RC_E1421 char ext;
    %SQL_RC_E1421 = '-1421';
                              /* Container wrong size                */
    %dcl SQL_RC_E1422 char ext;
    %SQL_RC_E1422 = '-1422';
                              /* no blobs for dwn lvl cl             */
    %dcl SQL_RC_E1423 char ext;
    %SQL_RC_E1423 = '-1423';
                              /* too many transition tbles           */
    %dcl SQL_RC_E1424 char ext;
    %SQL_RC_E1424 = '-1424';

                              /* Table not in check pend state       */
    %dcl SQL_RC_E3600 char ext;
    %SQL_RC_E3600 = '-3600';
                              /* Auto Check pending state            */
    dcl SQL_RC_W3601 fixed bin(31) value(3601);
                              /* Constraint violation moved          */
    dcl SQL_RC_W3602 fixed bin(31) value(3602);
                              /* Constraint Violations               */
    %dcl SQL_RC_E3603 char ext;
    %SQL_RC_E3603 = '-3603';
                              /* Invalid Exception Table             */
    %dcl SQL_RC_E3604 char ext;
    %SQL_RC_E3604 = '-3604';
                              /* Exception Table same as Check       */
                              /* Table                               */
    %dcl SQL_RC_E3605 char ext;
    %SQL_RC_E3605 = '-3605';
                              /* # check & exception tables not      */
                              /* match                               */
    %dcl SQL_RC_E3606 char ext;
    %SQL_RC_E3606 = '-3606';
                              /* Parent in Check Pending state       */
    %dcl SQL_RC_E3608 char ext;
    %SQL_RC_E3608 = '-3608';

                              /* Page number too high                */
    %dcl SQL_RC_E8100 char ext;
    %SQL_RC_E8100 = '-8100';
                              /* Segment in error                    */
    %dcl SQL_RC_E8101 char ext;
    %SQL_RC_E8101 = '-8101';

                              /* Distribution protocol error, no     */
                              /* disconnect                          */
    %dcl SQL_RC_E30000 char ext;
    %SQL_RC_E30000 = '-30000';
                              /* Distribution protocol error,        */
                              /* disconnect                          */
    %dcl SQL_RC_E30020 char ext;
    %SQL_RC_E30020 = '-30020';
                              /* Distribution compatibility error    */
    %dcl SQL_RC_E30021 char ext;
    %SQL_RC_E30021 = '-30021';
                              /* Distribution memory allocation err  */
    %dcl SQL_RC_E30040 char ext;
    %SQL_RC_E30040 = '-30040';
                              /* Distribution memory allocation      */
                              /* err, disconnect                     */
    %dcl SQL_RC_E30041 char ext;
    %SQL_RC_E30041 = '-30041';
                              /* Invalid command while bind in prog  */
    %dcl SQL_RC_E30050 char ext;
    %SQL_RC_E30050 = '-30050';
                              /* Bind not active                     */
    %dcl SQL_RC_E30051 char ext;
    %SQL_RC_E30051 = '-30051';
                              /* Bind Owner authorization failure    */
    %dcl SQL_RC_E30053 char ext;
    %SQL_RC_E30053 = '-30053';
                              /* RDB authorization failure           */
    %dcl SQL_RC_E30060 char ext;
    %SQL_RC_E30060 = '-30060';
                              /* RDB not found                       */
    %dcl SQL_RC_E30061 char ext;
    %SQL_RC_E30061 = '-30061';
                              /* Distribution command error          */
    %dcl SQL_RC_E30070 char ext;
    %SQL_RC_E30070 = '-30070';
                              /* Distribution object error           */
    %dcl SQL_RC_E30071 char ext;
    %SQL_RC_E30071 = '-30071';
                              /* Distribution parameter error        */
    %dcl SQL_RC_E30072 char ext;
    %SQL_RC_E30072 = '-30072';
                              /* Distribution parameter value error  */
    %dcl SQL_RC_E30073 char ext;
    %SQL_RC_E30073 = '-30073';
                              /* Distribution reply error            */
    %dcl SQL_RC_E30074 char ext;
    %SQL_RC_E30074 = '-30074';
                              /* Communication error                 */
    %dcl SQL_RC_E30080 char ext;
    %SQL_RC_E30080 = '-30080';
                              /* Communication error                 */
    %dcl SQL_RC_E30081 char ext;
    %SQL_RC_E30081 = '-30081';
                              /* Remote operation invalid            */
    %dcl SQL_RC_E30090 char ext;
                              /* Rebind options ignored              */
    %SQL_RC_E30090 = '-30090';
                              /* Connection disabled                 */
    dcl SQL_RC_W30101 fixed bin(31) value(30101);
    dcl SQL_RC_W30102 fixed bin(31) value(30102);

 /* Database Monitor SQLCODES */

                              /* bad path specified for event        */
                              /* monitor                             */
    %dcl SQLM_RC_BAD_PATH char ext;
    %SQLM_RC_BAD_PATH = '-1612';
                              /* bad OPTION specified for event      */
                              /* monitor                             */
    %dcl SQLM_RC_BAD_OPTION char ext;
    %SQLM_RC_BAD_OPTION = '-1613';
                              /* I/O error on activating event       */
                              /* monitor                             */
    %dcl SQLM_RC_IO_ERROR char ext;
    %SQLM_RC_IO_ERROR = '-1614';
                              /* Event monitor not activated         */
    %dcl SQLM_RC_NOT_ACTIVATED char ext;
    %SQLM_RC_NOT_ACTIVATED = '-1616';
                              /* Event monitor data files are full   */
    %dcl SQLM_RC_EVMON_FULL char ext;
    %SQLM_RC_EVMON_FULL = '-1617';
                              /* Event monitor path is in use        */
    %dcl SQLM_RC_PATH_IN_USE char ext;
    %SQLM_RC_PATH_IN_USE = '-1618';
                              /* Cannot drop active event monitor    */
    %dcl SQLM_RC_CANNOT_DROP char ext;
    %SQLM_RC_CANNOT_DROP = '-1619';
                              /* Must commit to use event monitor    */
    %dcl SQLM_RC_MUST_COMMIT char ext;
    %SQLM_RC_MUST_COMMIT = '-1621';
                              /* Invalid state                       */
    %dcl SQLM_RC_BAD_STATE char ext;
    %SQLM_RC_BAD_STATE = '-1622';


  %end;
 /* SQL_H_SQLCODES */
