 /*********************************************************/
 /*  CREATED BY C2PLI CONVERSION UTILITY                  */
 /*********************************************************/
 /********************************************************************/
 /*                                                                  */
 /*  PL/I Include file: SQLJACB.CPY                                  */
 /*                                                                  */
 /*    This file is installed in the \IBMPLI\INCLUDE\ directory.     */
 /*                                                                  */
 /*                                                                  */
 /*  NAME - SQLJACB.CPY                                              */
 /*                                                                  */
 /*  DESCRIPTION                                                     */
 /*                                                                  */
 /*    This include file is translated into a PL/I include file,     */
 /*    from the C header files supplied with the                     */
 /*    IBM DATABASE 2 SOFTWARE DEVELOPERS KIT/2  product.            */
 /*    This include file is intended for use with the                */
 /*    IBM DATABASE 2 SOFTWARE DEVELOPERS KIT/2 product.             */
 /*                                                                  */
 /*                                                                  */
 /*    (C) Copyright IBM Corp. 1994, 1996. All Rights Reserved.      */
 /*    US Government Users Restricted Rights-- Use, duplication or   */
 /*    disclosure restricted by GSA ADP Schedule Contract with       */
 /*    IBM Corp.                                                     */
 /*  Licensed Materials - Property of IBM                            */
 /*                                                                  */
 /*  Function =                                                      */
 /*     Include File defining:                                       */
 /*       Database Connection Services (DCS) Interface - Constants   */
 /*       DCS Interface - SQLJ_ACBH, SQLJACB handle structure        */
 /*       DCS Interface - SQLJACB, DCS Interface Control Block       */
 /*                                                                  */
 /*                                                                  */
 /*  Operating System = OS/2                                         */
 /*                                                                  */
 /*                                                                  */
 /*  DISCLAIMER OF WARRANTIES                                        */
 /*    The following enclosed code is sample code created by IBM   */
 /*    Corporation. This sample code is not part of any standard     */
 /*    IBM product and is provided to you solely for the purpose of  */
 /*    assisting you in the development of your applications.  The   */
 /*    code is provided "AS IS", without warranty of any kind.       */
 /*    IBM shall not be liable for any damages arising out of your   */
 /*    use of the sample code, even if IBM has been advised of the   */
 /*    possibility of such damages.                                  */
 /*                                                                  */
 /********************************************************************/

 %dcl SQL_H_SQLJACB char ext;
 %if SQL_H_SQLJACB = '' %then
  %do;
    %dcl SQL_H_SQLJACB char ext;
    %SQL_H_SQLJACB = 'Y';



                                                  /* SQLJACB Title   */
    dcl SQLJACB_TTL char value("SQLJACB ");
                                                  /* SQLJACB Version */
    dcl SQLJACB_VER fixed bin(15) value('0100'xn);

 /* Connection type - SQLJ_ACBH.conn_type */

    dcl SQLJ_CONN_DRD1 fixed bin(31) value(1);
    dcl SQLJ_CONN_ASP0 fixed bin(31) value(2);
    dcl SQLJ_CONN_LOC fixed bin(31) value(3);
    dcl SQLJ_CONN_VNDR fixed bin(31) value(5);

 /* ACB type - SQLJACB.sqlapcont */
                                /* Database is local to Application  */
    dcl SQLJALOC fixed bin(15) value('00'xn);
                                /* Database is remote to Application */
    dcl SQLJAREM fixed bin(15) value('01'xn);

 /* ACB Connection States - SQLJACB.sqlapconst */
                                 /* Application not connected        */
    dcl SQLJAINA fixed bin(31) value('00000000'xn);
                                 /* Application is connected to DB   */
    dcl SQLJAIDL fixed bin(31) value('00000001'xn);
                                 /* SQL in progress, interrupt valid */
    dcl SQLJAREQ fixed bin(31) value('00000003'xn);
                                 /* Connection in error state        */
    dcl SQLJAERR fixed bin(31) value('00000004'xn);
                                 /* Connection in Recovery state     */
    dcl SQLJRCVY fixed bin(31) value('00000005'xn);
                                 /* Connection in Paused state       */
    dcl SQLJ_CONN_PAUS fixed bin(31) value('00000009'xn);
                                 /* In Logical Unit of Work.         */
    dcl SQLJ_IN_LUW fixed bin(31) value('00000010'xn);

 /* ACB Connection Pending States - SQLJACB.sqlapconst */
                                          /* Nothing Pending         */
    dcl SQLJAACT fixed bin(31) value('00000000'xn);
                                          /* Start Database Pending  */
    dcl SQLJASTA fixed bin(31) value('00000100'xn);
                                          /* Stop Database Pending   */
    dcl SQLJASTO fixed bin(31) value('00000200'xn);
                                          /* Request interrupted     */
    dcl SQLJAINT fixed bin(31) value('00000400'xn);
                                          /* Pause Database Pending  */
    dcl SQLJ_PAUS_PEND fixed bin(31) value('00000800'xn);
                                          /* Database has Terminated */
    dcl SQLJ_DB_TERM fixed bin(31) value('00001000'xn);

 /* ACB Information States - SQLJACB.sqlapconst */
                                      /* Local Request               */
    dcl SQLJLOCR fixed bin(31) value('00000000'xn);
                                      /* Remote Request              */
    dcl SQLJREMR fixed bin(31) value('00010000'xn);
                                      /* Cleanup already in progress */
    dcl SQLJBUSY fixed bin(31) value('00020000'xn);
                                      /* Backup/Restore waiting      */
                                      /* for user input              */
    dcl SQLJBRWT fixed bin(31) value('00040000'xn);

 /* ACB Information States - SQLJACB.sqlapconst */
                                      /* No Info                     */
    dcl SQLJNOIN fixed bin(31) value('00000000'xn);
                                      /* Restart Request in Progress */
    dcl SQLJREST fixed bin(31) value('01000000'xn);
                                      /* Create Database in Progress */
    dcl SQLJCDIP fixed bin(31) value('02000000'xn);
                                      /* Backup/Restore in Progress  */
    dcl SQLJBURS fixed bin(31) value('04000000'xn);
                                      /* Migrate in Progress         */
    dcl SQLJMIGR fixed bin(31) value('08000000'xn);
                                      /* Backup Only in Progress     */
    dcl SQLJBACK fixed bin(31) value('10000000'xn);

 /* ACB Information States - SQLJACB.sqlapcons2 */
                                      /* Connection is Type-1        */
    dcl SQLJTYP1 fixed bin(31) value('00000001'xn);
                                      /* Connection is Type-2        */
    dcl SQLJTYP2 fixed bin(31) value('00000002'xn);
                                      /* Connection is DRDA-1        */
    dcl SQLJDRD1 fixed bin(31) value('00000004'xn);
                                      /* Connection is DRDA-2        */
    dcl SQLJDRD2 fixed bin(31) value('00000008'xn);
                                      /* Connection is released      */
    dcl SQLJREL fixed bin(31) value('00000010'xn);
                                      /* Connection is dormant       */
    dcl SQLJDORM fixed bin(31) value('00000020'xn);

 define structure
    1 sqlj_acb,                       /* Connection is dormant       */
        2 sqlacbid char(8),           /* Control block eye catcher */
        2 sqlacbsz unsigned fixed bin(31) ,         /* Size in bytes */
        2 sqlacbver unsigned fixed bin(16) ,       /* Version number */
                 /* Reserved for Database Connection Router use only */
       2 sqlnacb unsigned fixed bin(16) ,
      /***************************************************************/
      /* the following two pointer fields are in support of the      */
      /* Application connection set. Each SQLJACB is linked onto one */
      /* of the synonym chains within the sqlecvt array in the       */
      /* sqlerglob structure.                                        */
      /***************************************************************/
        2 sqljfwd handle sqlj_acb,            /* forward chain field */
        2 sqljback handle sqlj_acb,          /* backward chain field */
        2 sqlhash fixed bin(15),               /* index into sqlecvt */
      /***************************************************************/
      /* the database use, product signature and country code are    */
      /* moved from the sqlerglob to the sqljacb as they are         */
      /* attributes of the connection.                               */
      /***************************************************************/
        2 use char,                                  /* database use */
        2 prod_sig char(8),            /* served product signature */
        2 dbcpcc char(32),                 /* Database country and */
                                                        /* code page */
                                      /* Application connection type */
       2 sqlapcont unsigned fixed bin(16) ,
                                     /* Application connection state */
       2 sqlapconst unsigned fixed bin(31) ,
                                            /* Application connection*/
                                                     /* state word 2 */
       2 sqlapcons2 unsigned fixed bin(31) ,
      /* Process and thread id */
                                     /* Process ID of server process */
       2 sqlappid unsigned fixed bin(16) ,
                                      /* Thread ID of server process */
       2 sqlaptid unsigned fixed bin(16) ,
       /* Codepages */
                              /* Codepage of originating application */
       2 sqlapcpg unsigned fixed bin(16) ,
                                             /* Codepage of database */
       2 sqldbcpg unsigned fixed bin(16) ,
      /* Datastream type */
       2 sqldtast unsigned fixed bin(16) ,/* Datastream type */
      /* Originating Application node */
                                   /* Length of application nodename */
       2 sqlapnnl unsigned fixed bin(31) ,
                               /* Data type of application node name */
       2 sqlapnnt unsigned fixed bin(16) ,
        2 sqlapnn pointer,       /* Pointer to application node name */
      /* Originating Application ID */
                                          /* Length of application id*/
       2 sqlapidl unsigned fixed bin(31) ,
                                      /* Data type of application id */
       2 sqlapidt unsigned fixed bin(16) ,
        2 sqlapid pointer,              /* Pointer to application id */
      /* Database Connection Router internal control block */
      /* Length of Database Connection Router internal control block */
       2 sqlcrtcbl unsigned fixed bin(31) ,
   /* Data type of Database Connection Router internal control block */
       2 sqlcrtcbt unsigned fixed bin(16) ,
       /* Pointer to Database Connection Router internal control     */
                      /* block (Database Connection Router use only) */
       2 sqlcrtcb pointer,
      /* Target internal control block */
                           /* Length of target internalcontrol block */
       2 sqlcsvcbl unsigned fixed bin(31) ,
                       /* Data type of target internal control block */
       2 sqlcsvcbt unsigned fixed bin(16) ,
        2 sqlcsvcb pointer,   /* Ptr to target internal control block*/
      /* Userid */
        2 sqlusl unsigned fixed bin(31) ,        /* Length of userid */
        2 sqlust unsigned fixed bin(16) ,     /* Data type of userid */
        2 sqluser pointer,                      /* Pointer to userid */
      /* Alias name in system database directory */
        2 sqldball unsigned fixed bin(31) ,  /* Length of alias name */
       2 sqldbalt unsigned fixed bin(16) ,/* Data type of alias name */
    /* Pointer to alias name of database in systemdatabase directory */
       2 sqldbal pointer,
      /* Database name in system database directory */
       2 sqlldbnl unsigned fixed bin(31) ,/* Length of database name */
                                        /* Data type of database name*/
       2 sqlldbnt unsigned fixed bin(16) ,
         /* Pointer to name of database in system database directory */
       2 sqlldbn pointer,
      /* Node name in system database directory */
        2 sqlnnl unsigned fixed bin(31) ,     /* Length of node name */
        2 sqlnnt unsigned fixed bin(16) ,  /* Data type of node name */
                /* Pointer to node name in system database directory */
       2 sqlnn pointer,
      /* Database name in Database Connection Services directory */
       2 sqlsdbnl unsigned fixed bin(31) ,/* Length of database name */
                                        /* Data type of database name*/
       2 sqlsdbnt unsigned fixed bin(16) ,
                             /* Pointer to database name in Database */
                                     /*Connection Services directory */
       2 sqlsdbn pointer,
      /* Target library name */
        2 sqlpgmnl unsigned fixed bin(31) ,/* Length of library name */
                                         /* Data type of library name*/
        2 sqlpgmnt unsigned fixed bin(16) ,
       2 sqlpgmn pointer,/* Pointer to library name of target element*/
      /* Parameter string */
                                        /* Length of parameter string*/
       2 sqlparml unsigned fixed bin(31) ,
                                    /* Data type of parameter string */
       2 sqlparmt unsigned fixed bin(16) ,
                        /* Pointer to parameter string from Database */
                                    /* Connection Services directory */
       2 sqlparm pointer,
      /* Target element data heap */
                                        /* Length of target data heap*/
       2 sqlrshpl unsigned fixed bin(31) ,
                                    /* Data type of target data heap */
       2 sqlrshpt unsigned fixed bin(16) ,
        2 sqlrshp pointer;            /* Pointer to target data heap */

    define alias @sqlj_acb handle sqlj_acb;
    define alias SQLJACB type sqlj_acb;
    define alias @SQLJACB type @sqlj_acb;

 %dcl SQLJ_LEN_SQLJACB char ext;
 %SQLJ_LEN_SQLJACB='SQLJACB';
    %dcl @SQLJ_LEN_SQLJACB char ext;
    %@SQLJ_LEN_SQLJACB='@SQLJACB';

 /* SQLJ_ACBH */

 define structure
   1 sqlj_acbh,
       2 handle fixed bin(31),
        2 conn_type fixed bin(15);                   /* int to short */

    define alias @sqlj_acbh handle sqlj_acbh;

  %end;
 /* SQL_H_SQLJACB */
