 /*********************************************************/
 /*  CREATED BY C2PLI CONVERSION UTILITY                  */
 /*********************************************************/
 /********************************************************************/
 /*                                                                  */
 /*  PL/I Include file: SQLJRA.CPY                                   */
 /*                                                                  */
 /*    This file is installed in the \IBMPLI\INCLUDE\ directory.     */
 /*                                                                  */
 /*                                                                  */
 /*  NAME - SQLJRA.CPY                                               */
 /*                                                                  */
 /*  DESCRIPTION                                                     */
 /*                                                                  */
 /*    This include file is translated into a PL/I include file,     */
 /*    from the C header files supplied with the                     */
 /*    IBM DATABASE 2 SOFTWARE DEVELOPERS KIT/2  product.            */
 /*    This include file is intended for use with the                */
 /*    IBM DATABASE 2 SOFTWARE DEVELOPERS KIT/2 product.             */
 /*                                                                  */
 /*                                                                  */
 /*    (C) Copyright IBM Corp. 1994, 1996. All Rights Reserved.      */
 /*    US Government Users Restricted Rights-- Use, duplication or   */
 /*    disclosure restricted by GSA ADP Schedule Contract with       */
 /*    IBM Corp.                                                     */
 /*  Licensed Materials - Property of IBM                            */
 /*                                                                  */
 /*  Function =                                                      */
 /*     Include File defining:                                       */
 /*       Database Connection Services (DCS) Interface Constants     */
 /*       DCS Interface Return Codes                                 */
 /*       SQLJRA and Other Related DCS Interface Structures          */
 /*                                                                  */
 /*                                                                  */
 /*  Operating System = OS/2                                         */
 /*                                                                  */
 /*                                                                  */
 /*  DISCLAIMER OF WARRANTIES                                        */
 /*    The following enclosed code is sample code created by IBM   */
 /*    Corporation. This sample code is not part of any standard     */
 /*    IBM product and is provided to you solely for the purpose of  */
 /*    assisting you in the development of your applications.  The   */
 /*    code is provided "AS IS", without warranty of any kind.       */
 /*    IBM shall not be liable for any damages arising out of your   */
 /*    use of the sample code, even if IBM has been advised of the   */
 /*    possibility of such damages.                                  */
 /*                                                                  */
 /********************************************************************/

 %dcl SQL_H_SQLJRA char ext;
 %if SQL_H_SQLJRA = '' %then
  %do;
 /* Permit duplicate Includes      */
    %dcl SQL_H_SQLJRA char ext;
    %SQL_H_SQLJRA = 'Y';

 /* Provides char           */
    %include sqlsystm;

 /* Service type */

                                   /* Connection Services            */
    dcl SQLJ_DCSSV fixed bin(31) value(1);
                                   /* Database Services              */
    dcl SQLJ_DBSV fixed bin(31) value(2);

 /* Connection Service request types */

                                   /* Reserved (No-op)               */
    dcl SQLJR_NOOP fixed bin(31) value(0);
                                   /* Stop Database function         */
    dcl SQLJR_STOPGW fixed bin(31) value(1);
                                   /* Interrupt the request          */
    dcl SQLJR_INT fixed bin(31) value(2);
                                   /* Start Database Connection      */
    dcl SQLJR_STARTGW fixed bin(31) value(3);
                                   /* Application Remote Interface   */
    dcl SQLJR_RPC fixed bin(31) value(4);
                                   /* Reset database state           */
    dcl SQLJR_RESET fixed bin(31) value(5);
                                   /* Highest Valid Request + 1      */
    dcl SQLJR_CS_MAXOP fixed bin(31) value(6);

 /* Database Services request types */

                                 /* Precompiler/Binder Initialization*/
    dcl SQLJR_PREPINIT fixed bin(31) value(1);
                                   /* Precompiler/Binder Termination */
    dcl SQLJR_PREPFINI fixed bin(31) value(2);
                                   /* Compile                        */
    dcl SQLJR_COMPILE fixed bin(31) value(3);
                                   /* Free SQLDA                     */
    dcl SQLJR_FREEDA fixed bin(31) value(4);
                                   /* Open Cursor                    */
    dcl SQLJR_OPEN fixed bin(31) value(5);
                                   /* Fetch with Cursor              */
    dcl SQLJR_FETCH fixed bin(31) value(6);
                                   /* Close Cursor                   */
    dcl SQLJR_CLOSE fixed bin(31) value(7);
                                   /* Execute                        */
    dcl SQLJR_EXECUTE fixed bin(31) value(8);
                                   /* Prepare                        */
    dcl SQLJR_PREPARE fixed bin(31) value(9);
                                   /* Execute Immediate              */
    dcl SQLJR_EXECIMMD fixed bin(31) value(10);
                                   /* Commit                         */
    dcl SQLJR_COMMIT fixed bin(31) value(11);
                                   /* Rollback                       */
    dcl SQLJR_ROLLBACK fixed bin(31) value(12);
                                   /* Runstats                       */
    dcl SQLJR_RUNSTATS fixed bin(31) value(13);
                                   /* Reserved for Database Manager  */
                                   /*                      use only  */
    dcl SQLJR_PREREORG fixed bin(31) value(14);
                                   /* Describe                       */
    dcl SQLJR_DESCRIBE fixed bin(31) value(15);
                                   /* Request Savepoint              */
    dcl SQLJR_RQSVPT fixed bin(31) value(17);
                                   /* End Savepoint                  */
    dcl SQLJR_ENSVPT fixed bin(31) value(18);
                                   /* Rollback Savepoint             */
    dcl SQLJR_RBSVPT fixed bin(31) value(19);
                                   /* Reserved for Database Manager  */
                                   /* use only                       */
    dcl SQLJR_GETAA fixed bin(31) value(20);
                                   /* Not used                       */
    dcl SQLJR_NOT_USED fixed bin(31) value(21);
                                   /* Reserved for Database Manager  */
                                   /* use only                       */
    dcl SQLJR_REORG fixed bin(31) value(22);
                                   /* Get Table/View Authorizations  */
    dcl SQLJR_GETTA fixed bin(31) value(23);
                                   /* Compund SQL request.           */
                                   /* XA defines in here.            */
    dcl SQLJR_CMPNDSQL fixed bin(31) value(24);
                                   /* XA Recover  request.           */
    dcl SQLJR_XRECOVER fixed bin(31) value(25);
                                   /* XA Forget   request.           */
    dcl SQLJR_XFORGET fixed bin(31) value(26);
                                   /* XA Prepare  request.           */
    dcl SQLJR_XPREPARE fixed bin(31) value(27);
                                   /* XA Commit   request.           */
    dcl SQLJR_XCOMMIT fixed bin(31) value(28);
                                   /* XA Rollback request.           */
    dcl SQLJR_XROLLBACK fixed bin(31) value(29);
                                   /* XA End      request.           */
    dcl SQLJR_XEND fixed bin(31) value(30);
                                   /* XA Register request.           */
    dcl SQLJR_XREG fixed bin(31) value(31);

                                   /* Free BLOB handles (Temporary)  */
    dcl SQLJR_FREE_HANDLES fixed bin(31) value(32);

                                   /* Not Atomic Compound SQL.       */
    dcl SQLJR_CMPNDSQL_NA fixed bin(31) value(33);

                                   /* Rebind package    (Temporary)  */
    dcl SQLJR_REBIND fixed bin(31) value(34);
                                   /* Internal Describe (Temporary)  */
    dcl SQLJR_INTDESC fixed bin(31) value(35);
                                   /* Truncate table                 */
    dcl SQLJR_TRUNC_TABLE fixed bin(31) value(37);
                                   /* Highest Valid Request + 1      */
    dcl SQLJR_DS_MAXOP fixed bin(31) value(38);


 /* DCS Interface Positive Return Codes  returned to and by sqledcsr */

                                   /* Successful Execution           */
    dcl SQLJR_RCF_OK fixed bin(15) value('0000'xn);
                                   /* Commit Performed               */
    dcl SQLJR_RCF_COMMIT fixed bin(15) value('0001'xn);
                                   /* Rollback Performed             */
    dcl SQLJR_RCF_ROLLBACK fixed bin(15) value('0002'xn);
                                   /* Cursors Closed                 */
    dcl SQLJR_RCF_CLOSED fixed bin(15) value('0004'xn);
                                   /* Cursor has Hold option         */
    dcl SQLJR_RCF_HOLD fixed bin(15) value('0008'xn);
                                   /* Cursor can be blocked          */
    dcl SQLJR_RCF_BLOCK fixed bin(15) value('0010'xn);
                                   /* Cursor cannot be blocked       */
    dcl SQLJR_RCF_NOBLK fixed bin(15) value('0020'xn);
                                   /* SQLCA Modified                 */
    dcl SQLJR_RCF_SQLCA fixed bin(15) value('0040'xn);
                                   /* Cursor closed on fetch         */
    dcl SQLJR_RCF_FETCHERR fixed bin(15) value('0080'xn);
                                   /* Database Connection Terminated */
    dcl SQLJR_RCF_TERMINATE fixed bin(15) value('0100'xn);
                                   /* Security error                 */
    dcl SQLJR_RCF_SECURITY fixed bin(15) value('0200'xn);
                                   /* Forced rollback                */
    dcl SQLJR_RCF_FORCE_RLBK fixed bin(15) value('0400'xn);
                                   /* XA End                         */
    dcl SQLJR_RCF_END fixed bin(15) value('0800'xn);
                                   /* Cursor already open            */
    dcl SQLJR_RCF_OPEN fixed bin(15) value('1000'xn);

 /* Number of triplets in sqljra */

                              /* Default Connection Services         */
    dcl SQLJCSRA_DATA_ITEMS fixed bin(31) value(5);
                              /* Default Database Services           */
                              /* STARTGW_DATA_ITEMS from 5.          */
    dcl SQLJDSRA_DATA_ITEMS fixed bin(31) value(9);
                              /* Extra triplets for STARTGW          */
    dcl SQLJR_STARTGW_DATA_ITEMS fixed bin(31) value(6);
                              /* Maximum triplets for any request    */
    dcl SQLJR_MAX_DATA_ITEMS fixed bin(31) value(11);

 /* Data types */

                              /* Fixed length character string       */
    dcl SQLJ_TYP_CHAR fixed bin(31) value(1);
                              /* 4 byte unsigned short               */
    dcl SQLJ_TYP_INTEGER fixed bin(31) value(2);
                              /* 2 byte unsigned long                */
    dcl SQLJ_TYP_SMALL fixed bin(31) value(3);
                              /* Fixed length binary data            */
    dcl SQLJ_TYP_BIN fixed bin(31) value(4);
                              /* Input SQLDA                         */
    dcl SQLJ_TYP_INSQLDA fixed bin(31) value(5);
                              /* Output SQLDA                        */
    dcl SQLJ_TYP_OUTSQLDA fixed bin(31) value(6);
                              /* In SQLDA for host var description.  */
    dcl SQLJ_TYP_INHV fixed bin(31) value(7);
                              /* Out SQLDA for host var description. */
    dcl SQLJ_TYP_OUTHV fixed bin(31) value(8);
                              /* SQLCA                               */
    dcl SQLJ_TYP_SQLCA fixed bin(31) value(9);
                              /* Bind option array                   */
    dcl SQLJ_TYP_BNDOPT fixed bin(31) value(10);
                              /* Null-terminated char string.        */
    dcl SQLJ_TYP_CSTRING fixed bin(31) value(11);
                              /* DB monitor triplet.                 */
    dcl SQLJ_TYP_DBMON fixed bin(31) value(12);
                              /* X/Open XA triplet type              */
    dcl SQLJ_TYP_XACALL fixed bin(31) value(13);
                              /* Compound SQL control block          */
    dcl SQLJ_TYP_CMPNDSQL fixed bin(31) value(14);

 /* Length and count defaults */

                                   /* SQLCA                          */
    dcl SQLJ_LEN_SQLCA fixed bin(31) value(136);
                                   /* Consistency token              */
    dcl SQLJ_LEN_CTK fixed bin(31) value(8);
                                   /* Userid                         */
    dcl SQLJ_LEN_USERID fixed bin(31) value(8);
                                   /* Package name                   */
    dcl SQLJ_LEN_PGMN fixed bin(31) value(8);
                                   /* 2-Byte signed integer          */
    dcl SQLJ_LEN_SMALL fixed bin(31) value(2);
                                   /* Application or Database        */
                                   /* codepage                       */
    dcl SQLJ_LEN_CDPG fixed bin(31) value(4);
                                   /* Table name                     */
    dcl SQLJ_LEN_TBLNAM fixed bin(31) value(18);

                                   /* Len of database name.          */
    dcl SQLJ_LEN_DBNAME fixed bin(31) value(8);
                                   /* Len of database mon appid.     */
    dcl SQLJ_LEN_APPLID fixed bin(31) value(32);
                                   /* Length of prodid.              */
    dcl SQLJ_LEN_PRODID fixed bin(31) value(8);
                                   /* Length of prog name.           */
    dcl SQLJ_LEN_PRNAME fixed bin(31) value(20);

                                   /* DRDA-1 database name           */
    dcl SQLJ_LEN_DRDADBNAME fixed bin(31) value(18);
                                   /* User password                  */
    dcl SQLJ_LEN_PSWD fixed bin(31) value(18);
                                   /* Node name                      */
    dcl SQLJ_LEN_NODE fixed bin(31) value(8);
                                   /* Bind option array count        */
    dcl SQLJ_BNDOPT_CNT fixed bin(31) value(6);
                                   /* Indicator array count          */
    dcl SQLJ_INDICATOR_ARRAY_SIZE fixed bin(31) value(8);

                                   /* SQLJRA version number          */
    dcl SQLJ_RELNO fixed bin(15) value('0101'xn);
                                   /* SQLJRA title                   */
    dcl SQLJRA_TTL char value("SQLJRA  ");

 /********************************************************************/
 /* Indicator array offset defintions                                */
 /********************************************************************/


                                   /* Offset for Connection type     */
    dcl SQLJ_CONN_OFF fixed bin(31) value(0);
                                   /* Offset for database use        */
    dcl SQLJ_USE_OFF fixed bin(31) value(1);
                                   /* Security authentication type   */
    dcl SQLJ_AUTH_OFF fixed bin(31) value(2);
                                   /* Authentication source          */
    dcl SQLJ_UNAME_FROM_OFF fixed bin(31) value(3);

 /* SQLJ_CONN_OFF values */
                                   /* Connection operation           */
    dcl SQLJ_CONNECT fixed bin(31) value(1);
                                   /* Migrate operation              */
    dcl SQLJ_MIGRATE fixed bin(31) value(2);
                                   /* Restore database               */
    dcl SQLJ_RESTORE fixed bin(31) value(3);
                                   /* Restart/recover database       */
    dcl SQLJ_RESTART fixed bin(31) value(4);
                                   /* Backup database                */
    dcl SQLJ_BACKUP fixed bin(31) value(5);
                                   /* Recover database               */
    dcl SQLJ_RECOVER fixed bin(31) value(6);

 /* SQLJ_USE_OFF values */
                                   /* Shared use connection          */
    dcl SQLJ_USE_SHR char value('S');
                                   /* Exclusive use connection       */
    dcl SQLJ_USE_EXC char value('X');



                                   /* Offset for standards option    */
    dcl SQLJ_STND_OFF fixed bin(31) value(0);

 /* SQLJ_STND_OFF values */
                                   /* No compliance required         */
    dcl SQLJ_STND_NONE char value('0');
                                   /* MIA compliance required        */
    dcl SQLJ_STND_MIA char value('1');
                                   /* SQL 89 compliance required     */
    dcl SQLJ_STND_SQL89 char value('2');


                                   /* Offset for hold option         */
    dcl SQLJ_CMMT_OFF fixed bin(31) value(1);
                                   /* DTP state offset.              */
    dcl SQLJ_CMMT_DTP_OFF fixed bin(31) value(2);
                                   /* Sync/Async offset              */
    dcl SQLJ_CMMT_SNDRCV_OFF fixed bin(31) value(3);

 /* SQLJ_CMMT_OFF values  */
                                   /* Commit                         */
    dcl SQLJ_CMMT_NOHOLD fixed bin(31) value(0);
                                   /* Commit hold                    */
    dcl SQLJ_CMMT_HOLD fixed bin(31) value(1);

 /* ROLLBACK FLAG values        */
    dcl SQLJ_ROLL_SNDRCV_OFF fixed bin(31) value(0);
 /* Indicator for send or receive  */

 /* SQLJ_ROLL_SNDRCV_OFF values are the same as SQLJ_CMMT_SNDRCV_OFF */

                                   /* Offset for Statement type      */
    dcl SQLJ_DCSR_OFF fixed bin(31) value(1);
                                   /* Offset for Cursor Hold option  */
    dcl SQLJ_CSRH_OFF fixed bin(31) value(2);
                                   /* Offset for Shallow Grammar     */
    dcl SQLJ_SG_OFF fixed bin(31) value(3);
                                   /* DTP state offset.              */
    dcl SQLJ_COMP_DTP_OFF fixed bin(31) value(4);

 /* SQLJ_DCSR_OFF values */
                                   /* Statement is not Declare Cursor*/
    dcl SQLJ_STMT_NDCLR fixed bin(31) value(0);
                                   /* Statement is Declare Cursor    */
    dcl SQLJ_STMT_DCLR fixed bin(31) value(1);

 /* SQLJ_CSRH_OFF values  */
                                   /* Cursor not declared with Hold  */
    dcl SQLJ_CSR_NOHOLD fixed bin(31) value(0);
                                   /* Cursor declared with Hold      */
    dcl SQLJ_CSR_HOLD fixed bin(31) value(1);

 /* SQLJ_SG_OFF values    */
                              /* Statement recognized by precompiler */
    dcl SQLJ_STMT_VALID fixed bin(31) value(0);
                          /* Statement not recognized by precompiler */
    dcl SQLJ_STMT_UNKNOWN fixed bin(31) value(1);


                                   /* Offset for output SQLDA option */
    dcl SQLJ_EXEC_OFF fixed bin(31) value(1);
                                   /* DTP state offset.              */
    dcl SQLJ_EXEC_DTP_OFF fixed bin(31) value(2);

 /* SQLJ_EXEC_OFF and SQLJ_CSRDA_OFF values */
                                   /* Do not return output SQLDA     */
    dcl SQLJ_NO_OUTSQLDA fixed bin(31) value(0);
                                   /* Return output SQLDA            */
    dcl SQLJ_OUTSQLDA fixed bin(31) value(1);


                                   /* Offset for SQLDA option        */
    dcl SQLJ_CSRDA_OFF fixed bin(31) value(1);
                                   /* Offset for READ/UPDATE option  */
    dcl SQLJ_CSRRW_OFF fixed bin(31) value(2);
                                   /* Offset for blocking flag.      */
    dcl SQLJ_BLKREQ_OFF fixed bin(31) value(3);
                                   /* DTP state offset.              */
    dcl SQLJ_OPEN_DTP_OFF fixed bin(31) value(4);

 /* SQLJ_CSRRW_OFF values                   */
                                   /* Output SQLDA for read-only     */
    dcl SQLJ_READ fixed bin(31) value(0);
                                   /* Output SQLDA will be modified  */
    dcl SQLJ_UPDATE fixed bin(31) value(1);

 /* SQLJ_BLKREQ_OFF values                  */
                                   /* Ask for no blocking            */
    dcl SQLJ_NO_BLOCK fixed bin(31) value(0);
                                   /* Ask for blocking               */
    dcl SQLJ_BLOCK fixed bin(31) value(1);


                                   /* Offset for Commit/Rollback     */
    dcl SQLJ_PFINI_OFF fixed bin(31) value(0);
                                   /* DTP state offset.              */
    dcl SQLJ_PFINI_DTP_OFF fixed bin(31) value(1);

 /* SQLJ_PFINI_OFF values                   */
                                   /* Commit package                 */
    dcl SQLJ_COMMIT fixed bin(31) value(1);
                                   /* Rollback package               */
    dcl SQLJ_ROLLBACK fixed bin(31) value(0);


                                   /* Offset for Statistics option   */
    dcl SQLJ_STATS_OFF fixed bin(31) value(1);
                                   /* Offset for Share level         */
    dcl SQLJ_SHRLV_OFF fixed bin(31) value(2);
                                   /* DTP state offset.              */
    dcl SQLJ_RUNST_DTP_OFF fixed bin(31) value(3);

 /* SQLJ_STATS_OFF values are defined in sqlutil.h  */

 /* SQLJ_SHRLV_OFF values  are defined in sqlutil.h */


 /* sqlrtype = all SQLJ_DBSV sqlrtypes EXCEPT the following ...   */
 /*            SQLJR_COMMIT                                       */
 /*            SQLJR_COMPILE                                      */
 /*            SQLJR_EXECUTE                                      */
 /*            SQLJR_OPEN                                         */
 /*            SQLJR_PREPFINI                                     */
 /*            SQLJR_RUNSTATS                                     */
 /*                          - sqlrflag[SQLJ_DTP_OFF]             */

                                               /* DTP state offset.  */
    dcl SQLJ_DTP_OFF fixed bin(31) value(1);

 /* SQLJ_DTP_OFF       values are defined in sqlra.h as the       */
 /*                    SQLR_XA_CONNECT values.                    */


 /********************************************************************/
 /* Triplet defintions                                               */
 /********************************************************************/

 /* sqlrtype = SQLJR_STARTGW                                         */

                                   /*  user password                 */
    dcl SQLJ_UPW_OFF fixed bin(31) value(0);
                                   /*  application code page         */
    dcl SQLJ_ACP_OFF fixed bin(31) value(1);
                                   /*  application node name         */
    dcl SQLJ_ANN_OFF fixed bin(31) value(2);
                                   /*  application name              */
    dcl SQLJ_APN_OFF fixed bin(31) value(3);
                                   /*  database password             */
    dcl SQLJ_DPW_OFF fixed bin(31) value(4);
                                   /*  database monitor              */
    dcl SQLJ_MON_OFF fixed bin(31) value(5);
                                   /*  DCE Ticket                    */
    dcl SQLJ_DCE_OFF fixed bin(31) value(6);
                                   /*  User-supplied DDCS accounting */
                                   /*  string component.             */
    dcl SQLJ_ACC_OFF fixed bin(31) value(7);


 /* sqlrtype = SQLJR_RPC                                             */

                                   /*  procedure return code         */
    dcl SQLJ_PRC_OFF fixed bin(31) value(0);
                                   /*  remote procedure name         */
    dcl SQLJ_RPN_OFF fixed bin(31) value(1);
                                   /*  input data area               */
    dcl SQLJ_DAT_OFF fixed bin(31) value(2);
                                   /*  input sqlda                   */
    dcl SQLJ_IDA_OFF fixed bin(31) value(2);
                                   /*  output sqlda                  */
    dcl SQLJ_ODA_OFF fixed bin(31) value(3);


 /* sqlrtype = SQLJR_COMPILE                                         */

                                   /*  statement number              */
    dcl SQLJ_STN_OFF fixed bin(31) value(0);
                                   /*  statement text                */
    dcl SQLJ_STT_OFF fixed bin(31) value(1);
                                   /*  cursor name                   */
    dcl SQLJ_CRN_OFF fixed bin(31) value(2);
                                   /*  select string                 */
    dcl SQLJ_SEL_OFF fixed bin(31) value(3);


 /* sqlrtype =  SQLJR_EXECIMMD                                       */
 /*              SQLJR_PREPARE                                       */
 /*              SQLJR_REORG                                         */
 /*                                                                  */

                                   /*  statement text                */
    dcl SQLJ_TXT_OFF fixed bin(31) value(0);
                                   /*  alternate path                */
    dcl SQLJ_ALP_OFF fixed bin(31) value(1);


 /* sqlrtype = SQLJR_GETTA                                           */
 /*             SQLJR_RUNSTATS                                       */

                                   /*  table name                    */
    dcl SQLJ_TNM_OFF fixed bin(31) value(0);
                                   /*  index list                    */
    dcl SQLJ_INX_OFF fixed bin(31) value(1);

 /* sqlrtype = SQLJR_TRUNC_TABLE                                     */

                                   /*  table name                    */
    dcl SQLJ_TBN_OFF fixed bin(31) value(0);
                                   /*  index list                    */
    dcl SQLJ_SCH_OFF fixed bin(31) value(1);


 /* sqlrtype = SQLJR_PREPINIT                                        */

                                   /*  bind option array             */
    dcl SQLJ_BOA_OFF fixed bin(31) value(0);
                                   /*  New bind option array         */
    dcl SQLJ_BIND_OFF fixed bin(31) value(1);


 /* sqlrtype = SQLJR_CMPNDSQL                                        */

                                               /* cmpd SQL control   */
    dcl SQLJ_CMPND_OFF fixed bin(31) value(0);


 /* sqlrtype = SQLJR_XA_RECOVER                                      */
 /*             SQLJR_XA_PREPARE                                     */
 /*             SQLJR_XA_FORGET                                      */
 /*             SQLJR_XA_COMMIT                                      */
 /*             SQLJR_XA_ROLLBACK                                    */
 /*             SQLJR_XA_END                                         */

                                  /* XA Call Info struct             */
    dcl SQLJ_XACALL_OFF fixed bin(31) value(0);

 /********************************************************************/
 /* Bind Option codepoints                                           */
 /* These are the DDM codepoints which correspond to the all the bind*/
 /* options which may be specified with the Database Connection      */
 /* Services Programming  Interface.                                 */
 /********************************************************************/

                                  /* A brief description             */
    dcl SQLJ_BO_TITLE fixed bin(15) value('0045'xn);
                                  /* Version name                    */
    dcl SQLJ_BO_VRSNAM fixed bin(15) value('1144'xn);
                                  /* Package default CCSIDs of col   */
    dcl SQLJ_BO_PKGDFTCC fixed bin(15) value('119A'xn);
                                  /* CCSID for single-byte chars     */
    dcl SQLJ_BO_CCSIDSBC fixed bin(15) value('119C'xn);
                                  /* CCSID for double-byte chars     */
    dcl SQLJ_BO_CCSIDDBC fixed bin(15) value('119D'xn);
                                  /* CCSID for mixed-byte chars      */
    dcl SQLJ_BO_CCSIDMBC fixed bin(15) value('119E'xn);
                                  /* Decimal precision               */
    dcl SQLJ_BO_DECPRC fixed bin(15) value('2106'xn);
                                  /* RDB package consistency token   */
    dcl SQLJ_BO_PKGCNSTKN fixed bin(15) value('210D'xn);
                                  /* Bind existence checking         */
    dcl SQLJ_BO_BNDCHKEXS fixed bin(15) value('211B'xn);
                                  /* Bind package replacement option */
    dcl SQLJ_BO_PKGRPLOPT fixed bin(15) value('211C'xn);
                                  /* Bind create package option      */
    dcl SQLJ_BO_BNDCRTCTL fixed bin(15) value('211D'xn);
                                  /* Bind package authorization      */
    dcl SQLJ_BO_PKGATHOPT fixed bin(15) value('211E'xn);
                                  /* Bind statement string delimiter */
    dcl SQLJ_BO_STTSTRDEL fixed bin(15) value('2120'xn);
                                  /* Bind statement decimal delimiter*/
    dcl SQLJ_BO_STTDECDEL fixed bin(15) value('2121'xn);
                                  /* Bind date format option         */
    dcl SQLJ_BO_STTDATFMT fixed bin(15) value('2122'xn);
                                  /* Bind time format option         */
    dcl SQLJ_BO_STTTIMFMT fixed bin(15) value('2123'xn);
                                  /* Isolation level                 */
    dcl SQLJ_BO_PKGISOLVL fixed bin(15) value('2124'xn);
                                  /* Package default char subtype    */
    dcl SQLJ_BO_PKGDFTCST fixed bin(15) value('2125'xn);
                                  /* Default RDB collection id       */
    dcl SQLJ_BO_DFTRDBCOL fixed bin(15) value('2128'xn);
                                  /* RDB release option              */
    dcl SQLJ_BO_RDBRLSOPT fixed bin(15) value('2129'xn);
                                  /* Replaced package version name   */
    dcl SQLJ_BO_PKGRPLVRS fixed bin(15) value('212D'xn);
                                  /* Degree of I/O parallelism       */
    dcl SQLJ_BO_DGRIOPRL fixed bin(15) value('212F'xn);
                                  /* Bind explain option             */
    dcl SQLJ_BO_BNDEXPOPT fixed bin(15) value('2130'xn);
                                  /* Package owner id                */
    dcl SQLJ_BO_PKGOWNID fixed bin(15) value('2131'xn);
                                  /* Query block protocol            */
    dcl SQLJ_BO_QRYBLKCTL fixed bin(15) value('2132'xn);
                                  /* Package authorization rules     */
    dcl SQLJ_BO_PKGATHRUL fixed bin(15) value('213F'xn);

 /*   Database Manager internal values  */
                                  /* Standards compliance option     */
    dcl SQLJ_BO_STANDARD fixed bin(31) value('F901'xn);

 /********************************************************************/
 /* Bind Option values                                               */
 /* These are the DDM codepoints which correspond to the values for  */
 /* the  bind  options which may be specified with the Database      */
 /* Connection Services Programming Interface.                       */
 /********************************************************************/


                                  /* Force single row query          */
    dcl SQLJ_BO_FRCSNGROW fixed bin(15) value('2410'xn);
                                  /* Limited block query             */
    dcl SQLJ_BO_LMTBLCK fixed bin(15) value('2417'xn);
                                  /* Single row query                */
    dcl SQLJ_BO_SNGROW fixed bin(15) value('2418'xn);
                                  /* Bind object existence required  */
    dcl SQLJ_BO_BNDEXSRQR fixed bin(15) value('241C'xn);
                                  /* Bind object existence optional  */
    dcl SQLJ_BO_BNDEXSOPT fixed bin(15) value('241D'xn);
                                  /* Package auth. rule owner        */
    dcl SQLJ_BO_PKGATHRUL_OWN fixed bin(15) value('0001'xn);
                                  /* Package auth. rule requester    */
    dcl SQLJ_BO_PKGATHRUL_REQ fixed bin(15) value('0000'xn);
                                  /* Package replacement allowed     */
    dcl SQLJ_BO_PKGRPLALW fixed bin(15) value('241F'xn);
                                  /* Package replacement not allowed */
    dcl SQLJ_BO_PKGRPLNA fixed bin(15) value('2420'xn);
                                  /* Syntax Check only               */
    dcl SQLJ_BO_BNDCHKONL fixed bin(15) value('2421'xn);
                                  /* Create package if no errors     */
    dcl SQLJ_BO_BNDNERALW fixed bin(15) value('2422'xn);
                                  /* Create Package even if errors   */
    dcl SQLJ_BO_BNDERRALW fixed bin(15) value('2423'xn);
 %dcl SQLJ_BO_BNDCHK char ext;
 %SQLJ_BO_BNDCHK='SQLJ_BO_BNDCHKONL';
    %dcl @SQLJ_BO_BNDCHK char ext;
    %@SQLJ_BO_BNDCHK='@SQLJ_BO_BNDCHKONL';
 %dcl SQLJ_BO_BNDCRT char ext;
 %SQLJ_BO_BNDCRT='SQLJ_BO_BNDNERALW';
    %dcl @SQLJ_BO_BNDCRT char ext;
    %@SQLJ_BO_BNDCRT='@SQLJ_BO_BNDNERALW';
 %dcl SQLJ_BO_BNDERR char ext;
 %SQLJ_BO_BNDERR='SQLJ_BO_BNDERRALW';
    %dcl @SQLJ_BO_BNDERR char ext;
    %@SQLJ_BO_BNDERR='@SQLJ_BO_BNDERRALW';
                                  /* Package authorizations revoked  */
    dcl SQLJ_BO_PKGATHRVK fixed bin(15) value('2424'xn);
                                  /* Package authorizations keep     */
    dcl SQLJ_BO_PKGATHKP fixed bin(15) value('2425'xn);
                                  /* String delimeter apostrophe     */
    dcl SQLJ_BO_STRDELAP fixed bin(15) value('2426'xn);
                                  /* String delimeter double quote   */
    dcl SQLJ_BO_STRDELDQ fixed bin(15) value('2427'xn);
                                  /* ISO date format                 */
    dcl SQLJ_BO_ISOFMT fixed bin(15) value('2429'xn);
                                  /* USA date format                 */
    dcl SQLJ_BO_USAFMT fixed bin(15) value('242A'xn);
                                  /* European date format            */
    dcl SQLJ_BO_EURFMT fixed bin(15) value('242B'xn);
                                  /* Japanese date format            */
    dcl SQLJ_BO_JAPANFMT fixed bin(15) value('242C'xn);
                                  /* ISO time format                 */
    dcl SQLJ_BO_ISOTIMFMT fixed bin(15) value('242E'xn);
                                  /* USA time format                 */
    dcl SQLJ_BO_USATIMFMT fixed bin(15) value('242F'xn);
                                  /* European time format            */
    dcl SQLJ_BO_EURTIMFMT fixed bin(15) value('2430'xn);
                                  /* Japanese time format            */
    dcl SQLJ_BO_JISTIMFMT fixed bin(15) value('2431'xn);
                                  /* Character subtype system default*/
    dcl SQLJ_BO_CSTSYSDFT fixed bin(15) value('2432'xn);
                                  /* Character subtype bits          */
    dcl SQLJ_BO_CSTBITS fixed bin(15) value('2433'xn);
                                  /* Character subtype SBCS          */
    dcl SQLJ_BO_CSTSBCS fixed bin(15) value('2434'xn);
                                  /* Character subtype MBCS          */
    dcl SQLJ_BO_CSTMBCS fixed bin(15) value('2435'xn);
                                  /* RDB release at commit           */
    dcl SQLJ_BO_RDBRLSCMM fixed bin(15) value('2438'xn);
                                  /* RDB release at conversation     */
                                  /* deallocation                    */
    dcl SQLJ_BO_RDBRLSCNV fixed bin(15) value('2439'xn);
                                  /* Explain no SQL statements       */
    dcl SQLJ_BO_EXPNON fixed bin(15) value('243A'xn);
                                  /* Explain all explainable SQL     */
                                  /* statements.                     */
    dcl SQLJ_BO_EXPALL fixed bin(15) value('243B'xn);
                                  /* Decimal delimeter is period     */
    dcl SQLJ_BO_DECDELPRD fixed bin(15) value('243C'xn);
                                  /* Decimal delimeter is comma      */
    dcl SQLJ_BO_DECDELCMA fixed bin(15) value('243D'xn);
                                  /* Isolation lvl = change          */
    dcl SQLJ_BO_ISOLVLCHG fixed bin(15) value('2441'xn);
                                  /* Isolation lvl = cursor stability*/
    dcl SQLJ_BO_ISOLVLCS fixed bin(15) value('2442'xn);
                                  /* Isolation lvl = all             */
    dcl SQLJ_BO_ISOLVLALL fixed bin(15) value('2443'xn);
                                  /* Isolation lvl = repeatable read */
    dcl SQLJ_BO_ISOLVLRR fixed bin(15) value('2444'xn);
                                  /* Isolation lvl = no check        */
    dcl SQLJ_BO_ISOLVLNC fixed bin(15) value('2445'xn);



 /*   Database Manager internal values */
                                  /* SQL 89 standards compliance     */
    dcl SQLJ_BO_STDSQL89 fixed bin(31) value('F902'xn);
                                  /* MIA standards compliance        */
    dcl SQLJ_BO_STDMIA fixed bin(31) value('F903'xn);
                                  /* No standards compliance required*/
    dcl SQLJ_BO_STDNONE fixed bin(31) value('F904'xn);
                                  /* Default country date format     */
    dcl SQLJ_BO_DEFFMT fixed bin(31) value('F905'xn);
                                  /* Default country time format     */
    dcl SQLJ_BO_DEFTIMFMT fixed bin(31) value('F907'xn);
                                  /* Local country date format       */
    dcl SQLJ_BO_LOCAL fixed bin(31) value('F906'xn);
                                  /* Local country time format       */
    dcl SQLJ_BO_LOCALTIM fixed bin(31) value('F906'xn);
                                  /* Buffered insert                 */
    dcl SQLJ_BO_INSERT fixed bin(31) value('F908'xn);
                                  /* No buffering of inserts         */
    dcl SQLJ_BO_INSDEF fixed bin(31) value('F909'xn);
                                  /* Buffering of inserts            */
    dcl SQLJ_BO_INSBUF fixed bin(31) value('F90A'xn);

 /********************************************************************/
 /* Structure Definitions                                            */
 /********************************************************************/

 /* Database Monitor and NLS - Start Using Triplet structure         */
 define structure
    1 dummy#1,                    /* Buffering of inserts            */
        2 country unsigned fixed bin(16) ,           /* For NLS use. */
       2 comheap_size unsigned fixed bin(16) ,
       2 appl_id char(SQLJ_LEN_APPLID+1) ,
       2 dbalias char(SQLJ_LEN_DBNAME+1) ,
       2 client_prod_id char(SQLJ_LEN_PRODID+1) ,
       2 prog_name char(SQLJ_LEN_PRNAME+1) ,
       2 client_platform unsigned fixed bin(31) ;

    define alias @dummy#1 handle dummy#1;
    define alias SQLJ_DBMON_TRIPLET type dummy#1;
    define alias @SQLJ_DBMON_TRIPLET type @dummy#1;


 /* Bind Option Array Element                                        */
 define structure
   1 sqljra_bindopts,
       2 length unsigned fixed bin(16) ,
       2 option unsigned fixed bin(16) ,
       2 value unsigned fixed bin(16) ;


 /* New Bind Options Array Element                                   */
 define structure
 1 sqljra_bind_options# union,
       2 value unsigned fixed bin(16) ,
       2 valopt char(1) ;

 define structure
   1 sqljra_bind_options,
       2 length unsigned fixed bin(16) ,
       2 option unsigned fixed bin(16) ,
       2 user_defined unsigned fixed bin(16) ,
       2 bind_data type sqljra_bind_options#;


 /* SQLJRA Triplet element                                           */
 define structure
   1 dummy#2,
       2 sqlrdtl unsigned fixed bin(31) ,
       2 sqlrdtt unsigned fixed bin(31) ,
       2 sqlrdtp pointer;

    define alias @dummy#2 handle dummy#2;
    define alias SQLJDATA type dummy#2;
    define alias @SQLJDATA type @dummy#2;

 /* SQLJRA */

 define structure
 1 sqljra,
    2 sqlraid char(8) ,                 /* Eye catcher = 'SQLJRA ' */
    2 sqlrabc unsigned fixed bin(31) ,              /* Size in bytes */
    2 sqlrelno unsigned fixed bin(16) ,            /* Version number */
    2 sqltype unsigned fixed bin(16) ,               /* Service type */
    2 sqlrtype unsigned fixed bin(16) ,              /* Request type */
    2 sqlrdnum unsigned fixed bin(16) ,        /* Number of triplets */
   /* SQLCA */
    2 sqlrcal unsigned fixed bin(31) ,             /*Length of SQLCA */
    2 sqlrcat unsigned fixed bin(31) ,         /* Data type of SQLCA */
    2 sqlrcap pointer,                           /* Pointer to SQLCA */
   /* Input SQLDA */
    2 sqlrdail unsigned fixed bin(31) ,     /* Length of input SQLDA */
   /* Data type of input SQLDA */
   2 sqlrdait unsigned fixed bin(31) ,
    2 sqlrdapi handle sqlda,               /* Pointer to input SQLDA */
   /* Output SQLDA */
    2 sqlrdaol unsigned fixed bin(31) ,    /* Length of output SQLDA */
                                        /* Data type of output SQLDA */
    2 sqlrdaot unsigned fixed bin(31) ,
    2 sqlrdapo handle sqlda,              /* Pointer to output SQLDA */
   /* Indicator array */
    2 sqlrflgl unsigned fixed bin(31) , /* Length of indicator array */
                                     /* Data type of indicator array */
    2 sqlrflgt unsigned fixed bin(31) ,
    2 sqlrflag pointer,                /* Pointer to indicator array */
   /* Userid */
    2 sqlrusrl unsigned fixed bin(31) ,          /* Length of userid */
    2 sqlrusrt unsigned fixed bin(31) ,       /* Data type of userid */
    2 sqlruser pointer,                         /* Pointer to userid */
   /* Database name */
    2 sqlrdbnl unsigned fixed bin(31) ,   /* Length of database name */
    2 sqlrdbnt unsigned fixed bin(31) ,      /* Data type of db name */
    2 sqlrdbnm pointer,                  /* Pointer to database name */
   /* Package creator */
    2 sqlrcrel unsigned fixed bin(31) ,     /* Length of pkg creator */
                                     /* Data type of package creator */
   2 sqlrcret unsigned fixed bin(31) ,
    2 sqlrcrea pointer,                /* Pointer to package creator */
   /* Section Number */
    2 sqlrsctl unsigned fixed bin(31) ,      /* Length of sec number */
                                      /* Data type of section number */
   2 sqlrsctt unsigned fixed bin(31) ,
    2 sqlrsect pointer,                 /* Pointer to section number */
   /* Package Name */
    2 sqlrpgml unsigned fixed bin(31) ,        /* Length of pkg name */
    2 sqlrpgmt unsigned fixed bin(31) ,     /* Data type of pkg name */
    2 sqlrpgmn pointer,                   /* Pointer to package name */
   /* Consistency token */
                                     /* Length of consistency token */
   2 sqlrctkl unsigned fixed bin(31) ,
                                   /* Data type of consistency token*/
   2 sqlrctkt unsigned fixed bin(31) ,
    2 sqlrctkp pointer,              /* Pointer to consistency token */
   /* Data triplets */
   2 sqlrdata dim(0:SQLJR_MAX_DATA_ITEMS-1) type SQLJDATA;

    define alias @sqljra handle sqljra;

                                      /* Connection Services  SQLJRA */
 %dcl SQLJCSRA char ext;
 %SQLJCSRA='SQLJRA';
    %dcl @SQLJCSRA char ext;
    %@SQLJCSRA='@SQLJRA';
                                         /* Database Services SQLJRA */
 %dcl SQLJDSRA char ext;
 %SQLJDSRA='SQLJRA';
    %dcl @SQLJDSRA char ext;
    %@SQLJDSRA='@SQLJRA';
                                            /* SQLJRA size           */
 %dcl SQLJ_LEN_SQLJRA char ext;
 %SQLJ_LEN_SQLJRA='SQLJRA';
    %dcl @SQLJ_LEN_SQLJRA char ext;
    %@SQLJ_LEN_SQLJRA='@SQLJRA';
                                            /* SQLJCSRA size         */
 %dcl SQLJ_LEN_SQLJCSRA char ext;
 %SQLJ_LEN_SQLJCSRA='SQLJRA';
    %dcl @SQLJ_LEN_SQLJCSRA char ext;
    %@SQLJ_LEN_SQLJCSRA='@SQLJRA';
                                            /* SQLJDSRA size         */
 %dcl SQLJ_LEN_SQLJDSRA char ext;
 %SQLJ_LEN_SQLJDSRA='SQLJRA';
    %dcl @SQLJ_LEN_SQLJDSRA char ext;
    %@SQLJ_LEN_SQLJDSRA='@SQLJRA';

  %end;
 /* SQL_H_SQLJRA */
